/* Integration.c generated by valac 0.45.3, the Vala compiler
 * generated from Integration.vala, do not modify */

/*-
 * Copyright 2013-2018 elementary LLC. (https://elementary.io)
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.

 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Authored by: Corentin Noël <corentin@elementary.io>
 */

#include <gio/gio.h>
#include <glib-object.h>
#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include <libaccounts-glib/accounts-glib.h>
#include <libsignon-glib/signon-glib.h>
#include <rest/oauth2-proxy.h>
#include <rest/rest-proxy-call.h>
#include <rest/rest-proxy.h>
#include <json-glib/json-glib.h>

#define TYPE_INTEGRATION_APPLICATION (integration_application_get_type ())
#define INTEGRATION_APPLICATION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_INTEGRATION_APPLICATION, IntegrationApplication))
#define INTEGRATION_APPLICATION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_INTEGRATION_APPLICATION, IntegrationApplicationClass))
#define IS_INTEGRATION_APPLICATION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_INTEGRATION_APPLICATION))
#define IS_INTEGRATION_APPLICATION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_INTEGRATION_APPLICATION))
#define INTEGRATION_APPLICATION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_INTEGRATION_APPLICATION, IntegrationApplicationClass))

typedef struct _IntegrationApplication IntegrationApplication;
typedef struct _IntegrationApplicationClass IntegrationApplicationClass;
typedef struct _IntegrationApplicationPrivate IntegrationApplicationPrivate;
enum  {
	INTEGRATION_APPLICATION_0_PROPERTY,
	INTEGRATION_APPLICATION_NUM_PROPERTIES
};
static GParamSpec* integration_application_properties[INTEGRATION_APPLICATION_NUM_PROPERTIES];
#define _g_option_context_free0(var) ((var == NULL) ? NULL : (var = (g_option_context_free (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
typedef struct _IntegrationApplicationApiInfos IntegrationApplicationApiInfos;
typedef struct _Block1Data Block1Data;
#define _g_main_loop_unref0(var) ((var == NULL) ? NULL : (var = (g_main_loop_unref (var), NULL)))
#define _g_variant_unref0(var) ((var == NULL) ? NULL : (var = (g_variant_unref (var), NULL)))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define __vala_AgAuthData_free0(var) ((var == NULL) ? NULL : (var = (_vala_AgAuthData_free (var), NULL)))
#define _integration_application_api_infos_free0(var) ((var == NULL) ? NULL : (var = (integration_application_api_infos_free (var), NULL)))
#define _json_object_unref0(var) ((var == NULL) ? NULL : (var = (json_object_unref (var), NULL)))

struct _IntegrationApplication {
	GApplication parent_instance;
	IntegrationApplicationPrivate * priv;
};

struct _IntegrationApplicationClass {
	GApplicationClass parent_class;
};

struct _Block1Data {
	int _ref_count_;
	IntegrationApplication* self;
	SignonAuthSession* auth_session;
	GVariant* session_result;
	GMainLoop* main_loop;
};

struct _IntegrationApplicationApiInfos {
	gchar* access_token;
	gchar* client_id;
	gchar* redirect_uri;
	AgAccountService* account_service;
};

static gpointer integration_application_parent_class = NULL;
static guint integration_application_account_id;
static guint integration_application_account_id = (guint) 0;
static gchar* integration_application_method;
static gchar* integration_application_method = NULL;

GType integration_application_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (IntegrationApplication, g_object_unref)
static IntegrationApplication* integration_application_new (void);
static IntegrationApplication* integration_application_construct (GType object_type);
static gint integration_application_real_command_line (GApplication* base,
                                                GApplicationCommandLine* command_line);
gboolean integration_application_get_user_name (IntegrationApplication* self,
                                                guint account_id);
gboolean integration_application_get_user_image (IntegrationApplication* self,
                                                 guint account_id);
void integration_application_api_infos_free (IntegrationApplicationApiInfos * self);
G_DEFINE_AUTOPTR_CLEANUP_FUNC (IntegrationApplicationApiInfos, integration_application_api_infos_free)
IntegrationApplicationApiInfos* integration_application_get_token (IntegrationApplication* self,
                                                                   guint account_id);
IntegrationApplicationApiInfos* integration_application_api_infos_new (void);
static Block1Data* block1_data_ref (Block1Data* _data1_);
static void block1_data_unref (void * _userdata_);
static void _vala_AgAuthData_free (AgAuthData* self);
static void ___lambda4_ (Block1Data* _data1_,
                  GObject* obj,
                  GAsyncResult* res);
static void ____lambda4__gasync_ready_callback (GObject* source_object,
                                         GAsyncResult* res,
                                         gpointer self);
gint integration_application_main (gchar** args,
                                   gint args_length1);
static void integration_application_api_infos_instance_init (IntegrationApplicationApiInfos * self);
static void integration_application_finalize (GObject * obj);
static void _vala_array_destroy (gpointer array,
                          gint array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gint array_length,
                       GDestroyNotify destroy_func);

static const GOptionEntry INTEGRATION_APPLICATION_options[3] = {{"account-id", 'a', 0, G_OPTION_ARG_INT, &integration_application_account_id, "Specify the account id", "ID"}, {"method", (gchar) 0, 0, G_OPTION_ARG_STRING, &integration_application_method, "The action to do", "NAME"}, {NULL}};

static IntegrationApplication*
integration_application_construct (GType object_type)
{
	IntegrationApplication * self = NULL;
#line 22 "../providers/Microsoft/Integration.vala"
	self = (IntegrationApplication*) g_object_new (object_type, "flags", G_APPLICATION_HANDLES_COMMAND_LINE, NULL);
#line 21 "../providers/Microsoft/Integration.vala"
	return self;
#line 138 "Integration.c"
}

static IntegrationApplication*
integration_application_new (void)
{
#line 21 "../providers/Microsoft/Integration.vala"
	return integration_application_construct (TYPE_INTEGRATION_APPLICATION);
#line 146 "Integration.c"
}

static gint
integration_application_real_command_line (GApplication* base,
                                           GApplicationCommandLine* command_line)
{
	IntegrationApplication * self;
	gint result = 0;
	gchar** args = NULL;
	gint _tmp0_ = 0;
	gchar** _tmp1_;
	gint args_length1;
	gint _args_size_;
	const gchar* _tmp13_;
	gboolean finished = FALSE;
	const gchar* _tmp14_;
	const gchar* _tmp15_;
	GQuark _tmp17_ = 0U;
#line 59 "../providers/Microsoft/Integration.vala"
	static GQuark _tmp16_label0 = 0;
#line 59 "../providers/Microsoft/Integration.vala"
	static GQuark _tmp16_label1 = 0;
#line 169 "Integration.c"
	GError* _inner_error0_ = NULL;
#line 33 "../providers/Microsoft/Integration.vala"
	self = (IntegrationApplication*) base;
#line 33 "../providers/Microsoft/Integration.vala"
	g_return_val_if_fail (command_line != NULL, 0);
#line 34 "../providers/Microsoft/Integration.vala"
	_tmp1_ = g_application_command_line_get_arguments (command_line, &_tmp0_);
#line 34 "../providers/Microsoft/Integration.vala"
	args = _tmp1_;
#line 34 "../providers/Microsoft/Integration.vala"
	args_length1 = _tmp0_;
#line 34 "../providers/Microsoft/Integration.vala"
	_args_size_ = args_length1;
#line 183 "Integration.c"
	{
		GOptionContext* opt_context = NULL;
		GOptionContext* _tmp2_;
		GOptionContext* _tmp3_;
		GOptionContext* _tmp4_;
		GOptionContext* _tmp5_;
		GOptionContext* _tmp6_;
#line 36 "../providers/Microsoft/Integration.vala"
		_tmp2_ = g_option_context_new ("- Google Integration");
#line 36 "../providers/Microsoft/Integration.vala"
		opt_context = _tmp2_;
#line 37 "../providers/Microsoft/Integration.vala"
		_tmp3_ = opt_context;
#line 37 "../providers/Microsoft/Integration.vala"
		g_option_context_set_help_enabled (_tmp3_, TRUE);
#line 38 "../providers/Microsoft/Integration.vala"
		_tmp4_ = opt_context;
#line 38 "../providers/Microsoft/Integration.vala"
		g_option_context_set_ignore_unknown_options (_tmp4_, TRUE);
#line 39 "../providers/Microsoft/Integration.vala"
		_tmp5_ = opt_context;
#line 39 "../providers/Microsoft/Integration.vala"
		g_option_context_add_main_entries (_tmp5_, INTEGRATION_APPLICATION_options, NULL);
#line 41 "../providers/Microsoft/Integration.vala"
		_tmp6_ = opt_context;
#line 41 "../providers/Microsoft/Integration.vala"
		g_option_context_parse_strv (_tmp6_, &args, &_inner_error0_);
#line 41 "../providers/Microsoft/Integration.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 213 "Integration.c"
			gint _tmp7_ = -1;
#line 41 "../providers/Microsoft/Integration.vala"
			_g_option_context_free0 (opt_context);
#line 41 "../providers/Microsoft/Integration.vala"
			if (_inner_error0_->domain == G_OPTION_ERROR) {
#line 219 "Integration.c"
				goto __catch0_g_option_error;
			}
#line 41 "../providers/Microsoft/Integration.vala"
			_g_option_context_free0 (opt_context);
#line 41 "../providers/Microsoft/Integration.vala"
			args = (_vala_array_free (args, args_length1, (GDestroyNotify) g_free), NULL);
#line 41 "../providers/Microsoft/Integration.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 41 "../providers/Microsoft/Integration.vala"
			g_clear_error (&_inner_error0_);
#line 41 "../providers/Microsoft/Integration.vala"
			return _tmp7_;
#line 232 "Integration.c"
		}
#line 35 "../providers/Microsoft/Integration.vala"
		_g_option_context_free0 (opt_context);
#line 236 "Integration.c"
	}
	goto __finally0;
	__catch0_g_option_error:
	{
		GError* e = NULL;
		GError* _tmp8_;
		const gchar* _tmp9_;
		gchar** _tmp10_;
		gint _tmp10__length1;
		const gchar* _tmp11_;
#line 35 "../providers/Microsoft/Integration.vala"
		e = _inner_error0_;
#line 35 "../providers/Microsoft/Integration.vala"
		_inner_error0_ = NULL;
#line 43 "../providers/Microsoft/Integration.vala"
		_tmp8_ = e;
#line 43 "../providers/Microsoft/Integration.vala"
		_tmp9_ = _tmp8_->message;
#line 43 "../providers/Microsoft/Integration.vala"
		g_application_command_line_print (command_line, "error: %s\n", _tmp9_);
#line 44 "../providers/Microsoft/Integration.vala"
		_tmp10_ = args;
#line 44 "../providers/Microsoft/Integration.vala"
		_tmp10__length1 = args_length1;
#line 44 "../providers/Microsoft/Integration.vala"
		_tmp11_ = _tmp10_[0];
#line 44 "../providers/Microsoft/Integration.vala"
		g_application_command_line_print (command_line, "Run '%s --help' to see a full list of available command line options.\n", _tmp11_);
#line 45 "../providers/Microsoft/Integration.vala"
		result = -1;
#line 45 "../providers/Microsoft/Integration.vala"
		_g_error_free0 (e);
#line 45 "../providers/Microsoft/Integration.vala"
		args = (_vala_array_free (args, args_length1, (GDestroyNotify) g_free), NULL);
#line 45 "../providers/Microsoft/Integration.vala"
		return result;
#line 273 "Integration.c"
	}
	__finally0:
#line 35 "../providers/Microsoft/Integration.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 278 "Integration.c"
		gint _tmp12_ = -1;
#line 35 "../providers/Microsoft/Integration.vala"
		args = (_vala_array_free (args, args_length1, (GDestroyNotify) g_free), NULL);
#line 35 "../providers/Microsoft/Integration.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 35 "../providers/Microsoft/Integration.vala"
		g_clear_error (&_inner_error0_);
#line 35 "../providers/Microsoft/Integration.vala"
		return _tmp12_;
#line 288 "Integration.c"
	}
#line 48 "../providers/Microsoft/Integration.vala"
	_tmp13_ = integration_application_method;
#line 48 "../providers/Microsoft/Integration.vala"
	if (_tmp13_ == NULL) {
#line 49 "../providers/Microsoft/Integration.vala"
		g_application_command_line_print (command_line, "Missing method argument.\n");
#line 50 "../providers/Microsoft/Integration.vala"
		result = -1;
#line 50 "../providers/Microsoft/Integration.vala"
		args = (_vala_array_free (args, args_length1, (GDestroyNotify) g_free), NULL);
#line 50 "../providers/Microsoft/Integration.vala"
		return result;
#line 302 "Integration.c"
	}
#line 53 "../providers/Microsoft/Integration.vala"
	if (integration_application_account_id == ((guint) 0)) {
#line 54 "../providers/Microsoft/Integration.vala"
		g_application_command_line_print (command_line, "Missing account-id argument.\n");
#line 55 "../providers/Microsoft/Integration.vala"
		result = -1;
#line 55 "../providers/Microsoft/Integration.vala"
		args = (_vala_array_free (args, args_length1, (GDestroyNotify) g_free), NULL);
#line 55 "../providers/Microsoft/Integration.vala"
		return result;
#line 314 "Integration.c"
	}
#line 58 "../providers/Microsoft/Integration.vala"
	finished = FALSE;
#line 59 "../providers/Microsoft/Integration.vala"
	_tmp14_ = integration_application_method;
#line 59 "../providers/Microsoft/Integration.vala"
	_tmp15_ = _tmp14_;
#line 59 "../providers/Microsoft/Integration.vala"
	_tmp17_ = (NULL == _tmp15_) ? 0 : g_quark_from_string (_tmp15_);
#line 59 "../providers/Microsoft/Integration.vala"
	if (_tmp17_ == ((0 != _tmp16_label0) ? _tmp16_label0 : (_tmp16_label0 = g_quark_from_static_string ("UserName")))) {
#line 59 "../providers/Microsoft/Integration.vala"
		switch (0) {
#line 328 "Integration.c"
			default:
			{
#line 61 "../providers/Microsoft/Integration.vala"
				finished = integration_application_get_user_name (self, integration_application_account_id);
#line 62 "../providers/Microsoft/Integration.vala"
				break;
#line 335 "Integration.c"
			}
		}
	} else if (_tmp17_ == ((0 != _tmp16_label1) ? _tmp16_label1 : (_tmp16_label1 = g_quark_from_static_string ("UserImage")))) {
#line 59 "../providers/Microsoft/Integration.vala"
		switch (0) {
#line 341 "Integration.c"
			default:
			{
#line 64 "../providers/Microsoft/Integration.vala"
				finished = integration_application_get_user_image (self, integration_application_account_id);
#line 65 "../providers/Microsoft/Integration.vala"
				break;
#line 348 "Integration.c"
			}
		}
	} else {
#line 59 "../providers/Microsoft/Integration.vala"
		switch (0) {
#line 354 "Integration.c"
			default:
			{
				const gchar* _tmp18_;
#line 67 "../providers/Microsoft/Integration.vala"
				_tmp18_ = integration_application_method;
#line 67 "../providers/Microsoft/Integration.vala"
				g_application_command_line_print (command_line, "Method '%s' unavailable.\n", _tmp18_);
#line 68 "../providers/Microsoft/Integration.vala"
				break;
#line 364 "Integration.c"
			}
		}
	}
#line 71 "../providers/Microsoft/Integration.vala"
	if (finished) {
#line 370 "Integration.c"
		const gchar* _tmp19_;
#line 72 "../providers/Microsoft/Integration.vala"
		_tmp19_ = integration_application_method;
#line 72 "../providers/Microsoft/Integration.vala"
		g_application_command_line_print (command_line, "Method '%s' finished on account '%u'.\n", _tmp19_, integration_application_account_id);
#line 376 "Integration.c"
	}
#line 75 "../providers/Microsoft/Integration.vala"
	result = 0;
#line 75 "../providers/Microsoft/Integration.vala"
	args = (_vala_array_free (args, args_length1, (GDestroyNotify) g_free), NULL);
#line 75 "../providers/Microsoft/Integration.vala"
	return result;
#line 384 "Integration.c"
}

static Block1Data*
block1_data_ref (Block1Data* _data1_)
{
#line 90 "../providers/Microsoft/Integration.vala"
	g_atomic_int_inc (&_data1_->_ref_count_);
#line 90 "../providers/Microsoft/Integration.vala"
	return _data1_;
#line 394 "Integration.c"
}

static void
block1_data_unref (void * _userdata_)
{
	Block1Data* _data1_;
	_data1_ = (Block1Data*) _userdata_;
#line 90 "../providers/Microsoft/Integration.vala"
	if (g_atomic_int_dec_and_test (&_data1_->_ref_count_)) {
#line 404 "Integration.c"
		IntegrationApplication* self;
#line 90 "../providers/Microsoft/Integration.vala"
		self = _data1_->self;
#line 90 "../providers/Microsoft/Integration.vala"
		_g_main_loop_unref0 (_data1_->main_loop);
#line 90 "../providers/Microsoft/Integration.vala"
		_g_variant_unref0 (_data1_->session_result);
#line 90 "../providers/Microsoft/Integration.vala"
		_g_object_unref0 (_data1_->auth_session);
#line 90 "../providers/Microsoft/Integration.vala"
		_g_object_unref0 (self);
#line 90 "../providers/Microsoft/Integration.vala"
		g_slice_free (Block1Data, _data1_);
#line 418 "Integration.c"
	}
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 92 "../providers/Microsoft/Integration.vala"
	return self ? g_object_ref (self) : NULL;
#line 427 "Integration.c"
}

static void
_vala_AgAuthData_free (AgAuthData* self)
{
#line 101 "../providers/Microsoft/Integration.vala"
	g_boxed_free (ag_auth_data_get_type (), self);
#line 435 "Integration.c"
}

static void
___lambda4_ (Block1Data* _data1_,
             GObject* obj,
             GAsyncResult* res)
{
	IntegrationApplication* self;
	GMainLoop* _tmp6_;
	GError* _inner_error0_ = NULL;
#line 105 "../providers/Microsoft/Integration.vala"
	self = _data1_->self;
#line 105 "../providers/Microsoft/Integration.vala"
	g_return_if_fail (res != NULL);
#line 450 "Integration.c"
	{
		GVariant* _tmp0_ = NULL;
		SignonAuthSession* _tmp1_;
		GVariant* _tmp2_;
		GVariant* _tmp3_;
#line 107 "../providers/Microsoft/Integration.vala"
		_tmp1_ = _data1_->auth_session;
#line 107 "../providers/Microsoft/Integration.vala"
		_tmp2_ = signon_auth_session_process_finish (_tmp1_, res, &_inner_error0_);
#line 107 "../providers/Microsoft/Integration.vala"
		_tmp0_ = _tmp2_;
#line 107 "../providers/Microsoft/Integration.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 464 "Integration.c"
			goto __catch2_g_error;
		}
#line 107 "../providers/Microsoft/Integration.vala"
		_tmp3_ = _tmp0_;
#line 107 "../providers/Microsoft/Integration.vala"
		_tmp0_ = NULL;
#line 107 "../providers/Microsoft/Integration.vala"
		_g_variant_unref0 (_data1_->session_result);
#line 107 "../providers/Microsoft/Integration.vala"
		_data1_->session_result = _tmp3_;
#line 106 "../providers/Microsoft/Integration.vala"
		_g_variant_unref0 (_tmp0_);
#line 477 "Integration.c"
	}
	goto __finally2;
	__catch2_g_error:
	{
		GError* e = NULL;
		GError* _tmp4_;
		const gchar* _tmp5_;
#line 106 "../providers/Microsoft/Integration.vala"
		e = _inner_error0_;
#line 106 "../providers/Microsoft/Integration.vala"
		_inner_error0_ = NULL;
#line 109 "../providers/Microsoft/Integration.vala"
		_tmp4_ = e;
#line 109 "../providers/Microsoft/Integration.vala"
		_tmp5_ = _tmp4_->message;
#line 109 "../providers/Microsoft/Integration.vala"
		g_critical ("Integration.vala:109: %s", _tmp5_);
#line 106 "../providers/Microsoft/Integration.vala"
		_g_error_free0 (e);
#line 497 "Integration.c"
	}
	__finally2:
#line 106 "../providers/Microsoft/Integration.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 106 "../providers/Microsoft/Integration.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 106 "../providers/Microsoft/Integration.vala"
		g_clear_error (&_inner_error0_);
#line 106 "../providers/Microsoft/Integration.vala"
		return;
#line 508 "Integration.c"
	}
#line 112 "../providers/Microsoft/Integration.vala"
	_tmp6_ = _data1_->main_loop;
#line 112 "../providers/Microsoft/Integration.vala"
	g_main_loop_quit (_tmp6_);
#line 514 "Integration.c"
}

static void
____lambda4__gasync_ready_callback (GObject* source_object,
                                    GAsyncResult* res,
                                    gpointer self)
{
#line 105 "../providers/Microsoft/Integration.vala"
	___lambda4_ (self, source_object, res);
#line 105 "../providers/Microsoft/Integration.vala"
	block1_data_unref (self);
#line 526 "Integration.c"
}

IntegrationApplicationApiInfos*
integration_application_get_token (IntegrationApplication* self,
                                   guint account_id)
{
	IntegrationApplicationApiInfos* result = NULL;
	IntegrationApplicationApiInfos* api_infos = NULL;
	IntegrationApplicationApiInfos* _tmp0_;
	AgManager* ag_manager = NULL;
	AgManager* _tmp1_;
	GError* _inner_error0_ = NULL;
#line 86 "../providers/Microsoft/Integration.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 87 "../providers/Microsoft/Integration.vala"
	_tmp0_ = integration_application_api_infos_new ();
#line 87 "../providers/Microsoft/Integration.vala"
	api_infos = _tmp0_;
#line 89 "../providers/Microsoft/Integration.vala"
	_tmp1_ = ag_manager_new ();
#line 89 "../providers/Microsoft/Integration.vala"
	ag_manager = _tmp1_;
#line 549 "Integration.c"
	{
		Block1Data* _data1_;
		AgAccount* account = NULL;
		AgManager* _tmp2_;
		AgAccount* _tmp3_;
		AgAccountService* account_service = NULL;
		AgAccount* _tmp4_;
		AgAccount* _tmp5_;
		AgAccountService* _tmp6_;
		AgAuthData* auth_data = NULL;
		AgAccountService* _tmp7_;
		AgAuthData* _tmp8_;
		GVariant* session_data = NULL;
		AgAuthData* _tmp9_;
		GVariant* _tmp10_;
		IntegrationApplicationApiInfos* _tmp11_;
		AgAccountService* _tmp12_;
		AgAccountService* _tmp13_;
		IntegrationApplicationApiInfos* _tmp14_;
		GVariant* _tmp15_;
		GVariant* _tmp16_;
		GVariant* _tmp17_;
		gchar* _tmp18_;
		IntegrationApplicationApiInfos* _tmp19_;
		GVariant* _tmp20_;
		GVariant* _tmp21_;
		GVariant* _tmp22_;
		gchar* _tmp23_;
		SignonIdentity* identity = NULL;
		AgAuthData* _tmp24_;
		SignonIdentity* _tmp25_;
		SignonIdentity* _tmp26_;
		SignonAuthSession* _tmp27_;
		GMainLoop* _tmp28_;
		SignonAuthSession* _tmp29_;
		GVariant* _tmp30_;
		GMainLoop* _tmp31_;
		GVariant* _tmp32_;
		IntegrationApplicationApiInfos* _tmp33_;
		GVariant* _tmp34_;
		GVariant* _tmp35_;
		GVariant* _tmp36_;
		gchar* _tmp37_;
#line 90 "../providers/Microsoft/Integration.vala"
		_data1_ = g_slice_new0 (Block1Data);
#line 90 "../providers/Microsoft/Integration.vala"
		_data1_->_ref_count_ = 1;
#line 90 "../providers/Microsoft/Integration.vala"
		_data1_->self = g_object_ref (self);
#line 91 "../providers/Microsoft/Integration.vala"
		_tmp2_ = ag_manager;
#line 91 "../providers/Microsoft/Integration.vala"
		_tmp3_ = ag_manager_load_account (_tmp2_, (AgAccountId) account_id, &_inner_error0_);
#line 91 "../providers/Microsoft/Integration.vala"
		account = _tmp3_;
#line 91 "../providers/Microsoft/Integration.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 91 "../providers/Microsoft/Integration.vala"
			block1_data_unref (_data1_);
#line 91 "../providers/Microsoft/Integration.vala"
			_data1_ = NULL;
#line 611 "Integration.c"
			goto __catch1_g_error;
		}
#line 92 "../providers/Microsoft/Integration.vala"
		_tmp4_ = account;
#line 92 "../providers/Microsoft/Integration.vala"
		_tmp5_ = _g_object_ref0 (_tmp4_);
#line 92 "../providers/Microsoft/Integration.vala"
		_tmp6_ = ag_account_service_new (_tmp5_, NULL);
#line 92 "../providers/Microsoft/Integration.vala"
		account_service = _tmp6_;
#line 93 "../providers/Microsoft/Integration.vala"
		_tmp7_ = account_service;
#line 93 "../providers/Microsoft/Integration.vala"
		_tmp8_ = ag_account_service_get_auth_data (_tmp7_);
#line 93 "../providers/Microsoft/Integration.vala"
		auth_data = _tmp8_;
#line 94 "../providers/Microsoft/Integration.vala"
		_tmp9_ = auth_data;
#line 94 "../providers/Microsoft/Integration.vala"
		_tmp10_ = ag_auth_data_get_login_parameters (_tmp9_, NULL);
#line 94 "../providers/Microsoft/Integration.vala"
		session_data = _tmp10_;
#line 96 "../providers/Microsoft/Integration.vala"
		_tmp11_ = api_infos;
#line 96 "../providers/Microsoft/Integration.vala"
		_tmp12_ = account_service;
#line 96 "../providers/Microsoft/Integration.vala"
		_tmp13_ = _g_object_ref0 (_tmp12_);
#line 96 "../providers/Microsoft/Integration.vala"
		_g_object_unref0 (_tmp11_->account_service);
#line 96 "../providers/Microsoft/Integration.vala"
		_tmp11_->account_service = _tmp13_;
#line 97 "../providers/Microsoft/Integration.vala"
		_tmp14_ = api_infos;
#line 97 "../providers/Microsoft/Integration.vala"
		_tmp15_ = session_data;
#line 97 "../providers/Microsoft/Integration.vala"
		_tmp16_ = g_variant_lookup_value (_tmp15_, "ClientId", NULL);
#line 97 "../providers/Microsoft/Integration.vala"
		_tmp17_ = _tmp16_;
#line 97 "../providers/Microsoft/Integration.vala"
		_tmp18_ = g_variant_dup_string (_tmp17_, NULL);
#line 97 "../providers/Microsoft/Integration.vala"
		_g_free0 (_tmp14_->client_id);
#line 97 "../providers/Microsoft/Integration.vala"
		_tmp14_->client_id = _tmp18_;
#line 97 "../providers/Microsoft/Integration.vala"
		_g_variant_unref0 (_tmp17_);
#line 98 "../providers/Microsoft/Integration.vala"
		_tmp19_ = api_infos;
#line 98 "../providers/Microsoft/Integration.vala"
		_tmp20_ = session_data;
#line 98 "../providers/Microsoft/Integration.vala"
		_tmp21_ = g_variant_lookup_value (_tmp20_, "RedirectUri", NULL);
#line 98 "../providers/Microsoft/Integration.vala"
		_tmp22_ = _tmp21_;
#line 98 "../providers/Microsoft/Integration.vala"
		_tmp23_ = g_variant_dup_string (_tmp22_, NULL);
#line 98 "../providers/Microsoft/Integration.vala"
		_g_free0 (_tmp19_->redirect_uri);
#line 98 "../providers/Microsoft/Integration.vala"
		_tmp19_->redirect_uri = _tmp23_;
#line 98 "../providers/Microsoft/Integration.vala"
		_g_variant_unref0 (_tmp22_);
#line 100 "../providers/Microsoft/Integration.vala"
		_tmp24_ = auth_data;
#line 100 "../providers/Microsoft/Integration.vala"
		_tmp25_ = signon_identity_new_from_db ((guint32) ag_auth_data_get_credentials_id (_tmp24_));
#line 100 "../providers/Microsoft/Integration.vala"
		identity = _tmp25_;
#line 101 "../providers/Microsoft/Integration.vala"
		_tmp26_ = identity;
#line 101 "../providers/Microsoft/Integration.vala"
		_tmp27_ = signon_identity_create_session (_tmp26_, "oauth", &_inner_error0_);
#line 101 "../providers/Microsoft/Integration.vala"
		_data1_->auth_session = _tmp27_;
#line 101 "../providers/Microsoft/Integration.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 101 "../providers/Microsoft/Integration.vala"
			_g_object_unref0 (identity);
#line 101 "../providers/Microsoft/Integration.vala"
			__vala_AgAuthData_free0 (auth_data);
#line 101 "../providers/Microsoft/Integration.vala"
			_g_object_unref0 (account_service);
#line 101 "../providers/Microsoft/Integration.vala"
			_g_object_unref0 (account);
#line 101 "../providers/Microsoft/Integration.vala"
			block1_data_unref (_data1_);
#line 101 "../providers/Microsoft/Integration.vala"
			_data1_ = NULL;
#line 702 "Integration.c"
			goto __catch1_g_error;
		}
#line 103 "../providers/Microsoft/Integration.vala"
		_data1_->session_result = NULL;
#line 104 "../providers/Microsoft/Integration.vala"
		_tmp28_ = g_main_loop_new (NULL, FALSE);
#line 104 "../providers/Microsoft/Integration.vala"
		_data1_->main_loop = _tmp28_;
#line 105 "../providers/Microsoft/Integration.vala"
		_tmp29_ = _data1_->auth_session;
#line 105 "../providers/Microsoft/Integration.vala"
		_tmp30_ = session_data;
#line 105 "../providers/Microsoft/Integration.vala"
		signon_auth_session_process (_tmp29_, _tmp30_, "oauth2", NULL, ____lambda4__gasync_ready_callback, block1_data_ref (_data1_));
#line 115 "../providers/Microsoft/Integration.vala"
		_tmp31_ = _data1_->main_loop;
#line 115 "../providers/Microsoft/Integration.vala"
		g_main_loop_run (_tmp31_);
#line 116 "../providers/Microsoft/Integration.vala"
		_tmp32_ = _data1_->session_result;
#line 116 "../providers/Microsoft/Integration.vala"
		if (_tmp32_ == NULL) {
#line 117 "../providers/Microsoft/Integration.vala"
			result = NULL;
#line 117 "../providers/Microsoft/Integration.vala"
			_g_object_unref0 (identity);
#line 117 "../providers/Microsoft/Integration.vala"
			__vala_AgAuthData_free0 (auth_data);
#line 117 "../providers/Microsoft/Integration.vala"
			_g_object_unref0 (account_service);
#line 117 "../providers/Microsoft/Integration.vala"
			_g_object_unref0 (account);
#line 117 "../providers/Microsoft/Integration.vala"
			block1_data_unref (_data1_);
#line 117 "../providers/Microsoft/Integration.vala"
			_data1_ = NULL;
#line 117 "../providers/Microsoft/Integration.vala"
			_g_object_unref0 (ag_manager);
#line 117 "../providers/Microsoft/Integration.vala"
			_integration_application_api_infos_free0 (api_infos);
#line 117 "../providers/Microsoft/Integration.vala"
			return result;
#line 745 "Integration.c"
		}
#line 120 "../providers/Microsoft/Integration.vala"
		_tmp33_ = api_infos;
#line 120 "../providers/Microsoft/Integration.vala"
		_tmp34_ = _data1_->session_result;
#line 120 "../providers/Microsoft/Integration.vala"
		_tmp35_ = g_variant_lookup_value (_tmp34_, "AccessToken", NULL);
#line 120 "../providers/Microsoft/Integration.vala"
		_tmp36_ = _tmp35_;
#line 120 "../providers/Microsoft/Integration.vala"
		_tmp37_ = g_variant_dup_string (_tmp36_, NULL);
#line 120 "../providers/Microsoft/Integration.vala"
		_g_free0 (_tmp33_->access_token);
#line 120 "../providers/Microsoft/Integration.vala"
		_tmp33_->access_token = _tmp37_;
#line 120 "../providers/Microsoft/Integration.vala"
		_g_variant_unref0 (_tmp36_);
#line 90 "../providers/Microsoft/Integration.vala"
		_g_object_unref0 (identity);
#line 90 "../providers/Microsoft/Integration.vala"
		__vala_AgAuthData_free0 (auth_data);
#line 90 "../providers/Microsoft/Integration.vala"
		_g_object_unref0 (account_service);
#line 90 "../providers/Microsoft/Integration.vala"
		_g_object_unref0 (account);
#line 90 "../providers/Microsoft/Integration.vala"
		block1_data_unref (_data1_);
#line 90 "../providers/Microsoft/Integration.vala"
		_data1_ = NULL;
#line 775 "Integration.c"
	}
	goto __finally1;
	__catch1_g_error:
	{
		GError* e = NULL;
		GError* _tmp38_;
		const gchar* _tmp39_;
#line 90 "../providers/Microsoft/Integration.vala"
		e = _inner_error0_;
#line 90 "../providers/Microsoft/Integration.vala"
		_inner_error0_ = NULL;
#line 122 "../providers/Microsoft/Integration.vala"
		_tmp38_ = e;
#line 122 "../providers/Microsoft/Integration.vala"
		_tmp39_ = _tmp38_->message;
#line 122 "../providers/Microsoft/Integration.vala"
		g_critical ("Integration.vala:122: %s", _tmp39_);
#line 123 "../providers/Microsoft/Integration.vala"
		result = NULL;
#line 123 "../providers/Microsoft/Integration.vala"
		_g_error_free0 (e);
#line 123 "../providers/Microsoft/Integration.vala"
		_g_object_unref0 (ag_manager);
#line 123 "../providers/Microsoft/Integration.vala"
		_integration_application_api_infos_free0 (api_infos);
#line 123 "../providers/Microsoft/Integration.vala"
		return result;
#line 803 "Integration.c"
	}
	__finally1:
#line 90 "../providers/Microsoft/Integration.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 90 "../providers/Microsoft/Integration.vala"
		_g_object_unref0 (ag_manager);
#line 90 "../providers/Microsoft/Integration.vala"
		_integration_application_api_infos_free0 (api_infos);
#line 90 "../providers/Microsoft/Integration.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 90 "../providers/Microsoft/Integration.vala"
		g_clear_error (&_inner_error0_);
#line 90 "../providers/Microsoft/Integration.vala"
		return NULL;
#line 818 "Integration.c"
	}
#line 126 "../providers/Microsoft/Integration.vala"
	result = api_infos;
#line 126 "../providers/Microsoft/Integration.vala"
	_g_object_unref0 (ag_manager);
#line 126 "../providers/Microsoft/Integration.vala"
	return result;
#line 826 "Integration.c"
}

static gpointer
_json_object_ref0 (gpointer self)
{
#line 155 "../providers/Microsoft/Integration.vala"
	return self ? json_object_ref (self) : NULL;
#line 834 "Integration.c"
}

static gpointer
_g_variant_ref0 (gpointer self)
{
#line 165 "../providers/Microsoft/Integration.vala"
	return self ? g_variant_ref (self) : NULL;
#line 842 "Integration.c"
}

gboolean
integration_application_get_user_name (IntegrationApplication* self,
                                       guint account_id)
{
	gboolean result = FALSE;
	IntegrationApplicationApiInfos* api_infos = NULL;
	IntegrationApplicationApiInfos* _tmp0_;
	IntegrationApplicationApiInfos* _tmp1_;
	OAuth2Proxy* proxy = NULL;
	IntegrationApplicationApiInfos* _tmp2_;
	const gchar* _tmp3_;
	IntegrationApplicationApiInfos* _tmp4_;
	const gchar* _tmp5_;
	IntegrationApplicationApiInfos* _tmp6_;
	const gchar* _tmp7_;
	OAuth2Proxy* _tmp8_;
	RestProxyCall* call = NULL;
	OAuth2Proxy* _tmp9_;
	RestProxyCall* _tmp10_;
	RestProxyCall* _tmp11_;
	GError* _inner_error0_ = NULL;
#line 129 "../providers/Microsoft/Integration.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 130 "../providers/Microsoft/Integration.vala"
	_tmp0_ = integration_application_get_token (self, account_id);
#line 130 "../providers/Microsoft/Integration.vala"
	api_infos = _tmp0_;
#line 131 "../providers/Microsoft/Integration.vala"
	_tmp1_ = api_infos;
#line 131 "../providers/Microsoft/Integration.vala"
	if (_tmp1_ == NULL) {
#line 132 "../providers/Microsoft/Integration.vala"
		result = FALSE;
#line 132 "../providers/Microsoft/Integration.vala"
		_integration_application_api_infos_free0 (api_infos);
#line 132 "../providers/Microsoft/Integration.vala"
		return result;
#line 882 "Integration.c"
	}
#line 134 "../providers/Microsoft/Integration.vala"
	_tmp2_ = api_infos;
#line 134 "../providers/Microsoft/Integration.vala"
	_tmp3_ = _tmp2_->client_id;
#line 134 "../providers/Microsoft/Integration.vala"
	_tmp4_ = api_infos;
#line 134 "../providers/Microsoft/Integration.vala"
	_tmp5_ = _tmp4_->access_token;
#line 134 "../providers/Microsoft/Integration.vala"
	_tmp6_ = api_infos;
#line 134 "../providers/Microsoft/Integration.vala"
	_tmp7_ = _tmp6_->redirect_uri;
#line 134 "../providers/Microsoft/Integration.vala"
	_tmp8_ = (OAuth2Proxy*) oauth2_proxy_new_with_token (_tmp3_, _tmp5_, _tmp7_, "https://apis.live.net/v5.0/me", FALSE);
#line 134 "../providers/Microsoft/Integration.vala"
	proxy = _tmp8_;
#line 142 "../providers/Microsoft/Integration.vala"
	_tmp9_ = proxy;
#line 142 "../providers/Microsoft/Integration.vala"
	_tmp10_ = rest_proxy_new_call ((RestProxy*) _tmp9_);
#line 142 "../providers/Microsoft/Integration.vala"
	call = _tmp10_;
#line 143 "../providers/Microsoft/Integration.vala"
	_tmp11_ = call;
#line 143 "../providers/Microsoft/Integration.vala"
	rest_proxy_call_set_method (_tmp11_, "GET");
#line 910 "Integration.c"
	{
		RestProxyCall* _tmp12_;
#line 145 "../providers/Microsoft/Integration.vala"
		_tmp12_ = call;
#line 145 "../providers/Microsoft/Integration.vala"
		rest_proxy_call_run (_tmp12_, NULL, &_inner_error0_);
#line 145 "../providers/Microsoft/Integration.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 919 "Integration.c"
			goto __catch3_g_error;
		}
	}
	goto __finally3;
	__catch3_g_error:
	{
		GError* e = NULL;
		GError* _tmp13_;
		const gchar* _tmp14_;
#line 144 "../providers/Microsoft/Integration.vala"
		e = _inner_error0_;
#line 144 "../providers/Microsoft/Integration.vala"
		_inner_error0_ = NULL;
#line 147 "../providers/Microsoft/Integration.vala"
		_tmp13_ = e;
#line 147 "../providers/Microsoft/Integration.vala"
		_tmp14_ = _tmp13_->message;
#line 147 "../providers/Microsoft/Integration.vala"
		g_critical ("Integration.vala:147: %s", _tmp14_);
#line 148 "../providers/Microsoft/Integration.vala"
		result = FALSE;
#line 148 "../providers/Microsoft/Integration.vala"
		_g_error_free0 (e);
#line 148 "../providers/Microsoft/Integration.vala"
		_g_object_unref0 (call);
#line 148 "../providers/Microsoft/Integration.vala"
		_g_object_unref0 (proxy);
#line 148 "../providers/Microsoft/Integration.vala"
		_integration_application_api_infos_free0 (api_infos);
#line 148 "../providers/Microsoft/Integration.vala"
		return result;
#line 951 "Integration.c"
	}
	__finally3:
#line 144 "../providers/Microsoft/Integration.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 956 "Integration.c"
		gboolean _tmp15_ = FALSE;
#line 144 "../providers/Microsoft/Integration.vala"
		_g_object_unref0 (call);
#line 144 "../providers/Microsoft/Integration.vala"
		_g_object_unref0 (proxy);
#line 144 "../providers/Microsoft/Integration.vala"
		_integration_application_api_infos_free0 (api_infos);
#line 144 "../providers/Microsoft/Integration.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 144 "../providers/Microsoft/Integration.vala"
		g_clear_error (&_inner_error0_);
#line 144 "../providers/Microsoft/Integration.vala"
		return _tmp15_;
#line 970 "Integration.c"
	}
	{
		JsonParser* parser = NULL;
		JsonParser* _tmp16_;
		JsonParser* _tmp17_;
		RestProxyCall* _tmp18_;
		const gchar* _tmp19_;
		RestProxyCall* _tmp20_;
		JsonObject* root_object = NULL;
		JsonParser* _tmp21_;
		JsonNode* _tmp22_;
		JsonObject* _tmp23_;
		JsonObject* _tmp24_;
		JsonObject* mails_member = NULL;
		JsonObject* _tmp25_;
		JsonObject* _tmp26_;
		const gchar* mail = NULL;
		JsonObject* _tmp27_;
		const gchar* _tmp28_;
		AgAccountService* account_service = NULL;
		IntegrationApplicationApiInfos* _tmp29_;
		AgAccountService* _tmp30_;
		AgAccountService* _tmp31_;
		AgAccountService* _tmp32_;
		AgAccount* _tmp33_;
		AgAccount* _tmp34_;
		const gchar* _tmp35_;
		AgAccountService* _tmp36_;
		AgAccount* _tmp37_;
		AgAccount* _tmp38_;
		AgAuthData* auth_data = NULL;
		AgAccountService* _tmp39_;
		AgAuthData* _tmp40_;
		gchar* key = NULL;
		AgAuthData* _tmp41_;
		const gchar* _tmp42_;
		AgAuthData* _tmp43_;
		const gchar* _tmp44_;
		gchar* _tmp45_;
		GVariant* auth_query = NULL;
		AgAccountService* _tmp46_;
		const gchar* _tmp47_;
		GVariant* _tmp48_;
		GVariant* _tmp49_;
		GVariant* _tmp50_;
#line 152 "../providers/Microsoft/Integration.vala"
		_tmp16_ = json_parser_new ();
#line 152 "../providers/Microsoft/Integration.vala"
		parser = _tmp16_;
#line 153 "../providers/Microsoft/Integration.vala"
		_tmp17_ = parser;
#line 153 "../providers/Microsoft/Integration.vala"
		_tmp18_ = call;
#line 153 "../providers/Microsoft/Integration.vala"
		_tmp19_ = rest_proxy_call_get_payload (_tmp18_);
#line 153 "../providers/Microsoft/Integration.vala"
		_tmp20_ = call;
#line 153 "../providers/Microsoft/Integration.vala"
		json_parser_load_from_data (_tmp17_, _tmp19_, (gssize) rest_proxy_call_get_payload_length (_tmp20_), &_inner_error0_);
#line 153 "../providers/Microsoft/Integration.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 153 "../providers/Microsoft/Integration.vala"
			_g_object_unref0 (parser);
#line 1034 "Integration.c"
			goto __catch4_g_error;
		}
#line 155 "../providers/Microsoft/Integration.vala"
		_tmp21_ = parser;
#line 155 "../providers/Microsoft/Integration.vala"
		_tmp22_ = json_parser_get_root (_tmp21_);
#line 155 "../providers/Microsoft/Integration.vala"
		_tmp23_ = json_node_get_object (_tmp22_);
#line 155 "../providers/Microsoft/Integration.vala"
		_tmp24_ = _json_object_ref0 (_tmp23_);
#line 155 "../providers/Microsoft/Integration.vala"
		root_object = _tmp24_;
#line 156 "../providers/Microsoft/Integration.vala"
		_tmp25_ = root_object;
#line 156 "../providers/Microsoft/Integration.vala"
		_tmp26_ = json_object_get_object_member (_tmp25_, "emails");
#line 156 "../providers/Microsoft/Integration.vala"
		mails_member = _tmp26_;
#line 157 "../providers/Microsoft/Integration.vala"
		_tmp27_ = mails_member;
#line 157 "../providers/Microsoft/Integration.vala"
		_tmp28_ = json_object_get_string_member (_tmp27_, "account");
#line 157 "../providers/Microsoft/Integration.vala"
		mail = _tmp28_;
#line 158 "../providers/Microsoft/Integration.vala"
		_tmp29_ = api_infos;
#line 158 "../providers/Microsoft/Integration.vala"
		_tmp30_ = _tmp29_->account_service;
#line 158 "../providers/Microsoft/Integration.vala"
		_tmp31_ = _g_object_ref0 (_tmp30_);
#line 158 "../providers/Microsoft/Integration.vala"
		account_service = _tmp31_;
#line 159 "../providers/Microsoft/Integration.vala"
		_tmp32_ = account_service;
#line 159 "../providers/Microsoft/Integration.vala"
		_tmp33_ = ag_account_service_get_account (_tmp32_);
#line 159 "../providers/Microsoft/Integration.vala"
		_tmp34_ = _tmp33_;
#line 159 "../providers/Microsoft/Integration.vala"
		_tmp35_ = mail;
#line 159 "../providers/Microsoft/Integration.vala"
		ag_account_set_display_name (_tmp34_, _tmp35_);
#line 160 "../providers/Microsoft/Integration.vala"
		_tmp36_ = account_service;
#line 160 "../providers/Microsoft/Integration.vala"
		_tmp37_ = ag_account_service_get_account (_tmp36_);
#line 160 "../providers/Microsoft/Integration.vala"
		_tmp38_ = _tmp37_;
#line 160 "../providers/Microsoft/Integration.vala"
		ag_account_store_blocking (_tmp38_, &_inner_error0_);
#line 160 "../providers/Microsoft/Integration.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 160 "../providers/Microsoft/Integration.vala"
			_g_object_unref0 (account_service);
#line 160 "../providers/Microsoft/Integration.vala"
			_json_object_unref0 (root_object);
#line 160 "../providers/Microsoft/Integration.vala"
			_g_object_unref0 (parser);
#line 1093 "Integration.c"
			goto __catch4_g_error;
		}
#line 163 "../providers/Microsoft/Integration.vala"
		_tmp39_ = account_service;
#line 163 "../providers/Microsoft/Integration.vala"
		_tmp40_ = ag_account_service_get_auth_data (_tmp39_);
#line 163 "../providers/Microsoft/Integration.vala"
		auth_data = _tmp40_;
#line 164 "../providers/Microsoft/Integration.vala"
		_tmp41_ = auth_data;
#line 164 "../providers/Microsoft/Integration.vala"
		_tmp42_ = ag_auth_data_get_method (_tmp41_);
#line 164 "../providers/Microsoft/Integration.vala"
		_tmp43_ = auth_data;
#line 164 "../providers/Microsoft/Integration.vala"
		_tmp44_ = ag_auth_data_get_mechanism (_tmp43_);
#line 164 "../providers/Microsoft/Integration.vala"
		_tmp45_ = g_strdup_printf ("auth/%s/%s/AuthQuery", _tmp42_, _tmp44_);
#line 164 "../providers/Microsoft/Integration.vala"
		key = _tmp45_;
#line 165 "../providers/Microsoft/Integration.vala"
		_tmp46_ = account_service;
#line 165 "../providers/Microsoft/Integration.vala"
		_tmp47_ = key;
#line 165 "../providers/Microsoft/Integration.vala"
		_tmp48_ = ag_account_service_get_variant (_tmp46_, _tmp47_, NULL);
#line 165 "../providers/Microsoft/Integration.vala"
		_tmp49_ = _g_variant_ref0 (_tmp48_);
#line 165 "../providers/Microsoft/Integration.vala"
		auth_query = _tmp49_;
#line 166 "../providers/Microsoft/Integration.vala"
		_tmp50_ = auth_query;
#line 166 "../providers/Microsoft/Integration.vala"
		if (_tmp50_ != NULL) {
#line 1128 "Integration.c"
			GVariant* variant = NULL;
			const gchar* _tmp51_;
			GVariant* _tmp52_;
			const gchar* _tmp53_;
			gchar* _tmp54_;
			gchar* _tmp55_;
			GVariant* _tmp56_;
			GVariant* _tmp57_;
			AgAccountService* _tmp58_;
			const gchar* _tmp59_;
			GVariant* _tmp60_;
#line 167 "../providers/Microsoft/Integration.vala"
			_tmp51_ = mail;
#line 167 "../providers/Microsoft/Integration.vala"
			_tmp52_ = auth_query;
#line 167 "../providers/Microsoft/Integration.vala"
			_tmp53_ = g_variant_get_string (_tmp52_, NULL);
#line 167 "../providers/Microsoft/Integration.vala"
			_tmp54_ = g_strdup_printf ("login_hint=%s&amp;%s", _tmp51_, _tmp53_);
#line 167 "../providers/Microsoft/Integration.vala"
			_tmp55_ = _tmp54_;
#line 167 "../providers/Microsoft/Integration.vala"
			_tmp56_ = g_variant_new_string (_tmp55_);
#line 167 "../providers/Microsoft/Integration.vala"
			g_variant_ref_sink (_tmp56_);
#line 167 "../providers/Microsoft/Integration.vala"
			_tmp57_ = _tmp56_;
#line 167 "../providers/Microsoft/Integration.vala"
			_g_free0 (_tmp55_);
#line 167 "../providers/Microsoft/Integration.vala"
			variant = _tmp57_;
#line 168 "../providers/Microsoft/Integration.vala"
			_tmp58_ = account_service;
#line 168 "../providers/Microsoft/Integration.vala"
			_tmp59_ = key;
#line 168 "../providers/Microsoft/Integration.vala"
			_tmp60_ = variant;
#line 168 "../providers/Microsoft/Integration.vala"
			ag_account_service_set_variant (_tmp58_, _tmp59_, _tmp60_);
#line 166 "../providers/Microsoft/Integration.vala"
			_g_variant_unref0 (variant);
#line 1170 "Integration.c"
		} else {
			GVariant* variant = NULL;
			const gchar* _tmp61_;
			gchar* _tmp62_;
			gchar* _tmp63_;
			GVariant* _tmp64_;
			GVariant* _tmp65_;
			AgAccountService* _tmp66_;
			const gchar* _tmp67_;
			GVariant* _tmp68_;
#line 170 "../providers/Microsoft/Integration.vala"
			_tmp61_ = mail;
#line 170 "../providers/Microsoft/Integration.vala"
			_tmp62_ = g_strdup_printf ("login_hint=%s", _tmp61_);
#line 170 "../providers/Microsoft/Integration.vala"
			_tmp63_ = _tmp62_;
#line 170 "../providers/Microsoft/Integration.vala"
			_tmp64_ = g_variant_new_string (_tmp63_);
#line 170 "../providers/Microsoft/Integration.vala"
			g_variant_ref_sink (_tmp64_);
#line 170 "../providers/Microsoft/Integration.vala"
			_tmp65_ = _tmp64_;
#line 170 "../providers/Microsoft/Integration.vala"
			_g_free0 (_tmp63_);
#line 170 "../providers/Microsoft/Integration.vala"
			variant = _tmp65_;
#line 171 "../providers/Microsoft/Integration.vala"
			_tmp66_ = account_service;
#line 171 "../providers/Microsoft/Integration.vala"
			_tmp67_ = key;
#line 171 "../providers/Microsoft/Integration.vala"
			_tmp68_ = variant;
#line 171 "../providers/Microsoft/Integration.vala"
			ag_account_service_set_variant (_tmp66_, _tmp67_, _tmp68_);
#line 166 "../providers/Microsoft/Integration.vala"
			_g_variant_unref0 (variant);
#line 1207 "Integration.c"
		}
#line 151 "../providers/Microsoft/Integration.vala"
		_g_variant_unref0 (auth_query);
#line 151 "../providers/Microsoft/Integration.vala"
		_g_free0 (key);
#line 151 "../providers/Microsoft/Integration.vala"
		__vala_AgAuthData_free0 (auth_data);
#line 151 "../providers/Microsoft/Integration.vala"
		_g_object_unref0 (account_service);
#line 151 "../providers/Microsoft/Integration.vala"
		_json_object_unref0 (root_object);
#line 151 "../providers/Microsoft/Integration.vala"
		_g_object_unref0 (parser);
#line 1221 "Integration.c"
	}
	goto __finally4;
	__catch4_g_error:
	{
		GError* e = NULL;
		GError* _tmp69_;
		const gchar* _tmp70_;
#line 151 "../providers/Microsoft/Integration.vala"
		e = _inner_error0_;
#line 151 "../providers/Microsoft/Integration.vala"
		_inner_error0_ = NULL;
#line 174 "../providers/Microsoft/Integration.vala"
		_tmp69_ = e;
#line 174 "../providers/Microsoft/Integration.vala"
		_tmp70_ = _tmp69_->message;
#line 174 "../providers/Microsoft/Integration.vala"
		g_critical ("Integration.vala:174: %s", _tmp70_);
#line 151 "../providers/Microsoft/Integration.vala"
		_g_error_free0 (e);
#line 1241 "Integration.c"
	}
	__finally4:
#line 151 "../providers/Microsoft/Integration.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1246 "Integration.c"
		gboolean _tmp71_ = FALSE;
#line 151 "../providers/Microsoft/Integration.vala"
		_g_object_unref0 (call);
#line 151 "../providers/Microsoft/Integration.vala"
		_g_object_unref0 (proxy);
#line 151 "../providers/Microsoft/Integration.vala"
		_integration_application_api_infos_free0 (api_infos);
#line 151 "../providers/Microsoft/Integration.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 151 "../providers/Microsoft/Integration.vala"
		g_clear_error (&_inner_error0_);
#line 151 "../providers/Microsoft/Integration.vala"
		return _tmp71_;
#line 1260 "Integration.c"
	}
#line 177 "../providers/Microsoft/Integration.vala"
	result = TRUE;
#line 177 "../providers/Microsoft/Integration.vala"
	_g_object_unref0 (call);
#line 177 "../providers/Microsoft/Integration.vala"
	_g_object_unref0 (proxy);
#line 177 "../providers/Microsoft/Integration.vala"
	_integration_application_api_infos_free0 (api_infos);
#line 177 "../providers/Microsoft/Integration.vala"
	return result;
#line 1272 "Integration.c"
}

gboolean
integration_application_get_user_image (IntegrationApplication* self,
                                        guint account_id)
{
	gboolean result = FALSE;
	IntegrationApplicationApiInfos* api_infos = NULL;
	IntegrationApplicationApiInfos* _tmp0_;
	IntegrationApplicationApiInfos* _tmp1_;
#line 180 "../providers/Microsoft/Integration.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 181 "../providers/Microsoft/Integration.vala"
	_tmp0_ = integration_application_get_token (self, account_id);
#line 181 "../providers/Microsoft/Integration.vala"
	api_infos = _tmp0_;
#line 182 "../providers/Microsoft/Integration.vala"
	_tmp1_ = api_infos;
#line 182 "../providers/Microsoft/Integration.vala"
	if (_tmp1_ == NULL) {
#line 183 "../providers/Microsoft/Integration.vala"
		result = FALSE;
#line 183 "../providers/Microsoft/Integration.vala"
		_integration_application_api_infos_free0 (api_infos);
#line 183 "../providers/Microsoft/Integration.vala"
		return result;
#line 1299 "Integration.c"
	}
#line 187 "../providers/Microsoft/Integration.vala"
	result = TRUE;
#line 187 "../providers/Microsoft/Integration.vala"
	_integration_application_api_infos_free0 (api_infos);
#line 187 "../providers/Microsoft/Integration.vala"
	return result;
#line 1307 "Integration.c"
}

gint
integration_application_main (gchar** args,
                              gint args_length1)
{
	gint result = 0;
	IntegrationApplication* app = NULL;
	IntegrationApplication* _tmp0_;
	gint status = 0;
#line 191 "../providers/Microsoft/Integration.vala"
	_tmp0_ = integration_application_new ();
#line 191 "../providers/Microsoft/Integration.vala"
	app = _tmp0_;
#line 192 "../providers/Microsoft/Integration.vala"
	status = g_application_run ((GApplication*) app, (gint) args_length1, args);
#line 193 "../providers/Microsoft/Integration.vala"
	result = status;
#line 193 "../providers/Microsoft/Integration.vala"
	_g_object_unref0 (app);
#line 193 "../providers/Microsoft/Integration.vala"
	return result;
#line 1330 "Integration.c"
}

int
main (int argc,
      char ** argv)
{
#line 190 "../providers/Microsoft/Integration.vala"
	return integration_application_main (argv, argc);
#line 1339 "Integration.c"
}

IntegrationApplicationApiInfos*
integration_application_api_infos_new (void)
{
	IntegrationApplicationApiInfos* self;
#line 79 "../providers/Microsoft/Integration.vala"
	self = g_slice_new0 (IntegrationApplicationApiInfos);
#line 79 "../providers/Microsoft/Integration.vala"
	integration_application_api_infos_instance_init (self);
#line 79 "../providers/Microsoft/Integration.vala"
	return self;
#line 1352 "Integration.c"
}

static void
integration_application_api_infos_instance_init (IntegrationApplicationApiInfos * self)
{
}

void
integration_application_api_infos_free (IntegrationApplicationApiInfos * self)
{
#line 80 "../providers/Microsoft/Integration.vala"
	_g_free0 (self->access_token);
#line 81 "../providers/Microsoft/Integration.vala"
	_g_free0 (self->client_id);
#line 82 "../providers/Microsoft/Integration.vala"
	_g_free0 (self->redirect_uri);
#line 83 "../providers/Microsoft/Integration.vala"
	_g_object_unref0 (self->account_service);
#line 79 "../providers/Microsoft/Integration.vala"
	g_slice_free (IntegrationApplicationApiInfos, self);
#line 1373 "Integration.c"
}

static void
integration_application_class_init (IntegrationApplicationClass * klass,
                                    gpointer klass_data)
{
#line 20 "../providers/Microsoft/Integration.vala"
	integration_application_parent_class = g_type_class_peek_parent (klass);
#line 20 "../providers/Microsoft/Integration.vala"
	((GApplicationClass *) klass)->command_line = (gint (*) (GApplication*, GApplicationCommandLine*)) integration_application_real_command_line;
#line 20 "../providers/Microsoft/Integration.vala"
	G_OBJECT_CLASS (klass)->finalize = integration_application_finalize;
#line 1386 "Integration.c"
}

static void
integration_application_instance_init (IntegrationApplication * self,
                                       gpointer klass)
{
}

static void
integration_application_finalize (GObject * obj)
{
	IntegrationApplication * self;
#line 20 "../providers/Microsoft/Integration.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_INTEGRATION_APPLICATION, IntegrationApplication);
#line 20 "../providers/Microsoft/Integration.vala"
	G_OBJECT_CLASS (integration_application_parent_class)->finalize (obj);
#line 1403 "Integration.c"
}

GType
integration_application_get_type (void)
{
	static volatile gsize integration_application_type_id__volatile = 0;
	if (g_once_init_enter (&integration_application_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (IntegrationApplicationClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) integration_application_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (IntegrationApplication), 0, (GInstanceInitFunc) integration_application_instance_init, NULL };
		GType integration_application_type_id;
		integration_application_type_id = g_type_register_static (g_application_get_type (), "IntegrationApplication", &g_define_type_info, 0);
		g_once_init_leave (&integration_application_type_id__volatile, integration_application_type_id);
	}
	return integration_application_type_id__volatile;
}

static void
_vala_array_destroy (gpointer array,
                     gint array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gint array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

