/* AccountsManager.c generated by valac 0.45.3, the Vala compiler
 * generated from AccountsManager.vala, do not modify */

/* -*- Mode: vala; indent-tabs-mode: nil; tab-width: 4 -*-*/
/*-
 * Copyright (c) 2013-2015 Pantheon Developers (https://launchpad.net/switchboard-plug-onlineaccounts)
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the
 * Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
 * Boston, MA 02110-1301 USA.
 *
 * Authored by: Corentin Noël <corentin@elementary.io>
 */

#include <glib-object.h>
#include <gee.h>
#include <gio/gio.h>
#include <glib.h>
#include <libaccounts-glib/accounts-glib.h>

#define ONLINE_ACCOUNTS_TYPE_ACCOUNTS_MANAGER (online_accounts_accounts_manager_get_type ())
#define ONLINE_ACCOUNTS_ACCOUNTS_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), ONLINE_ACCOUNTS_TYPE_ACCOUNTS_MANAGER, OnlineAccountsAccountsManager))
#define ONLINE_ACCOUNTS_ACCOUNTS_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), ONLINE_ACCOUNTS_TYPE_ACCOUNTS_MANAGER, OnlineAccountsAccountsManagerClass))
#define ONLINE_ACCOUNTS_IS_ACCOUNTS_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), ONLINE_ACCOUNTS_TYPE_ACCOUNTS_MANAGER))
#define ONLINE_ACCOUNTS_IS_ACCOUNTS_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), ONLINE_ACCOUNTS_TYPE_ACCOUNTS_MANAGER))
#define ONLINE_ACCOUNTS_ACCOUNTS_MANAGER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), ONLINE_ACCOUNTS_TYPE_ACCOUNTS_MANAGER, OnlineAccountsAccountsManagerClass))

typedef struct _OnlineAccountsAccountsManager OnlineAccountsAccountsManager;
typedef struct _OnlineAccountsAccountsManagerClass OnlineAccountsAccountsManagerClass;
typedef struct _OnlineAccountsAccountsManagerPrivate OnlineAccountsAccountsManagerPrivate;

#define ONLINE_ACCOUNTS_TYPE_ACCOUNT (online_accounts_account_get_type ())
#define ONLINE_ACCOUNTS_ACCOUNT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), ONLINE_ACCOUNTS_TYPE_ACCOUNT, OnlineAccountsAccount))
#define ONLINE_ACCOUNTS_ACCOUNT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), ONLINE_ACCOUNTS_TYPE_ACCOUNT, OnlineAccountsAccountClass))
#define ONLINE_ACCOUNTS_IS_ACCOUNT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), ONLINE_ACCOUNTS_TYPE_ACCOUNT))
#define ONLINE_ACCOUNTS_IS_ACCOUNT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), ONLINE_ACCOUNTS_TYPE_ACCOUNT))
#define ONLINE_ACCOUNTS_ACCOUNT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), ONLINE_ACCOUNTS_TYPE_ACCOUNT, OnlineAccountsAccountClass))

typedef struct _OnlineAccountsAccount OnlineAccountsAccount;
typedef struct _OnlineAccountsAccountClass OnlineAccountsAccountClass;
enum  {
	ONLINE_ACCOUNTS_ACCOUNTS_MANAGER_0_PROPERTY,
	ONLINE_ACCOUNTS_ACCOUNTS_MANAGER_NUM_PROPERTIES
};
static GParamSpec* online_accounts_accounts_manager_properties[ONLINE_ACCOUNTS_ACCOUNTS_MANAGER_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define __vala_AgProvider_free0(var) ((var == NULL) ? NULL : (var = (_vala_AgProvider_free (var), NULL)))
enum  {
	ONLINE_ACCOUNTS_ACCOUNTS_MANAGER_ACCOUNT_ADDED_SIGNAL,
	ONLINE_ACCOUNTS_ACCOUNTS_MANAGER_ACCOUNT_REMOVED_SIGNAL,
	ONLINE_ACCOUNTS_ACCOUNTS_MANAGER_NUM_SIGNALS
};
static guint online_accounts_accounts_manager_signals[ONLINE_ACCOUNTS_ACCOUNTS_MANAGER_NUM_SIGNALS] = {0};

struct _OnlineAccountsAccountsManager {
	GObject parent_instance;
	OnlineAccountsAccountsManagerPrivate * priv;
	GeeArrayList* accounts_available;
};

struct _OnlineAccountsAccountsManagerClass {
	GObjectClass parent_class;
};

struct _OnlineAccountsAccountsManagerPrivate {
	OnlineAccountsAccount* to_delete;
};

static gint OnlineAccountsAccountsManager_private_offset;
static gpointer online_accounts_accounts_manager_parent_class = NULL;
static OnlineAccountsAccountsManager* online_accounts_accounts_manager_accounts_manager;
static OnlineAccountsAccountsManager* online_accounts_accounts_manager_accounts_manager = NULL;

GType online_accounts_accounts_manager_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (OnlineAccountsAccountsManager, g_object_unref)
GType online_accounts_account_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (OnlineAccountsAccount, g_object_unref)
void online_accounts_accounts_manager_remove_cached_account (OnlineAccountsAccountsManager* self);
OnlineAccountsAccountsManager* online_accounts_accounts_manager_get_default (void);
static OnlineAccountsAccountsManager* online_accounts_accounts_manager_new (void);
static OnlineAccountsAccountsManager* online_accounts_accounts_manager_construct (GType object_type);
void online_accounts_accounts_manager_add_account (OnlineAccountsAccountsManager* self,
                                                   OnlineAccountsAccount* account);
void online_accounts_account_delete_account (OnlineAccountsAccount* self,
                                             GAsyncReadyCallback _callback_,
                                             gpointer _user_data_);
void online_accounts_account_delete_account_finish (OnlineAccountsAccount* self,
                                                    GAsyncResult* _res_,
                                                    GError** error);
static void ___lambda4_ (OnlineAccountsAccountsManager* self,
                  GObject* obj,
                  GAsyncResult* res);
void online_accounts_accounts_manager_restore_cached_account (OnlineAccountsAccountsManager* self);
static void ____lambda4__gasync_ready_callback (GObject* source_object,
                                         GAsyncResult* res,
                                         gpointer self);
void online_accounts_accounts_manager_remove_account (OnlineAccountsAccountsManager* self,
                                                      OnlineAccountsAccount* account);
static GObject * online_accounts_accounts_manager_constructor (GType type,
                                                        guint n_construct_properties,
                                                        GObjectConstructParam * construct_properties);
static void _vala_AgProvider_free (AgProvider* self);
OnlineAccountsAccount* online_accounts_account_new (AgAccount* account);
OnlineAccountsAccount* online_accounts_account_construct (GType object_type,
                                                          AgAccount* account);
static void online_accounts_accounts_manager_finalize (GObject * obj);

static inline gpointer
online_accounts_accounts_manager_get_instance_private (OnlineAccountsAccountsManager* self)
{
	return G_STRUCT_MEMBER_P (self, OnlineAccountsAccountsManager_private_offset);
}

OnlineAccountsAccountsManager*
online_accounts_accounts_manager_get_default (void)
{
	OnlineAccountsAccountsManager* result = NULL;
	OnlineAccountsAccountsManager* _tmp0_;
	OnlineAccountsAccountsManager* _tmp2_;
#line 33 "../src/AccountsManager.vala"
	_tmp0_ = online_accounts_accounts_manager_accounts_manager;
#line 33 "../src/AccountsManager.vala"
	if (_tmp0_ == NULL) {
#line 137 "AccountsManager.c"
		OnlineAccountsAccountsManager* _tmp1_;
#line 34 "../src/AccountsManager.vala"
		_tmp1_ = online_accounts_accounts_manager_new ();
#line 34 "../src/AccountsManager.vala"
		_g_object_unref0 (online_accounts_accounts_manager_accounts_manager);
#line 34 "../src/AccountsManager.vala"
		online_accounts_accounts_manager_accounts_manager = _tmp1_;
#line 145 "AccountsManager.c"
	}
#line 37 "../src/AccountsManager.vala"
	_tmp2_ = online_accounts_accounts_manager_accounts_manager;
#line 37 "../src/AccountsManager.vala"
	result = _tmp2_;
#line 37 "../src/AccountsManager.vala"
	return result;
#line 153 "AccountsManager.c"
}

static OnlineAccountsAccountsManager*
online_accounts_accounts_manager_construct (GType object_type)
{
	OnlineAccountsAccountsManager * self = NULL;
#line 40 "../src/AccountsManager.vala"
	self = (OnlineAccountsAccountsManager*) g_object_new (object_type, NULL);
#line 40 "../src/AccountsManager.vala"
	return self;
#line 164 "AccountsManager.c"
}

static OnlineAccountsAccountsManager*
online_accounts_accounts_manager_new (void)
{
#line 40 "../src/AccountsManager.vala"
	return online_accounts_accounts_manager_construct (ONLINE_ACCOUNTS_TYPE_ACCOUNTS_MANAGER);
#line 172 "AccountsManager.c"
}

void
online_accounts_accounts_manager_add_account (OnlineAccountsAccountsManager* self,
                                              OnlineAccountsAccount* account)
{
	GeeArrayList* _tmp0_;
#line 66 "../src/AccountsManager.vala"
	g_return_if_fail (self != NULL);
#line 66 "../src/AccountsManager.vala"
	g_return_if_fail (account != NULL);
#line 67 "../src/AccountsManager.vala"
	_tmp0_ = self->accounts_available;
#line 67 "../src/AccountsManager.vala"
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp0_, account);
#line 68 "../src/AccountsManager.vala"
	g_signal_emit (self, online_accounts_accounts_manager_signals[ONLINE_ACCOUNTS_ACCOUNTS_MANAGER_ACCOUNT_ADDED_SIGNAL], 0, account);
#line 190 "AccountsManager.c"
}

static void
___lambda4_ (OnlineAccountsAccountsManager* self,
             GObject* obj,
             GAsyncResult* res)
{
	GError* _inner_error0_ = NULL;
#line 73 "../src/AccountsManager.vala"
	g_return_if_fail (res != NULL);
#line 201 "AccountsManager.c"
	{
#line 75 "../src/AccountsManager.vala"
		online_accounts_account_delete_account_finish (G_TYPE_CHECK_INSTANCE_CAST (obj, ONLINE_ACCOUNTS_TYPE_ACCOUNT, OnlineAccountsAccount), res, &_inner_error0_);
#line 75 "../src/AccountsManager.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 207 "AccountsManager.c"
			goto __catch0_g_error;
		}
#line 76 "../src/AccountsManager.vala"
		_g_object_unref0 (self->priv->to_delete);
#line 76 "../src/AccountsManager.vala"
		self->priv->to_delete = NULL;
#line 214 "AccountsManager.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp0_;
		const gchar* _tmp1_;
#line 74 "../src/AccountsManager.vala"
		e = _inner_error0_;
#line 74 "../src/AccountsManager.vala"
		_inner_error0_ = NULL;
#line 78 "../src/AccountsManager.vala"
		_tmp0_ = e;
#line 78 "../src/AccountsManager.vala"
		_tmp1_ = _tmp0_->message;
#line 78 "../src/AccountsManager.vala"
		g_critical ("AccountsManager.vala:78: %s", _tmp1_);
#line 79 "../src/AccountsManager.vala"
		online_accounts_accounts_manager_restore_cached_account (self);
#line 74 "../src/AccountsManager.vala"
		_g_error_free0 (e);
#line 236 "AccountsManager.c"
	}
	__finally0:
#line 74 "../src/AccountsManager.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 74 "../src/AccountsManager.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 74 "../src/AccountsManager.vala"
		g_clear_error (&_inner_error0_);
#line 74 "../src/AccountsManager.vala"
		return;
#line 247 "AccountsManager.c"
	}
}

static void
____lambda4__gasync_ready_callback (GObject* source_object,
                                    GAsyncResult* res,
                                    gpointer self)
{
#line 73 "../src/AccountsManager.vala"
	___lambda4_ ((OnlineAccountsAccountsManager*) self, source_object, res);
#line 73 "../src/AccountsManager.vala"
	g_object_unref (self);
#line 260 "AccountsManager.c"
}

void
online_accounts_accounts_manager_remove_cached_account (OnlineAccountsAccountsManager* self)
{
	OnlineAccountsAccount* _tmp0_;
#line 71 "../src/AccountsManager.vala"
	g_return_if_fail (self != NULL);
#line 72 "../src/AccountsManager.vala"
	_tmp0_ = self->priv->to_delete;
#line 72 "../src/AccountsManager.vala"
	if (_tmp0_ != NULL) {
#line 273 "AccountsManager.c"
		OnlineAccountsAccount* _tmp1_;
#line 73 "../src/AccountsManager.vala"
		_tmp1_ = self->priv->to_delete;
#line 73 "../src/AccountsManager.vala"
		online_accounts_account_delete_account (_tmp1_, ____lambda4__gasync_ready_callback, g_object_ref (self));
#line 279 "AccountsManager.c"
	}
}

void
online_accounts_accounts_manager_restore_cached_account (OnlineAccountsAccountsManager* self)
{
	OnlineAccountsAccount* _tmp0_;
#line 86 "../src/AccountsManager.vala"
	g_return_if_fail (self != NULL);
#line 87 "../src/AccountsManager.vala"
	_tmp0_ = self->priv->to_delete;
#line 87 "../src/AccountsManager.vala"
	if (_tmp0_ != NULL) {
#line 293 "AccountsManager.c"
		OnlineAccountsAccount* _tmp1_;
#line 88 "../src/AccountsManager.vala"
		_tmp1_ = self->priv->to_delete;
#line 88 "../src/AccountsManager.vala"
		online_accounts_accounts_manager_add_account (self, _tmp1_);
#line 299 "AccountsManager.c"
	}
#line 91 "../src/AccountsManager.vala"
	_g_object_unref0 (self->priv->to_delete);
#line 91 "../src/AccountsManager.vala"
	self->priv->to_delete = NULL;
#line 305 "AccountsManager.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 98 "../src/AccountsManager.vala"
	return self ? g_object_ref (self) : NULL;
#line 313 "AccountsManager.c"
}

void
online_accounts_accounts_manager_remove_account (OnlineAccountsAccountsManager* self,
                                                 OnlineAccountsAccount* account)
{
	GeeArrayList* _tmp0_;
	OnlineAccountsAccount* _tmp1_;
#line 94 "../src/AccountsManager.vala"
	g_return_if_fail (self != NULL);
#line 94 "../src/AccountsManager.vala"
	g_return_if_fail (account != NULL);
#line 95 "../src/AccountsManager.vala"
	_tmp0_ = self->accounts_available;
#line 95 "../src/AccountsManager.vala"
	gee_abstract_collection_remove ((GeeAbstractCollection*) _tmp0_, account);
#line 96 "../src/AccountsManager.vala"
	online_accounts_accounts_manager_remove_cached_account (self);
#line 98 "../src/AccountsManager.vala"
	_tmp1_ = _g_object_ref0 (account);
#line 98 "../src/AccountsManager.vala"
	_g_object_unref0 (self->priv->to_delete);
#line 98 "../src/AccountsManager.vala"
	self->priv->to_delete = _tmp1_;
#line 99 "../src/AccountsManager.vala"
	g_signal_emit (self, online_accounts_accounts_manager_signals[ONLINE_ACCOUNTS_ACCOUNTS_MANAGER_ACCOUNT_REMOVED_SIGNAL], 0, account);
#line 340 "AccountsManager.c"
}

static void
_vala_AgProvider_free (AgProvider* self)
{
#line 52 "../src/AccountsManager.vala"
	g_boxed_free (ag_provider_get_type (), self);
#line 348 "AccountsManager.c"
}

static GObject *
online_accounts_accounts_manager_constructor (GType type,
                                              guint n_construct_properties,
                                              GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	OnlineAccountsAccountsManager * self;
	GeeArrayList* _tmp0_;
	AgManager* manager = NULL;
	AgManager* _tmp1_;
	AgManager* _tmp2_;
	GList* _tmp3_;
	GError* _inner_error0_ = NULL;
#line 44 "../src/AccountsManager.vala"
	parent_class = G_OBJECT_CLASS (online_accounts_accounts_manager_parent_class);
#line 44 "../src/AccountsManager.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 44 "../src/AccountsManager.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, ONLINE_ACCOUNTS_TYPE_ACCOUNTS_MANAGER, OnlineAccountsAccountsManager);
#line 45 "../src/AccountsManager.vala"
	_tmp0_ = gee_array_list_new (ONLINE_ACCOUNTS_TYPE_ACCOUNT, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 45 "../src/AccountsManager.vala"
	_g_object_unref0 (self->accounts_available);
#line 45 "../src/AccountsManager.vala"
	self->accounts_available = _tmp0_;
#line 46 "../src/AccountsManager.vala"
	_tmp1_ = ag_manager_new ();
#line 46 "../src/AccountsManager.vala"
	manager = _tmp1_;
#line 47 "../src/AccountsManager.vala"
	_tmp2_ = manager;
#line 47 "../src/AccountsManager.vala"
	_tmp3_ = ag_manager_list_enabled (_tmp2_);
#line 385 "AccountsManager.c"
	{
		GList* accountid_collection = NULL;
		GList* accountid_it = NULL;
#line 47 "../src/AccountsManager.vala"
		accountid_collection = _tmp3_;
#line 47 "../src/AccountsManager.vala"
		for (accountid_it = accountid_collection; accountid_it != NULL; accountid_it = accountid_it->next) {
#line 393 "AccountsManager.c"
			guint accountid = 0U;
#line 47 "../src/AccountsManager.vala"
			accountid = (guint) ((guintptr) accountid_it->data);
#line 397 "AccountsManager.c"
			{
				{
					AgAccount* ag_account = NULL;
					AgManager* _tmp4_;
					AgAccount* _tmp5_;
					AgProvider* provider = NULL;
					AgManager* _tmp6_;
					AgAccount* _tmp7_;
					const gchar* _tmp8_;
					AgProvider* _tmp9_;
					AgProvider* _tmp10_;
					OnlineAccountsAccount* account = NULL;
					AgAccount* _tmp11_;
					OnlineAccountsAccount* _tmp12_;
					OnlineAccountsAccount* _tmp13_;
#line 49 "../src/AccountsManager.vala"
					_tmp4_ = manager;
#line 49 "../src/AccountsManager.vala"
					_tmp5_ = ag_manager_load_account (_tmp4_, (AgAccountId) accountid, &_inner_error0_);
#line 49 "../src/AccountsManager.vala"
					ag_account = _tmp5_;
#line 49 "../src/AccountsManager.vala"
					if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 421 "AccountsManager.c"
						goto __catch1_g_error;
					}
#line 50 "../src/AccountsManager.vala"
					_tmp6_ = manager;
#line 50 "../src/AccountsManager.vala"
					_tmp7_ = ag_account;
#line 50 "../src/AccountsManager.vala"
					_tmp8_ = ag_account_get_provider_name (_tmp7_);
#line 50 "../src/AccountsManager.vala"
					_tmp9_ = ag_manager_get_provider (_tmp6_, _tmp8_);
#line 50 "../src/AccountsManager.vala"
					provider = _tmp9_;
#line 51 "../src/AccountsManager.vala"
					_tmp10_ = provider;
#line 51 "../src/AccountsManager.vala"
					if (_tmp10_ == NULL) {
#line 52 "../src/AccountsManager.vala"
						__vala_AgProvider_free0 (provider);
#line 52 "../src/AccountsManager.vala"
						_g_object_unref0 (ag_account);
#line 52 "../src/AccountsManager.vala"
						continue;
#line 444 "AccountsManager.c"
					}
#line 54 "../src/AccountsManager.vala"
					_tmp11_ = ag_account;
#line 54 "../src/AccountsManager.vala"
					_tmp12_ = online_accounts_account_new (_tmp11_);
#line 54 "../src/AccountsManager.vala"
					account = _tmp12_;
#line 55 "../src/AccountsManager.vala"
					_tmp13_ = account;
#line 55 "../src/AccountsManager.vala"
					online_accounts_accounts_manager_add_account (self, _tmp13_);
#line 48 "../src/AccountsManager.vala"
					_g_object_unref0 (account);
#line 48 "../src/AccountsManager.vala"
					__vala_AgProvider_free0 (provider);
#line 48 "../src/AccountsManager.vala"
					_g_object_unref0 (ag_account);
#line 462 "AccountsManager.c"
				}
				goto __finally1;
				__catch1_g_error:
				{
					GError* e = NULL;
					GError* _tmp14_;
					const gchar* _tmp15_;
#line 48 "../src/AccountsManager.vala"
					e = _inner_error0_;
#line 48 "../src/AccountsManager.vala"
					_inner_error0_ = NULL;
#line 57 "../src/AccountsManager.vala"
					_tmp14_ = e;
#line 57 "../src/AccountsManager.vala"
					_tmp15_ = _tmp14_->message;
#line 57 "../src/AccountsManager.vala"
					g_critical ("AccountsManager.vala:57: %s", _tmp15_);
#line 48 "../src/AccountsManager.vala"
					_g_error_free0 (e);
#line 482 "AccountsManager.c"
				}
				__finally1:
#line 48 "../src/AccountsManager.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 48 "../src/AccountsManager.vala"
					(accountid_collection == NULL) ? NULL : (accountid_collection = (g_list_free (accountid_collection), NULL));
#line 48 "../src/AccountsManager.vala"
					_g_object_unref0 (manager);
#line 48 "../src/AccountsManager.vala"
					g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 48 "../src/AccountsManager.vala"
					g_clear_error (&_inner_error0_);
#line 495 "AccountsManager.c"
				}
			}
		}
#line 47 "../src/AccountsManager.vala"
		(accountid_collection == NULL) ? NULL : (accountid_collection = (g_list_free (accountid_collection), NULL));
#line 501 "AccountsManager.c"
	}
#line 44 "../src/AccountsManager.vala"
	_g_object_unref0 (manager);
#line 44 "../src/AccountsManager.vala"
	return obj;
#line 507 "AccountsManager.c"
}

static void
online_accounts_accounts_manager_class_init (OnlineAccountsAccountsManagerClass * klass,
                                             gpointer klass_data)
{
#line 23 "../src/AccountsManager.vala"
	online_accounts_accounts_manager_parent_class = g_type_class_peek_parent (klass);
#line 23 "../src/AccountsManager.vala"
	g_type_class_adjust_private_offset (klass, &OnlineAccountsAccountsManager_private_offset);
#line 23 "../src/AccountsManager.vala"
	G_OBJECT_CLASS (klass)->constructor = online_accounts_accounts_manager_constructor;
#line 23 "../src/AccountsManager.vala"
	G_OBJECT_CLASS (klass)->finalize = online_accounts_accounts_manager_finalize;
#line 23 "../src/AccountsManager.vala"
	online_accounts_accounts_manager_signals[ONLINE_ACCOUNTS_ACCOUNTS_MANAGER_ACCOUNT_ADDED_SIGNAL] = g_signal_new ("account-added", ONLINE_ACCOUNTS_TYPE_ACCOUNTS_MANAGER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, ONLINE_ACCOUNTS_TYPE_ACCOUNT);
#line 23 "../src/AccountsManager.vala"
	online_accounts_accounts_manager_signals[ONLINE_ACCOUNTS_ACCOUNTS_MANAGER_ACCOUNT_REMOVED_SIGNAL] = g_signal_new ("account-removed", ONLINE_ACCOUNTS_TYPE_ACCOUNTS_MANAGER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, ONLINE_ACCOUNTS_TYPE_ACCOUNT);
#line 526 "AccountsManager.c"
}

static void
online_accounts_accounts_manager_instance_init (OnlineAccountsAccountsManager * self,
                                                gpointer klass)
{
#line 23 "../src/AccountsManager.vala"
	self->priv = online_accounts_accounts_manager_get_instance_private (self);
#line 535 "AccountsManager.c"
}

static void
online_accounts_accounts_manager_finalize (GObject * obj)
{
	OnlineAccountsAccountsManager * self;
#line 23 "../src/AccountsManager.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, ONLINE_ACCOUNTS_TYPE_ACCOUNTS_MANAGER, OnlineAccountsAccountsManager);
#line 63 "../src/AccountsManager.vala"
	online_accounts_accounts_manager_remove_cached_account (self);
#line 24 "../src/AccountsManager.vala"
	_g_object_unref0 (self->accounts_available);
#line 25 "../src/AccountsManager.vala"
	_g_object_unref0 (self->priv->to_delete);
#line 23 "../src/AccountsManager.vala"
	G_OBJECT_CLASS (online_accounts_accounts_manager_parent_class)->finalize (obj);
#line 552 "AccountsManager.c"
}

GType
online_accounts_accounts_manager_get_type (void)
{
	static volatile gsize online_accounts_accounts_manager_type_id__volatile = 0;
	if (g_once_init_enter (&online_accounts_accounts_manager_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (OnlineAccountsAccountsManagerClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) online_accounts_accounts_manager_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (OnlineAccountsAccountsManager), 0, (GInstanceInitFunc) online_accounts_accounts_manager_instance_init, NULL };
		GType online_accounts_accounts_manager_type_id;
		online_accounts_accounts_manager_type_id = g_type_register_static (G_TYPE_OBJECT, "OnlineAccountsAccountsManager", &g_define_type_info, 0);
		OnlineAccountsAccountsManager_private_offset = g_type_add_instance_private (online_accounts_accounts_manager_type_id, sizeof (OnlineAccountsAccountsManagerPrivate));
		g_once_init_leave (&online_accounts_accounts_manager_type_id__volatile, online_accounts_accounts_manager_type_id);
	}
	return online_accounts_accounts_manager_type_id__volatile;
}

