/* Dialog.c generated by valac 0.45.3, the Vala compiler
 * generated from Dialog.vala, do not modify */

/* -*- Mode: vala; indent-tabs-mode: nil; tab-width: 4 -*-*/
/*-
 * Copyright (c) 2013-2015 Pantheon Developers (https://launchpad.net/switchboard-plug-onlineaccounts)
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the
 * Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
 * Boston, MA 02110-1301 USA.
 *
 * Authored by: Corentin Noël <corentin@elementary.io>
 */

#include <glib-object.h>
#include <gtk/gtk.h>
#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include <switchboard.h>

typedef enum  {
	ONLINE_ACCOUNTS_SIGNON_UI_ERROR_NONE,
	ONLINE_ACCOUNTS_SIGNON_UI_ERROR_GENERAL,
	ONLINE_ACCOUNTS_SIGNON_UI_ERROR_NO_SIGNONUI,
	ONLINE_ACCOUNTS_SIGNON_UI_ERROR_BAD_PARAMETERS,
	ONLINE_ACCOUNTS_SIGNON_UI_ERROR_CANCELED,
	ONLINE_ACCOUNTS_SIGNON_UI_ERROR_NOT_AVAILABLE,
	ONLINE_ACCOUNTS_SIGNON_UI_ERROR_BAD_URL,
	ONLINE_ACCOUNTS_SIGNON_UI_ERROR_BAD_CAPTCHA,
	ONLINE_ACCOUNTS_SIGNON_UI_ERROR_BAD_CAPTCHA_URL,
	ONLINE_ACCOUNTS_SIGNON_UI_ERROR_REFRESH_FAILED,
	ONLINE_ACCOUNTS_SIGNON_UI_ERROR_FORBIDDEN,
	ONLINE_ACCOUNTS_SIGNON_UI_ERROR_FORGOT_PASSWORD
} OnlineAccountsSignonUIError;

#define ONLINE_ACCOUNTS_TYPE_SIGNON_UI_ERROR (online_accounts_signon_ui_error_get_type ())

#define ONLINE_ACCOUNTS_TYPE_DIALOG (online_accounts_dialog_get_type ())
#define ONLINE_ACCOUNTS_DIALOG(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), ONLINE_ACCOUNTS_TYPE_DIALOG, OnlineAccountsDialog))
#define ONLINE_ACCOUNTS_DIALOG_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), ONLINE_ACCOUNTS_TYPE_DIALOG, OnlineAccountsDialogClass))
#define ONLINE_ACCOUNTS_IS_DIALOG(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), ONLINE_ACCOUNTS_TYPE_DIALOG))
#define ONLINE_ACCOUNTS_IS_DIALOG_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), ONLINE_ACCOUNTS_TYPE_DIALOG))
#define ONLINE_ACCOUNTS_DIALOG_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), ONLINE_ACCOUNTS_TYPE_DIALOG, OnlineAccountsDialogClass))

typedef struct _OnlineAccountsDialog OnlineAccountsDialog;
typedef struct _OnlineAccountsDialogClass OnlineAccountsDialogClass;
typedef struct _OnlineAccountsDialogPrivate OnlineAccountsDialogPrivate;
enum  {
	ONLINE_ACCOUNTS_DIALOG_0_PROPERTY,
	ONLINE_ACCOUNTS_DIALOG_NUM_PROPERTIES
};
static GParamSpec* online_accounts_dialog_properties[ONLINE_ACCOUNTS_DIALOG_NUM_PROPERTIES];
#define _g_hash_table_unref0(var) ((var == NULL) ? NULL : (var = (g_hash_table_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))

#define ONLINE_ACCOUNTS_TYPE_PLUG (online_accounts_plug_get_type ())
#define ONLINE_ACCOUNTS_PLUG(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), ONLINE_ACCOUNTS_TYPE_PLUG, OnlineAccountsPlug))
#define ONLINE_ACCOUNTS_PLUG_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), ONLINE_ACCOUNTS_TYPE_PLUG, OnlineAccountsPlugClass))
#define ONLINE_ACCOUNTS_IS_PLUG(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), ONLINE_ACCOUNTS_TYPE_PLUG))
#define ONLINE_ACCOUNTS_IS_PLUG_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), ONLINE_ACCOUNTS_TYPE_PLUG))
#define ONLINE_ACCOUNTS_PLUG_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), ONLINE_ACCOUNTS_TYPE_PLUG, OnlineAccountsPlugClass))

typedef struct _OnlineAccountsPlug OnlineAccountsPlug;
typedef struct _OnlineAccountsPlugClass OnlineAccountsPlugClass;
#define _g_variant_unref0(var) ((var == NULL) ? NULL : (var = (g_variant_unref (var), NULL)))
enum  {
	ONLINE_ACCOUNTS_DIALOG_FINISHED_SIGNAL,
	ONLINE_ACCOUNTS_DIALOG_NUM_SIGNALS
};
static guint online_accounts_dialog_signals[ONLINE_ACCOUNTS_DIALOG_NUM_SIGNALS] = {0};

struct _OnlineAccountsDialog {
	GtkGrid parent_instance;
	OnlineAccountsDialogPrivate * priv;
	GHashTable* parameters;
	gchar* request_id;
	OnlineAccountsSignonUIError error_code;
};

struct _OnlineAccountsDialogClass {
	GtkGridClass parent_class;
	GHashTable* (*get_reply) (OnlineAccountsDialog* self);
	gboolean (*set_parameters) (OnlineAccountsDialog* self, GHashTable* params);
	gboolean (*refresh_captcha) (OnlineAccountsDialog* self, const gchar* uri);
};

static gpointer online_accounts_dialog_parent_class = NULL;
extern OnlineAccountsPlug* online_accounts_plug;

GType online_accounts_signon_ui_error_get_type (void) G_GNUC_CONST;
GType online_accounts_dialog_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (OnlineAccountsDialog, g_object_unref)
OnlineAccountsDialog* online_accounts_dialog_construct (GType object_type,
                                                        GHashTable* parameter);
GType online_accounts_plug_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (OnlineAccountsPlug, g_object_unref)
static void __lambda17_ (OnlineAccountsDialog* self);
static void ___lambda17__online_accounts_plug_hide_request (OnlineAccountsPlug* _sender,
                                                     gpointer self);
GHashTable* online_accounts_dialog_get_reply (OnlineAccountsDialog* self);
static GHashTable* online_accounts_dialog_real_get_reply (OnlineAccountsDialog* self);
static void _g_free0_ (gpointer var);
static void _g_variant_unref0_ (gpointer var);
#define ONLINE_ACCOUNTS_KEY_QUERY_ERROR_CODE "QueryErrorCode"
gboolean online_accounts_dialog_set_parameters (OnlineAccountsDialog* self,
                                                GHashTable* params);
static gboolean online_accounts_dialog_real_set_parameters (OnlineAccountsDialog* self,
                                                     GHashTable* params);
static gboolean online_accounts_dialog_validate_params (OnlineAccountsDialog* self,
                                                 GHashTable* params);
gboolean online_accounts_dialog_refresh_captcha (OnlineAccountsDialog* self,
                                                 const gchar* uri);
static gboolean online_accounts_dialog_real_refresh_captcha (OnlineAccountsDialog* self,
                                                      const gchar* uri);
#define ONLINE_ACCOUNTS_KEY_REQUEST_ID "RequestId"
static void online_accounts_dialog_finalize (GObject * obj);

GType
online_accounts_signon_ui_error_get_type (void)
{
	static volatile gsize online_accounts_signon_ui_error_type_id__volatile = 0;
	if (g_once_init_enter (&online_accounts_signon_ui_error_type_id__volatile)) {
		static const GEnumValue values[] = {{ONLINE_ACCOUNTS_SIGNON_UI_ERROR_NONE, "ONLINE_ACCOUNTS_SIGNON_UI_ERROR_NONE", "none"}, {ONLINE_ACCOUNTS_SIGNON_UI_ERROR_GENERAL, "ONLINE_ACCOUNTS_SIGNON_UI_ERROR_GENERAL", "general"}, {ONLINE_ACCOUNTS_SIGNON_UI_ERROR_NO_SIGNONUI, "ONLINE_ACCOUNTS_SIGNON_UI_ERROR_NO_SIGNONUI", "no-signonui"}, {ONLINE_ACCOUNTS_SIGNON_UI_ERROR_BAD_PARAMETERS, "ONLINE_ACCOUNTS_SIGNON_UI_ERROR_BAD_PARAMETERS", "bad-parameters"}, {ONLINE_ACCOUNTS_SIGNON_UI_ERROR_CANCELED, "ONLINE_ACCOUNTS_SIGNON_UI_ERROR_CANCELED", "canceled"}, {ONLINE_ACCOUNTS_SIGNON_UI_ERROR_NOT_AVAILABLE, "ONLINE_ACCOUNTS_SIGNON_UI_ERROR_NOT_AVAILABLE", "not-available"}, {ONLINE_ACCOUNTS_SIGNON_UI_ERROR_BAD_URL, "ONLINE_ACCOUNTS_SIGNON_UI_ERROR_BAD_URL", "bad-url"}, {ONLINE_ACCOUNTS_SIGNON_UI_ERROR_BAD_CAPTCHA, "ONLINE_ACCOUNTS_SIGNON_UI_ERROR_BAD_CAPTCHA", "bad-captcha"}, {ONLINE_ACCOUNTS_SIGNON_UI_ERROR_BAD_CAPTCHA_URL, "ONLINE_ACCOUNTS_SIGNON_UI_ERROR_BAD_CAPTCHA_URL", "bad-captcha-url"}, {ONLINE_ACCOUNTS_SIGNON_UI_ERROR_REFRESH_FAILED, "ONLINE_ACCOUNTS_SIGNON_UI_ERROR_REFRESH_FAILED", "refresh-failed"}, {ONLINE_ACCOUNTS_SIGNON_UI_ERROR_FORBIDDEN, "ONLINE_ACCOUNTS_SIGNON_UI_ERROR_FORBIDDEN", "forbidden"}, {ONLINE_ACCOUNTS_SIGNON_UI_ERROR_FORGOT_PASSWORD, "ONLINE_ACCOUNTS_SIGNON_UI_ERROR_FORGOT_PASSWORD", "forgot-password"}, {0, NULL, NULL}};
		GType online_accounts_signon_ui_error_type_id;
		online_accounts_signon_ui_error_type_id = g_enum_register_static ("OnlineAccountsSignonUIError", values);
		g_once_init_leave (&online_accounts_signon_ui_error_type_id__volatile, online_accounts_signon_ui_error_type_id);
	}
	return online_accounts_signon_ui_error_type_id__volatile;
}

static gpointer
_g_hash_table_ref0 (gpointer self)
{
#line 48 "../src/Authentification/Dialog.vala"
	return self ? g_hash_table_ref (self) : NULL;
#line 149 "Dialog.c"
}

static void
__lambda17_ (OnlineAccountsDialog* self)
{
#line 50 "../src/Authentification/Dialog.vala"
	self->error_code = ONLINE_ACCOUNTS_SIGNON_UI_ERROR_CANCELED;
#line 51 "../src/Authentification/Dialog.vala"
	g_signal_emit (self, online_accounts_dialog_signals[ONLINE_ACCOUNTS_DIALOG_FINISHED_SIGNAL], 0);
#line 159 "Dialog.c"
}

static void
___lambda17__online_accounts_plug_hide_request (OnlineAccountsPlug* _sender,
                                                gpointer self)
{
#line 49 "../src/Authentification/Dialog.vala"
	__lambda17_ ((OnlineAccountsDialog*) self);
#line 168 "Dialog.c"
}

OnlineAccountsDialog*
online_accounts_dialog_construct (GType object_type,
                                  GHashTable* parameter)
{
	OnlineAccountsDialog * self = NULL;
	GHashTable* _tmp0_;
	OnlineAccountsPlug* _tmp1_;
#line 46 "../src/Authentification/Dialog.vala"
	g_return_val_if_fail (parameter != NULL, NULL);
#line 46 "../src/Authentification/Dialog.vala"
	self = (OnlineAccountsDialog*) g_object_new (object_type, NULL);
#line 47 "../src/Authentification/Dialog.vala"
	self->error_code = ONLINE_ACCOUNTS_SIGNON_UI_ERROR_NONE;
#line 48 "../src/Authentification/Dialog.vala"
	_tmp0_ = _g_hash_table_ref0 (parameter);
#line 48 "../src/Authentification/Dialog.vala"
	_g_hash_table_unref0 (self->parameters);
#line 48 "../src/Authentification/Dialog.vala"
	self->parameters = _tmp0_;
#line 49 "../src/Authentification/Dialog.vala"
	_tmp1_ = online_accounts_plug;
#line 49 "../src/Authentification/Dialog.vala"
	g_signal_connect_object (_tmp1_, "hide-request", (GCallback) ___lambda17__online_accounts_plug_hide_request, self, 0);
#line 46 "../src/Authentification/Dialog.vala"
	return self;
#line 196 "Dialog.c"
}

static void
_g_free0_ (gpointer var)
{
#line 56 "../src/Authentification/Dialog.vala"
	var = (g_free (var), NULL);
#line 204 "Dialog.c"
}

static void
_g_variant_unref0_ (gpointer var)
{
#line 56 "../src/Authentification/Dialog.vala"
	(var == NULL) ? NULL : (var = (g_variant_unref (var), NULL));
#line 212 "Dialog.c"
}

static GHashTable*
online_accounts_dialog_real_get_reply (OnlineAccountsDialog* self)
{
	GHashTable* result = NULL;
	GHashTable* reply = NULL;
	GHashFunc _tmp0_;
	GEqualFunc _tmp1_;
	GHashTable* _tmp2_;
	gchar* _tmp3_;
	OnlineAccountsSignonUIError _tmp4_;
	GVariant* _tmp5_;
#line 56 "../src/Authentification/Dialog.vala"
	_tmp0_ = g_str_hash;
#line 56 "../src/Authentification/Dialog.vala"
	_tmp1_ = g_str_equal;
#line 56 "../src/Authentification/Dialog.vala"
	_tmp2_ = g_hash_table_new_full (_tmp0_, _tmp1_, _g_free0_, _g_variant_unref0_);
#line 56 "../src/Authentification/Dialog.vala"
	reply = _tmp2_;
#line 57 "../src/Authentification/Dialog.vala"
	_tmp3_ = g_strdup (ONLINE_ACCOUNTS_KEY_QUERY_ERROR_CODE);
#line 57 "../src/Authentification/Dialog.vala"
	_tmp4_ = self->error_code;
#line 57 "../src/Authentification/Dialog.vala"
	_tmp5_ = g_variant_new_uint32 ((guint32) _tmp4_);
#line 57 "../src/Authentification/Dialog.vala"
	g_variant_ref_sink (_tmp5_);
#line 57 "../src/Authentification/Dialog.vala"
	g_hash_table_insert (reply, _tmp3_, _tmp5_);
#line 59 "../src/Authentification/Dialog.vala"
	result = reply;
#line 59 "../src/Authentification/Dialog.vala"
	return result;
#line 248 "Dialog.c"
}

GHashTable*
online_accounts_dialog_get_reply (OnlineAccountsDialog* self)
{
#line 55 "../src/Authentification/Dialog.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 55 "../src/Authentification/Dialog.vala"
	return ONLINE_ACCOUNTS_DIALOG_GET_CLASS (self)->get_reply (self);
#line 258 "Dialog.c"
}

static gboolean
online_accounts_dialog_real_set_parameters (OnlineAccountsDialog* self,
                                            GHashTable* params)
{
	gboolean result = FALSE;
	GHashTable* _tmp0_;
#line 62 "../src/Authentification/Dialog.vala"
	g_return_val_if_fail (params != NULL, FALSE);
#line 63 "../src/Authentification/Dialog.vala"
	_tmp0_ = _g_hash_table_ref0 (params);
#line 63 "../src/Authentification/Dialog.vala"
	_g_hash_table_unref0 (self->parameters);
#line 63 "../src/Authentification/Dialog.vala"
	self->parameters = _tmp0_;
#line 64 "../src/Authentification/Dialog.vala"
	if (!online_accounts_dialog_validate_params (self, params)) {
#line 65 "../src/Authentification/Dialog.vala"
		self->error_code = ONLINE_ACCOUNTS_SIGNON_UI_ERROR_BAD_PARAMETERS;
#line 66 "../src/Authentification/Dialog.vala"
		g_warning ("Dialog.vala:66: Bad parameters");
#line 67 "../src/Authentification/Dialog.vala"
		result = FALSE;
#line 67 "../src/Authentification/Dialog.vala"
		return result;
#line 285 "Dialog.c"
	}
#line 70 "../src/Authentification/Dialog.vala"
	result = TRUE;
#line 70 "../src/Authentification/Dialog.vala"
	return result;
#line 291 "Dialog.c"
}

gboolean
online_accounts_dialog_set_parameters (OnlineAccountsDialog* self,
                                       GHashTable* params)
{
#line 62 "../src/Authentification/Dialog.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 62 "../src/Authentification/Dialog.vala"
	return ONLINE_ACCOUNTS_DIALOG_GET_CLASS (self)->set_parameters (self, params);
#line 302 "Dialog.c"
}

static gboolean
online_accounts_dialog_real_refresh_captcha (OnlineAccountsDialog* self,
                                             const gchar* uri)
{
	gboolean _tmp0_ = FALSE;
#line 73 "../src/Authentification/Dialog.vala"
	g_critical ("Type `%s' does not implement abstract method `online_accounts_dialog_refresh_captcha'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 73 "../src/Authentification/Dialog.vala"
	return _tmp0_;
#line 314 "Dialog.c"
}

gboolean
online_accounts_dialog_refresh_captcha (OnlineAccountsDialog* self,
                                        const gchar* uri)
{
#line 73 "../src/Authentification/Dialog.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 73 "../src/Authentification/Dialog.vala"
	return ONLINE_ACCOUNTS_DIALOG_GET_CLASS (self)->refresh_captcha (self, uri);
#line 325 "Dialog.c"
}

static gpointer
_g_variant_ref0 (gpointer self)
{
#line 76 "../src/Authentification/Dialog.vala"
	return self ? g_variant_ref (self) : NULL;
#line 333 "Dialog.c"
}

static gboolean
online_accounts_dialog_validate_params (OnlineAccountsDialog* self,
                                        GHashTable* params)
{
	gboolean result = FALSE;
	GVariant* value = NULL;
	gconstpointer _tmp0_;
	GVariant* _tmp1_;
	gboolean _tmp2_ = FALSE;
	GVariant* _tmp3_;
	GVariant* _tmp10_;
	const gchar* _tmp11_;
	gchar* _tmp12_;
#line 75 "../src/Authentification/Dialog.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 75 "../src/Authentification/Dialog.vala"
	g_return_val_if_fail (params != NULL, FALSE);
#line 76 "../src/Authentification/Dialog.vala"
	_tmp0_ = g_hash_table_lookup (params, ONLINE_ACCOUNTS_KEY_REQUEST_ID);
#line 76 "../src/Authentification/Dialog.vala"
	_tmp1_ = _g_variant_ref0 ((GVariant*) _tmp0_);
#line 76 "../src/Authentification/Dialog.vala"
	value = _tmp1_;
#line 77 "../src/Authentification/Dialog.vala"
	_tmp3_ = value;
#line 77 "../src/Authentification/Dialog.vala"
	if (_tmp3_ == NULL) {
#line 77 "../src/Authentification/Dialog.vala"
		_tmp2_ = TRUE;
#line 365 "Dialog.c"
	} else {
		GVariant* _tmp4_;
		const GVariantType* _tmp5_;
#line 77 "../src/Authentification/Dialog.vala"
		_tmp4_ = value;
#line 77 "../src/Authentification/Dialog.vala"
		_tmp5_ = G_VARIANT_TYPE_STRING;
#line 77 "../src/Authentification/Dialog.vala"
		_tmp2_ = g_variant_is_of_type (_tmp4_, _tmp5_) == FALSE;
#line 375 "Dialog.c"
	}
#line 77 "../src/Authentification/Dialog.vala"
	if (_tmp2_) {
#line 379 "Dialog.c"
		const gchar* _tmp6_ = NULL;
		GVariant* _tmp7_;
#line 78 "../src/Authentification/Dialog.vala"
		_tmp7_ = value;
#line 78 "../src/Authentification/Dialog.vala"
		if (_tmp7_ != NULL) {
#line 386 "Dialog.c"
			GVariant* _tmp8_;
			const gchar* _tmp9_;
#line 78 "../src/Authentification/Dialog.vala"
			_tmp8_ = value;
#line 78 "../src/Authentification/Dialog.vala"
			_tmp9_ = g_variant_get_type_string (_tmp8_);
#line 78 "../src/Authentification/Dialog.vala"
			_tmp6_ = _tmp9_;
#line 395 "Dialog.c"
		} else {
#line 78 "../src/Authentification/Dialog.vala"
			_tmp6_ = "null request id";
#line 399 "Dialog.c"
		}
#line 78 "../src/Authentification/Dialog.vala"
		g_debug ("Dialog.vala:78: Wrong request id : %s", _tmp6_);
#line 79 "../src/Authentification/Dialog.vala"
		result = FALSE;
#line 79 "../src/Authentification/Dialog.vala"
		_g_variant_unref0 (value);
#line 79 "../src/Authentification/Dialog.vala"
		return result;
#line 409 "Dialog.c"
	}
#line 82 "../src/Authentification/Dialog.vala"
	_tmp10_ = value;
#line 82 "../src/Authentification/Dialog.vala"
	_tmp11_ = g_variant_get_string (_tmp10_, NULL);
#line 82 "../src/Authentification/Dialog.vala"
	_tmp12_ = g_strdup (_tmp11_);
#line 82 "../src/Authentification/Dialog.vala"
	_g_free0 (self->request_id);
#line 82 "../src/Authentification/Dialog.vala"
	self->request_id = _tmp12_;
#line 83 "../src/Authentification/Dialog.vala"
	result = TRUE;
#line 83 "../src/Authentification/Dialog.vala"
	_g_variant_unref0 (value);
#line 83 "../src/Authentification/Dialog.vala"
	return result;
#line 427 "Dialog.c"
}

static void
online_accounts_dialog_class_init (OnlineAccountsDialogClass * klass,
                                   gpointer klass_data)
{
#line 38 "../src/Authentification/Dialog.vala"
	online_accounts_dialog_parent_class = g_type_class_peek_parent (klass);
#line 38 "../src/Authentification/Dialog.vala"
	((OnlineAccountsDialogClass *) klass)->get_reply = (GHashTable* (*) (OnlineAccountsDialog*)) online_accounts_dialog_real_get_reply;
#line 38 "../src/Authentification/Dialog.vala"
	((OnlineAccountsDialogClass *) klass)->set_parameters = (gboolean (*) (OnlineAccountsDialog*, GHashTable*)) online_accounts_dialog_real_set_parameters;
#line 38 "../src/Authentification/Dialog.vala"
	((OnlineAccountsDialogClass *) klass)->refresh_captcha = (gboolean (*) (OnlineAccountsDialog*, const gchar*)) online_accounts_dialog_real_refresh_captcha;
#line 38 "../src/Authentification/Dialog.vala"
	G_OBJECT_CLASS (klass)->finalize = online_accounts_dialog_finalize;
#line 38 "../src/Authentification/Dialog.vala"
	online_accounts_dialog_signals[ONLINE_ACCOUNTS_DIALOG_FINISHED_SIGNAL] = g_signal_new ("finished", ONLINE_ACCOUNTS_TYPE_DIALOG, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 446 "Dialog.c"
}

static void
online_accounts_dialog_instance_init (OnlineAccountsDialog * self,
                                      gpointer klass)
{
}

static void
online_accounts_dialog_finalize (GObject * obj)
{
	OnlineAccountsDialog * self;
#line 38 "../src/Authentification/Dialog.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, ONLINE_ACCOUNTS_TYPE_DIALOG, OnlineAccountsDialog);
#line 42 "../src/Authentification/Dialog.vala"
	_g_hash_table_unref0 (self->parameters);
#line 43 "../src/Authentification/Dialog.vala"
	_g_free0 (self->request_id);
#line 38 "../src/Authentification/Dialog.vala"
	G_OBJECT_CLASS (online_accounts_dialog_parent_class)->finalize (obj);
#line 467 "Dialog.c"
}

GType
online_accounts_dialog_get_type (void)
{
	static volatile gsize online_accounts_dialog_type_id__volatile = 0;
	if (g_once_init_enter (&online_accounts_dialog_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (OnlineAccountsDialogClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) online_accounts_dialog_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (OnlineAccountsDialog), 0, (GInstanceInitFunc) online_accounts_dialog_instance_init, NULL };
		GType online_accounts_dialog_type_id;
		online_accounts_dialog_type_id = g_type_register_static (gtk_grid_get_type (), "OnlineAccountsDialog", &g_define_type_info, G_TYPE_FLAG_ABSTRACT);
		g_once_init_leave (&online_accounts_dialog_type_id__volatile, online_accounts_dialog_type_id);
	}
	return online_accounts_dialog_type_id__volatile;
}

