/* PasswordDialog.c generated by valac 0.45.3, the Vala compiler
 * generated from PasswordDialog.vala, do not modify */

/* -*- Mode: vala; indent-tabs-mode: nil; tab-width: 4 -*-*/
/*-
 * Copyright (c) 2013-2016 elementary LLC. (https://elementary.io)
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the
 * Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
 * Boston, MA 02110-1301 USA.
 *
 * Authored by: Corentin Noël <corentin@elementary.io>
 */

#include <gtk/gtk.h>
#include <glib-object.h>
#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include <glib/gi18n-lib.h>
#include <gdk/gdk.h>

#define ONLINE_ACCOUNTS_TYPE_DIALOG (online_accounts_dialog_get_type ())
#define ONLINE_ACCOUNTS_DIALOG(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), ONLINE_ACCOUNTS_TYPE_DIALOG, OnlineAccountsDialog))
#define ONLINE_ACCOUNTS_DIALOG_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), ONLINE_ACCOUNTS_TYPE_DIALOG, OnlineAccountsDialogClass))
#define ONLINE_ACCOUNTS_IS_DIALOG(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), ONLINE_ACCOUNTS_TYPE_DIALOG))
#define ONLINE_ACCOUNTS_IS_DIALOG_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), ONLINE_ACCOUNTS_TYPE_DIALOG))
#define ONLINE_ACCOUNTS_DIALOG_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), ONLINE_ACCOUNTS_TYPE_DIALOG, OnlineAccountsDialogClass))

typedef struct _OnlineAccountsDialog OnlineAccountsDialog;
typedef struct _OnlineAccountsDialogClass OnlineAccountsDialogClass;
typedef struct _OnlineAccountsDialogPrivate OnlineAccountsDialogPrivate;
typedef enum  {
	ONLINE_ACCOUNTS_SIGNON_UI_ERROR_NONE,
	ONLINE_ACCOUNTS_SIGNON_UI_ERROR_GENERAL,
	ONLINE_ACCOUNTS_SIGNON_UI_ERROR_NO_SIGNONUI,
	ONLINE_ACCOUNTS_SIGNON_UI_ERROR_BAD_PARAMETERS,
	ONLINE_ACCOUNTS_SIGNON_UI_ERROR_CANCELED,
	ONLINE_ACCOUNTS_SIGNON_UI_ERROR_NOT_AVAILABLE,
	ONLINE_ACCOUNTS_SIGNON_UI_ERROR_BAD_URL,
	ONLINE_ACCOUNTS_SIGNON_UI_ERROR_BAD_CAPTCHA,
	ONLINE_ACCOUNTS_SIGNON_UI_ERROR_BAD_CAPTCHA_URL,
	ONLINE_ACCOUNTS_SIGNON_UI_ERROR_REFRESH_FAILED,
	ONLINE_ACCOUNTS_SIGNON_UI_ERROR_FORBIDDEN,
	ONLINE_ACCOUNTS_SIGNON_UI_ERROR_FORGOT_PASSWORD
} OnlineAccountsSignonUIError;

#define ONLINE_ACCOUNTS_TYPE_SIGNON_UI_ERROR (online_accounts_signon_ui_error_get_type ())

#define ONLINE_ACCOUNTS_TYPE_PASSWORD_DIALOG (online_accounts_password_dialog_get_type ())
#define ONLINE_ACCOUNTS_PASSWORD_DIALOG(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), ONLINE_ACCOUNTS_TYPE_PASSWORD_DIALOG, OnlineAccountsPasswordDialog))
#define ONLINE_ACCOUNTS_PASSWORD_DIALOG_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), ONLINE_ACCOUNTS_TYPE_PASSWORD_DIALOG, OnlineAccountsPasswordDialogClass))
#define ONLINE_ACCOUNTS_IS_PASSWORD_DIALOG(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), ONLINE_ACCOUNTS_TYPE_PASSWORD_DIALOG))
#define ONLINE_ACCOUNTS_IS_PASSWORD_DIALOG_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), ONLINE_ACCOUNTS_TYPE_PASSWORD_DIALOG))
#define ONLINE_ACCOUNTS_PASSWORD_DIALOG_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), ONLINE_ACCOUNTS_TYPE_PASSWORD_DIALOG, OnlineAccountsPasswordDialogClass))

typedef struct _OnlineAccountsPasswordDialog OnlineAccountsPasswordDialog;
typedef struct _OnlineAccountsPasswordDialogClass OnlineAccountsPasswordDialogClass;
typedef struct _OnlineAccountsPasswordDialogPrivate OnlineAccountsPasswordDialogPrivate;
enum  {
	ONLINE_ACCOUNTS_PASSWORD_DIALOG_0_PROPERTY,
	ONLINE_ACCOUNTS_PASSWORD_DIALOG_NUM_PROPERTIES
};
static GParamSpec* online_accounts_password_dialog_properties[ONLINE_ACCOUNTS_PASSWORD_DIALOG_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _g_hash_table_unref0(var) ((var == NULL) ? NULL : (var = (g_hash_table_unref (var), NULL)))
enum  {
	ONLINE_ACCOUNTS_PASSWORD_DIALOG_REFRESH_CAPTCHA_NEEDED_SIGNAL,
	ONLINE_ACCOUNTS_PASSWORD_DIALOG_NUM_SIGNALS
};
static guint online_accounts_password_dialog_signals[ONLINE_ACCOUNTS_PASSWORD_DIALOG_NUM_SIGNALS] = {0};

struct _OnlineAccountsDialog {
	GtkGrid parent_instance;
	OnlineAccountsDialogPrivate * priv;
	GHashTable* parameters;
	gchar* request_id;
	OnlineAccountsSignonUIError error_code;
};

struct _OnlineAccountsDialogClass {
	GtkGridClass parent_class;
	GHashTable* (*get_reply) (OnlineAccountsDialog* self);
	gboolean (*set_parameters) (OnlineAccountsDialog* self, GHashTable* params);
	gboolean (*refresh_captcha) (OnlineAccountsDialog* self, const gchar* uri);
};

struct _OnlineAccountsPasswordDialog {
	OnlineAccountsDialog parent_instance;
	OnlineAccountsPasswordDialogPrivate * priv;
};

struct _OnlineAccountsPasswordDialogClass {
	OnlineAccountsDialogClass parent_class;
};

struct _OnlineAccountsPasswordDialogPrivate {
	GtkEntry* url_entry;
	GtkEntry* username_entry;
	GtkEntry* password_entry;
	GtkEntry* new_password_entry;
	GtkEntry* confirm_password_entry;
	GtkEntry* captcha_entry;
	GtkButton* cancel_button;
	GtkButton* save_button;
	GtkLinkButton* forgot_button;
	GtkLinkButton* signup_button;
	GtkImage* captcha_image;
	GtkLabel* message_label;
	GtkLabel* provider_label;
	gboolean query_url;
	gboolean query_username;
	gboolean query_password;
	gboolean query_confirm;
	gboolean query_captcha;
	gboolean is_username_valid;
	gboolean is_password_valid;
	gboolean is_new_password_valid;
	gboolean is_captcha_valid;
	gchar* display_name;
	gchar* old_password;
	gchar* forgot_password_url;
	gchar* signup_url;
};

static gint OnlineAccountsPasswordDialog_private_offset;
static gpointer online_accounts_password_dialog_parent_class = NULL;

GType online_accounts_dialog_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (OnlineAccountsDialog, g_object_unref)
GType online_accounts_signon_ui_error_get_type (void) G_GNUC_CONST;
GType online_accounts_password_dialog_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (OnlineAccountsPasswordDialog, g_object_unref)
OnlineAccountsPasswordDialog* online_accounts_password_dialog_new (GHashTable* params);
OnlineAccountsPasswordDialog* online_accounts_password_dialog_construct (GType object_type,
                                                                         GHashTable* params);
OnlineAccountsDialog* online_accounts_dialog_construct (GType object_type,
                                                        GHashTable* parameter);
gboolean online_accounts_dialog_set_parameters (OnlineAccountsDialog* self,
                                                GHashTable* params);
static void __lambda41_ (OnlineAccountsPasswordDialog* self);
static void ___lambda41__gtk_entry_activate (GtkEntry* _sender,
                                      gpointer self);
static void __lambda42_ (OnlineAccountsPasswordDialog* self);
static void ___lambda42__gtk_button_clicked (GtkButton* _sender,
                                      gpointer self);
static void __lambda43_ (OnlineAccountsPasswordDialog* self);
static void ___lambda43__gtk_button_clicked (GtkButton* _sender,
                                      gpointer self);
static gboolean online_accounts_password_dialog_real_set_parameters (OnlineAccountsDialog* base,
                                                              GHashTable* params);
static gboolean online_accounts_password_dialog_validate_params (OnlineAccountsPasswordDialog* self,
                                                          GHashTable* params);
#define ONLINE_ACCOUNTS_KEY_USERNAME "UserName"
static gboolean ___lambda34_ (OnlineAccountsPasswordDialog* self);
static gboolean ____lambda34__gtk_link_button_activate_link (GtkLinkButton* _sender,
                                                      gpointer self);
#define ONLINE_ACCOUNTS_KEY_MESSAGE "Message"
#define ONLINE_ACCOUNTS_KEY_CAPTCHA_URL "CaptchaUrl"
gboolean online_accounts_dialog_refresh_captcha (OnlineAccountsDialog* self,
                                                 const gchar* uri);
static void ___lambda35_ (OnlineAccountsPasswordDialog* self);
static void online_accounts_password_dialog_reset_ok (OnlineAccountsPasswordDialog* self);
static void ____lambda35__gtk_editable_changed (GtkEditable* _sender,
                                         gpointer self);
static void ___lambda36_ (OnlineAccountsPasswordDialog* self);
static void ____lambda36__gtk_editable_changed (GtkEditable* _sender,
                                         gpointer self);
static void ___lambda37_ (OnlineAccountsPasswordDialog* self);
static void ____lambda37__gtk_editable_changed (GtkEditable* _sender,
                                         gpointer self);
static void ___lambda38_ (OnlineAccountsPasswordDialog* self);
static void ____lambda38__gtk_editable_changed (GtkEditable* _sender,
                                         gpointer self);
static void ___lambda39_ (OnlineAccountsPasswordDialog* self);
static void ____lambda39__gtk_editable_changed (GtkEditable* _sender,
                                         gpointer self);
static void ___lambda40_ (OnlineAccountsPasswordDialog* self,
                   GtkEntryIconPosition pos,
                   GdkEventButton* event);
static void ____lambda40__gtk_entry_icon_release (GtkEntry* _sender,
                                           GtkEntryIconPosition icon_pos,
                                           GdkEventButton* event,
                                           gpointer self);
#define ONLINE_ACCOUNTS_KEY_QUERY_USERNAME "QueryUserName"
#define ONLINE_ACCOUNTS_KEY_QUERY_URL "QueryUrl"
#define ONLINE_ACCOUNTS_KEY_QUERY_PASSWORD "QueryPassword"
#define ONLINE_ACCOUNTS_KEY_CONFIRM "Confirm"
#define ONLINE_ACCOUNTS_KEY_PASSWORD "Secret"
#define ONLINE_ACCOUNTS_KEY_DISPLAY_NAME "DisplayName"
#define ONLINE_ACCOUNTS_KEY_FORGOT_PASSWORD_URL "ForgotPasswordUrl"
#define ONLINE_ACCOUNTS_KEY_SIGNUP_URL "SignUpURL"
static void __lambda33_ (OnlineAccountsPasswordDialog* self,
                  const gchar* key);
static void ___lambda33__gfunc (gconstpointer data,
                         gpointer self);
static gboolean online_accounts_password_dialog_real_refresh_captcha (OnlineAccountsDialog* base,
                                                               const gchar* uri);
static GHashTable* online_accounts_password_dialog_real_get_reply (OnlineAccountsDialog* base);
GHashTable* online_accounts_dialog_get_reply (OnlineAccountsDialog* self);
static void online_accounts_password_dialog_finalize (GObject * obj);

static inline gpointer
online_accounts_password_dialog_get_instance_private (OnlineAccountsPasswordDialog* self)
{
	return G_STRUCT_MEMBER_P (self, OnlineAccountsPasswordDialog_private_offset);
}

static void
__lambda41_ (OnlineAccountsPasswordDialog* self)
{
	GtkButton* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
#line 162 "../src/Authentification/PasswordDialog.vala"
	_tmp0_ = self->priv->save_button;
#line 162 "../src/Authentification/PasswordDialog.vala"
	_tmp1_ = gtk_widget_get_sensitive ((GtkWidget*) _tmp0_);
#line 162 "../src/Authentification/PasswordDialog.vala"
	_tmp2_ = _tmp1_;
#line 162 "../src/Authentification/PasswordDialog.vala"
	if (_tmp2_) {
#line 237 "PasswordDialog.c"
		GtkButton* _tmp3_;
#line 163 "../src/Authentification/PasswordDialog.vala"
		_tmp3_ = self->priv->save_button;
#line 163 "../src/Authentification/PasswordDialog.vala"
		g_signal_emit_by_name (_tmp3_, "activate");
#line 243 "PasswordDialog.c"
	}
}

static void
___lambda41__gtk_entry_activate (GtkEntry* _sender,
                                 gpointer self)
{
#line 161 "../src/Authentification/PasswordDialog.vala"
	__lambda41_ ((OnlineAccountsPasswordDialog*) self);
#line 253 "PasswordDialog.c"
}

static void
__lambda42_ (OnlineAccountsPasswordDialog* self)
{
#line 166 "../src/Authentification/PasswordDialog.vala"
	g_signal_emit_by_name ((OnlineAccountsDialog*) self, "finished");
#line 261 "PasswordDialog.c"
}

static void
___lambda42__gtk_button_clicked (GtkButton* _sender,
                                 gpointer self)
{
#line 166 "../src/Authentification/PasswordDialog.vala"
	__lambda42_ ((OnlineAccountsPasswordDialog*) self);
#line 270 "PasswordDialog.c"
}

static void
__lambda43_ (OnlineAccountsPasswordDialog* self)
{
#line 168 "../src/Authentification/PasswordDialog.vala"
	((OnlineAccountsDialog*) self)->error_code = ONLINE_ACCOUNTS_SIGNON_UI_ERROR_CANCELED;
#line 169 "../src/Authentification/PasswordDialog.vala"
	g_signal_emit_by_name ((OnlineAccountsDialog*) self, "finished");
#line 170 "../src/Authentification/PasswordDialog.vala"
	gtk_widget_destroy ((GtkWidget*) self);
#line 282 "PasswordDialog.c"
}

static void
___lambda43__gtk_button_clicked (GtkButton* _sender,
                                 gpointer self)
{
#line 167 "../src/Authentification/PasswordDialog.vala"
	__lambda43_ ((OnlineAccountsPasswordDialog*) self);
#line 291 "PasswordDialog.c"
}

OnlineAccountsPasswordDialog*
online_accounts_password_dialog_construct (GType object_type,
                                           GHashTable* params)
{
	OnlineAccountsPasswordDialog * self = NULL;
	GtkStyleContext* _tmp0_;
	GtkLabel* _tmp1_;
	GtkLabel* _tmp2_;
	GtkStyleContext* _tmp3_;
	GtkLabel* _tmp4_;
	GtkEntry* _tmp5_;
	GtkEntry* _tmp6_;
	GtkEntry* _tmp7_;
	GtkEntry* _tmp8_;
	GtkEntry* _tmp9_;
	GtkEntry* _tmp10_;
	GtkEntry* _tmp11_;
	GtkEntry* _tmp12_;
	GtkEntry* _tmp13_;
	GtkEntry* _tmp14_;
	GtkEntry* _tmp15_;
	GtkEntry* _tmp16_;
	GtkEntry* _tmp17_;
	GtkEntry* _tmp18_;
	GtkEntry* _tmp19_;
	GtkEntry* _tmp20_;
	GtkEntry* _tmp21_;
	GtkEntry* _tmp22_;
	GtkGrid* entry_grid = NULL;
	GtkGrid* _tmp23_;
	GtkGrid* _tmp24_;
	GtkStyleContext* _tmp25_;
	GtkGrid* _tmp26_;
	GtkLinkButton* _tmp27_;
	GtkEntry* _tmp28_;
	GtkEntry* _tmp29_;
	GtkEntry* _tmp30_;
	GtkEntry* _tmp31_;
	GtkEntry* _tmp32_;
	GtkLabel* _tmp33_;
	GtkLabel* _tmp34_;
	GtkButton* _tmp35_;
	GtkButton* _tmp36_;
	GtkButton* _tmp37_;
	GtkButton* _tmp38_;
	GtkStyleContext* _tmp39_;
	GtkButton* _tmp40_;
	GtkLinkButton* _tmp41_;
	GtkLabel* _tmp42_;
	GtkGrid* _tmp44_;
	GtkGrid* save_box = NULL;
	GtkGrid* _tmp49_;
	GtkGrid* _tmp50_;
	GtkGrid* _tmp51_;
	GtkGrid* _tmp52_;
	GtkButton* _tmp53_;
	GtkGrid* _tmp54_;
	GtkButton* _tmp55_;
	GtkGrid* _tmp56_;
	const gchar* _tmp57_;
	const gchar* _tmp59_;
	GtkLabel* _tmp67_;
	GtkEntry* _tmp68_;
	GtkButton* _tmp69_;
	GtkButton* _tmp70_;
#line 55 "../src/Authentification/PasswordDialog.vala"
	g_return_val_if_fail (params != NULL, NULL);
#line 56 "../src/Authentification/PasswordDialog.vala"
	self = (OnlineAccountsPasswordDialog*) online_accounts_dialog_construct (object_type, params);
#line 58 "../src/Authentification/PasswordDialog.vala"
	gtk_widget_set_halign ((GtkWidget*) self, GTK_ALIGN_CENTER);
#line 59 "../src/Authentification/PasswordDialog.vala"
	gtk_widget_set_valign ((GtkWidget*) self, GTK_ALIGN_CENTER);
#line 60 "../src/Authentification/PasswordDialog.vala"
	gtk_grid_set_column_spacing ((GtkGrid*) self, 12);
#line 61 "../src/Authentification/PasswordDialog.vala"
	gtk_grid_set_row_spacing ((GtkGrid*) self, 6);
#line 62 "../src/Authentification/PasswordDialog.vala"
	gtk_orientable_set_orientation ((GtkOrientable*) self, GTK_ORIENTATION_VERTICAL);
#line 63 "../src/Authentification/PasswordDialog.vala"
	_tmp0_ = gtk_widget_get_style_context ((GtkWidget*) self);
#line 63 "../src/Authentification/PasswordDialog.vala"
	gtk_style_context_add_class (_tmp0_, "login");
#line 65 "../src/Authentification/PasswordDialog.vala"
	_tmp1_ = (GtkLabel*) gtk_label_new ("");
#line 65 "../src/Authentification/PasswordDialog.vala"
	g_object_ref_sink (_tmp1_);
#line 65 "../src/Authentification/PasswordDialog.vala"
	_g_object_unref0 (self->priv->provider_label);
#line 65 "../src/Authentification/PasswordDialog.vala"
	self->priv->provider_label = _tmp1_;
#line 66 "../src/Authentification/PasswordDialog.vala"
	_tmp2_ = self->priv->provider_label;
#line 66 "../src/Authentification/PasswordDialog.vala"
	_tmp3_ = gtk_widget_get_style_context ((GtkWidget*) _tmp2_);
#line 66 "../src/Authentification/PasswordDialog.vala"
	gtk_style_context_add_class (_tmp3_, "h1");
#line 67 "../src/Authentification/PasswordDialog.vala"
	_tmp4_ = self->priv->provider_label;
#line 67 "../src/Authentification/PasswordDialog.vala"
	gtk_widget_set_margin_bottom ((GtkWidget*) _tmp4_, 24);
#line 69 "../src/Authentification/PasswordDialog.vala"
	_tmp5_ = (GtkEntry*) gtk_entry_new ();
#line 69 "../src/Authentification/PasswordDialog.vala"
	g_object_ref_sink (_tmp5_);
#line 69 "../src/Authentification/PasswordDialog.vala"
	_g_object_unref0 (self->priv->url_entry);
#line 69 "../src/Authentification/PasswordDialog.vala"
	self->priv->url_entry = _tmp5_;
#line 70 "../src/Authentification/PasswordDialog.vala"
	_tmp6_ = self->priv->url_entry;
#line 70 "../src/Authentification/PasswordDialog.vala"
	gtk_entry_set_placeholder_text (_tmp6_, _ ("URL"));
#line 71 "../src/Authentification/PasswordDialog.vala"
	_tmp7_ = self->priv->url_entry;
#line 71 "../src/Authentification/PasswordDialog.vala"
	gtk_entry_set_input_purpose (_tmp7_, GTK_INPUT_PURPOSE_URL);
#line 73 "../src/Authentification/PasswordDialog.vala"
	_tmp8_ = (GtkEntry*) gtk_entry_new ();
#line 73 "../src/Authentification/PasswordDialog.vala"
	g_object_ref_sink (_tmp8_);
#line 73 "../src/Authentification/PasswordDialog.vala"
	_g_object_unref0 (self->priv->username_entry);
#line 73 "../src/Authentification/PasswordDialog.vala"
	self->priv->username_entry = _tmp8_;
#line 74 "../src/Authentification/PasswordDialog.vala"
	_tmp9_ = self->priv->username_entry;
#line 74 "../src/Authentification/PasswordDialog.vala"
	gtk_entry_set_placeholder_text (_tmp9_, _ ("Email"));
#line 75 "../src/Authentification/PasswordDialog.vala"
	_tmp10_ = self->priv->username_entry;
#line 75 "../src/Authentification/PasswordDialog.vala"
	g_object_set ((GtkWidget*) _tmp10_, "width-request", 256, NULL);
#line 77 "../src/Authentification/PasswordDialog.vala"
	_tmp11_ = (GtkEntry*) gtk_entry_new ();
#line 77 "../src/Authentification/PasswordDialog.vala"
	g_object_ref_sink (_tmp11_);
#line 77 "../src/Authentification/PasswordDialog.vala"
	_g_object_unref0 (self->priv->password_entry);
#line 77 "../src/Authentification/PasswordDialog.vala"
	self->priv->password_entry = _tmp11_;
#line 78 "../src/Authentification/PasswordDialog.vala"
	_tmp12_ = self->priv->password_entry;
#line 78 "../src/Authentification/PasswordDialog.vala"
	gtk_entry_set_placeholder_text (_tmp12_, _ ("Password"));
#line 79 "../src/Authentification/PasswordDialog.vala"
	_tmp13_ = self->priv->password_entry;
#line 79 "../src/Authentification/PasswordDialog.vala"
	gtk_entry_set_visibility (_tmp13_, FALSE);
#line 80 "../src/Authentification/PasswordDialog.vala"
	_tmp14_ = self->priv->password_entry;
#line 80 "../src/Authentification/PasswordDialog.vala"
	gtk_entry_set_input_purpose (_tmp14_, GTK_INPUT_PURPOSE_PASSWORD);
#line 82 "../src/Authentification/PasswordDialog.vala"
	_tmp15_ = (GtkEntry*) gtk_entry_new ();
#line 82 "../src/Authentification/PasswordDialog.vala"
	g_object_ref_sink (_tmp15_);
#line 82 "../src/Authentification/PasswordDialog.vala"
	_g_object_unref0 (self->priv->new_password_entry);
#line 82 "../src/Authentification/PasswordDialog.vala"
	self->priv->new_password_entry = _tmp15_;
#line 83 "../src/Authentification/PasswordDialog.vala"
	_tmp16_ = self->priv->new_password_entry;
#line 83 "../src/Authentification/PasswordDialog.vala"
	gtk_entry_set_placeholder_text (_tmp16_, _ ("New Password"));
#line 84 "../src/Authentification/PasswordDialog.vala"
	_tmp17_ = self->priv->new_password_entry;
#line 84 "../src/Authentification/PasswordDialog.vala"
	gtk_entry_set_visibility (_tmp17_, FALSE);
#line 85 "../src/Authentification/PasswordDialog.vala"
	_tmp18_ = self->priv->new_password_entry;
#line 85 "../src/Authentification/PasswordDialog.vala"
	gtk_entry_set_input_purpose (_tmp18_, GTK_INPUT_PURPOSE_PASSWORD);
#line 87 "../src/Authentification/PasswordDialog.vala"
	_tmp19_ = (GtkEntry*) gtk_entry_new ();
#line 87 "../src/Authentification/PasswordDialog.vala"
	g_object_ref_sink (_tmp19_);
#line 87 "../src/Authentification/PasswordDialog.vala"
	_g_object_unref0 (self->priv->confirm_password_entry);
#line 87 "../src/Authentification/PasswordDialog.vala"
	self->priv->confirm_password_entry = _tmp19_;
#line 88 "../src/Authentification/PasswordDialog.vala"
	_tmp20_ = self->priv->confirm_password_entry;
#line 88 "../src/Authentification/PasswordDialog.vala"
	gtk_entry_set_placeholder_text (_tmp20_, _ ("Confirm Password"));
#line 89 "../src/Authentification/PasswordDialog.vala"
	_tmp21_ = self->priv->confirm_password_entry;
#line 89 "../src/Authentification/PasswordDialog.vala"
	gtk_entry_set_visibility (_tmp21_, FALSE);
#line 90 "../src/Authentification/PasswordDialog.vala"
	_tmp22_ = self->priv->confirm_password_entry;
#line 90 "../src/Authentification/PasswordDialog.vala"
	gtk_entry_set_input_purpose (_tmp22_, GTK_INPUT_PURPOSE_PASSWORD);
#line 92 "../src/Authentification/PasswordDialog.vala"
	_tmp23_ = (GtkGrid*) gtk_grid_new ();
#line 92 "../src/Authentification/PasswordDialog.vala"
	g_object_ref_sink (_tmp23_);
#line 92 "../src/Authentification/PasswordDialog.vala"
	entry_grid = _tmp23_;
#line 93 "../src/Authentification/PasswordDialog.vala"
	_tmp24_ = entry_grid;
#line 93 "../src/Authentification/PasswordDialog.vala"
	_tmp25_ = gtk_widget_get_style_context ((GtkWidget*) _tmp24_);
#line 93 "../src/Authentification/PasswordDialog.vala"
	gtk_style_context_add_class (_tmp25_, GTK_STYLE_CLASS_LINKED);
#line 94 "../src/Authentification/PasswordDialog.vala"
	_tmp26_ = entry_grid;
#line 94 "../src/Authentification/PasswordDialog.vala"
	gtk_orientable_set_orientation ((GtkOrientable*) _tmp26_, GTK_ORIENTATION_VERTICAL);
#line 96 "../src/Authentification/PasswordDialog.vala"
	_tmp27_ = (GtkLinkButton*) gtk_link_button_new_with_label ("", _ ("Forgot password…"));
#line 96 "../src/Authentification/PasswordDialog.vala"
	g_object_ref_sink (_tmp27_);
#line 96 "../src/Authentification/PasswordDialog.vala"
	_g_object_unref0 (self->priv->forgot_button);
#line 96 "../src/Authentification/PasswordDialog.vala"
	self->priv->forgot_button = _tmp27_;
#line 98 "../src/Authentification/PasswordDialog.vala"
	_tmp28_ = (GtkEntry*) gtk_entry_new ();
#line 98 "../src/Authentification/PasswordDialog.vala"
	g_object_ref_sink (_tmp28_);
#line 98 "../src/Authentification/PasswordDialog.vala"
	_g_object_unref0 (self->priv->captcha_entry);
#line 98 "../src/Authentification/PasswordDialog.vala"
	self->priv->captcha_entry = _tmp28_;
#line 99 "../src/Authentification/PasswordDialog.vala"
	_tmp29_ = self->priv->captcha_entry;
#line 99 "../src/Authentification/PasswordDialog.vala"
	g_object_set (_tmp29_, "secondary-icon-name", "view-refresh", NULL);
#line 100 "../src/Authentification/PasswordDialog.vala"
	_tmp30_ = self->priv->captcha_entry;
#line 100 "../src/Authentification/PasswordDialog.vala"
	g_object_set (_tmp30_, "secondary-icon-activatable", TRUE, NULL);
#line 101 "../src/Authentification/PasswordDialog.vala"
	_tmp31_ = self->priv->captcha_entry;
#line 101 "../src/Authentification/PasswordDialog.vala"
	g_object_set (_tmp31_, "secondary-icon-tooltip-text", _ ("Refresh Captcha"), NULL);
#line 102 "../src/Authentification/PasswordDialog.vala"
	_tmp32_ = self->priv->captcha_entry;
#line 102 "../src/Authentification/PasswordDialog.vala"
	gtk_widget_set_tooltip_text ((GtkWidget*) _tmp32_, _ ("Enter above text here"));
#line 104 "../src/Authentification/PasswordDialog.vala"
	_tmp33_ = (GtkLabel*) gtk_label_new ("");
#line 104 "../src/Authentification/PasswordDialog.vala"
	g_object_ref_sink (_tmp33_);
#line 104 "../src/Authentification/PasswordDialog.vala"
	_g_object_unref0 (self->priv->message_label);
#line 104 "../src/Authentification/PasswordDialog.vala"
	self->priv->message_label = _tmp33_;
#line 105 "../src/Authentification/PasswordDialog.vala"
	_tmp34_ = self->priv->message_label;
#line 105 "../src/Authentification/PasswordDialog.vala"
	gtk_widget_set_no_show_all ((GtkWidget*) _tmp34_, TRUE);
#line 107 "../src/Authentification/PasswordDialog.vala"
	_tmp35_ = (GtkButton*) gtk_button_new_with_label (_ ("Cancel"));
#line 107 "../src/Authentification/PasswordDialog.vala"
	g_object_ref_sink (_tmp35_);
#line 107 "../src/Authentification/PasswordDialog.vala"
	_g_object_unref0 (self->priv->cancel_button);
#line 107 "../src/Authentification/PasswordDialog.vala"
	self->priv->cancel_button = _tmp35_;
#line 108 "../src/Authentification/PasswordDialog.vala"
	_tmp36_ = self->priv->cancel_button;
#line 108 "../src/Authentification/PasswordDialog.vala"
	gtk_widget_set_hexpand ((GtkWidget*) _tmp36_, TRUE);
#line 109 "../src/Authentification/PasswordDialog.vala"
	_tmp37_ = (GtkButton*) gtk_button_new_with_label (_ ("Log In"));
#line 109 "../src/Authentification/PasswordDialog.vala"
	g_object_ref_sink (_tmp37_);
#line 109 "../src/Authentification/PasswordDialog.vala"
	_g_object_unref0 (self->priv->save_button);
#line 109 "../src/Authentification/PasswordDialog.vala"
	self->priv->save_button = _tmp37_;
#line 110 "../src/Authentification/PasswordDialog.vala"
	_tmp38_ = self->priv->save_button;
#line 110 "../src/Authentification/PasswordDialog.vala"
	_tmp39_ = gtk_widget_get_style_context ((GtkWidget*) _tmp38_);
#line 110 "../src/Authentification/PasswordDialog.vala"
	gtk_style_context_add_class (_tmp39_, GTK_STYLE_CLASS_SUGGESTED_ACTION);
#line 111 "../src/Authentification/PasswordDialog.vala"
	_tmp40_ = self->priv->save_button;
#line 111 "../src/Authentification/PasswordDialog.vala"
	gtk_widget_set_hexpand ((GtkWidget*) _tmp40_, TRUE);
#line 113 "../src/Authentification/PasswordDialog.vala"
	_tmp41_ = (GtkLinkButton*) gtk_link_button_new_with_label ("", _ ("Don't have an account? Sign Up"));
#line 113 "../src/Authentification/PasswordDialog.vala"
	g_object_ref_sink (_tmp41_);
#line 113 "../src/Authentification/PasswordDialog.vala"
	_g_object_unref0 (self->priv->signup_button);
#line 113 "../src/Authentification/PasswordDialog.vala"
	self->priv->signup_button = _tmp41_;
#line 115 "../src/Authentification/PasswordDialog.vala"
	online_accounts_dialog_set_parameters ((OnlineAccountsDialog*) self, params);
#line 117 "../src/Authentification/PasswordDialog.vala"
	_tmp42_ = self->priv->provider_label;
#line 117 "../src/Authentification/PasswordDialog.vala"
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) _tmp42_);
#line 119 "../src/Authentification/PasswordDialog.vala"
	if (self->priv->query_url) {
#line 593 "PasswordDialog.c"
		GtkEntry* _tmp43_;
#line 120 "../src/Authentification/PasswordDialog.vala"
		_tmp43_ = self->priv->url_entry;
#line 120 "../src/Authentification/PasswordDialog.vala"
		gtk_container_add ((GtkContainer*) self, (GtkWidget*) _tmp43_);
#line 599 "PasswordDialog.c"
	}
#line 123 "../src/Authentification/PasswordDialog.vala"
	_tmp44_ = entry_grid;
#line 123 "../src/Authentification/PasswordDialog.vala"
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) _tmp44_);
#line 125 "../src/Authentification/PasswordDialog.vala"
	if (self->priv->query_username) {
#line 607 "PasswordDialog.c"
		GtkGrid* _tmp45_;
		GtkEntry* _tmp46_;
#line 126 "../src/Authentification/PasswordDialog.vala"
		_tmp45_ = entry_grid;
#line 126 "../src/Authentification/PasswordDialog.vala"
		_tmp46_ = self->priv->username_entry;
#line 126 "../src/Authentification/PasswordDialog.vala"
		gtk_container_add ((GtkContainer*) _tmp45_, (GtkWidget*) _tmp46_);
#line 616 "PasswordDialog.c"
	}
#line 129 "../src/Authentification/PasswordDialog.vala"
	if (self->priv->query_password) {
#line 620 "PasswordDialog.c"
		GtkGrid* _tmp47_;
		GtkEntry* _tmp48_;
#line 130 "../src/Authentification/PasswordDialog.vala"
		_tmp47_ = entry_grid;
#line 130 "../src/Authentification/PasswordDialog.vala"
		_tmp48_ = self->priv->password_entry;
#line 130 "../src/Authentification/PasswordDialog.vala"
		gtk_container_add ((GtkContainer*) _tmp47_, (GtkWidget*) _tmp48_);
#line 629 "PasswordDialog.c"
	}
#line 133 "../src/Authentification/PasswordDialog.vala"
	_tmp49_ = (GtkGrid*) gtk_grid_new ();
#line 133 "../src/Authentification/PasswordDialog.vala"
	g_object_ref_sink (_tmp49_);
#line 133 "../src/Authentification/PasswordDialog.vala"
	save_box = _tmp49_;
#line 134 "../src/Authentification/PasswordDialog.vala"
	_tmp50_ = save_box;
#line 134 "../src/Authentification/PasswordDialog.vala"
	gtk_widget_set_margin_top ((GtkWidget*) _tmp50_, 12);
#line 135 "../src/Authentification/PasswordDialog.vala"
	_tmp51_ = save_box;
#line 135 "../src/Authentification/PasswordDialog.vala"
	gtk_grid_set_column_spacing (_tmp51_, 6);
#line 136 "../src/Authentification/PasswordDialog.vala"
	_tmp52_ = save_box;
#line 136 "../src/Authentification/PasswordDialog.vala"
	_tmp53_ = self->priv->cancel_button;
#line 136 "../src/Authentification/PasswordDialog.vala"
	gtk_container_add ((GtkContainer*) _tmp52_, (GtkWidget*) _tmp53_);
#line 137 "../src/Authentification/PasswordDialog.vala"
	_tmp54_ = save_box;
#line 137 "../src/Authentification/PasswordDialog.vala"
	_tmp55_ = self->priv->save_button;
#line 137 "../src/Authentification/PasswordDialog.vala"
	gtk_container_add ((GtkContainer*) _tmp54_, (GtkWidget*) _tmp55_);
#line 139 "../src/Authentification/PasswordDialog.vala"
	_tmp56_ = save_box;
#line 139 "../src/Authentification/PasswordDialog.vala"
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) _tmp56_);
#line 141 "../src/Authentification/PasswordDialog.vala"
	_tmp57_ = self->priv->forgot_password_url;
#line 141 "../src/Authentification/PasswordDialog.vala"
	if (_tmp57_ != NULL) {
#line 665 "PasswordDialog.c"
		GtkLinkButton* _tmp58_;
#line 142 "../src/Authentification/PasswordDialog.vala"
		_tmp58_ = self->priv->forgot_button;
#line 142 "../src/Authentification/PasswordDialog.vala"
		gtk_container_add ((GtkContainer*) self, (GtkWidget*) _tmp58_);
#line 671 "PasswordDialog.c"
	}
#line 145 "../src/Authentification/PasswordDialog.vala"
	_tmp59_ = self->priv->signup_url;
#line 145 "../src/Authentification/PasswordDialog.vala"
	if (_tmp59_ != NULL) {
#line 677 "PasswordDialog.c"
		GtkLinkButton* _tmp60_;
#line 146 "../src/Authentification/PasswordDialog.vala"
		_tmp60_ = self->priv->signup_button;
#line 146 "../src/Authentification/PasswordDialog.vala"
		gtk_container_add ((GtkContainer*) self, (GtkWidget*) _tmp60_);
#line 683 "PasswordDialog.c"
	}
#line 149 "../src/Authentification/PasswordDialog.vala"
	if (self->priv->query_confirm) {
#line 687 "PasswordDialog.c"
		GtkGrid* _tmp61_;
		GtkEntry* _tmp62_;
		GtkGrid* _tmp63_;
		GtkEntry* _tmp64_;
#line 150 "../src/Authentification/PasswordDialog.vala"
		_tmp61_ = entry_grid;
#line 150 "../src/Authentification/PasswordDialog.vala"
		_tmp62_ = self->priv->new_password_entry;
#line 150 "../src/Authentification/PasswordDialog.vala"
		gtk_container_add ((GtkContainer*) _tmp61_, (GtkWidget*) _tmp62_);
#line 151 "../src/Authentification/PasswordDialog.vala"
		_tmp63_ = entry_grid;
#line 151 "../src/Authentification/PasswordDialog.vala"
		_tmp64_ = self->priv->confirm_password_entry;
#line 151 "../src/Authentification/PasswordDialog.vala"
		gtk_container_add ((GtkContainer*) _tmp63_, (GtkWidget*) _tmp64_);
#line 704 "PasswordDialog.c"
	}
#line 154 "../src/Authentification/PasswordDialog.vala"
	if (self->priv->query_captcha) {
#line 708 "PasswordDialog.c"
		GtkImage* _tmp65_;
		GtkEntry* _tmp66_;
#line 155 "../src/Authentification/PasswordDialog.vala"
		_tmp65_ = self->priv->captcha_image;
#line 155 "../src/Authentification/PasswordDialog.vala"
		gtk_container_add ((GtkContainer*) self, (GtkWidget*) _tmp65_);
#line 156 "../src/Authentification/PasswordDialog.vala"
		_tmp66_ = self->priv->captcha_entry;
#line 156 "../src/Authentification/PasswordDialog.vala"
		gtk_container_add ((GtkContainer*) self, (GtkWidget*) _tmp66_);
#line 719 "PasswordDialog.c"
	}
#line 159 "../src/Authentification/PasswordDialog.vala"
	_tmp67_ = self->priv->message_label;
#line 159 "../src/Authentification/PasswordDialog.vala"
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) _tmp67_);
#line 161 "../src/Authentification/PasswordDialog.vala"
	_tmp68_ = self->priv->password_entry;
#line 161 "../src/Authentification/PasswordDialog.vala"
	g_signal_connect_object (_tmp68_, "activate", (GCallback) ___lambda41__gtk_entry_activate, self, 0);
#line 166 "../src/Authentification/PasswordDialog.vala"
	_tmp69_ = self->priv->save_button;
#line 166 "../src/Authentification/PasswordDialog.vala"
	g_signal_connect_object (_tmp69_, "clicked", (GCallback) ___lambda42__gtk_button_clicked, self, 0);
#line 167 "../src/Authentification/PasswordDialog.vala"
	_tmp70_ = self->priv->cancel_button;
#line 167 "../src/Authentification/PasswordDialog.vala"
	g_signal_connect_object (_tmp70_, "clicked", (GCallback) ___lambda43__gtk_button_clicked, self, 0);
#line 173 "../src/Authentification/PasswordDialog.vala"
	gtk_widget_show_all ((GtkWidget*) self);
#line 55 "../src/Authentification/PasswordDialog.vala"
	_g_object_unref0 (save_box);
#line 55 "../src/Authentification/PasswordDialog.vala"
	_g_object_unref0 (entry_grid);
#line 55 "../src/Authentification/PasswordDialog.vala"
	return self;
#line 745 "PasswordDialog.c"
}

OnlineAccountsPasswordDialog*
online_accounts_password_dialog_new (GHashTable* params)
{
#line 55 "../src/Authentification/PasswordDialog.vala"
	return online_accounts_password_dialog_construct (ONLINE_ACCOUNTS_TYPE_PASSWORD_DIALOG, params);
#line 753 "PasswordDialog.c"
}

static gboolean
___lambda34_ (OnlineAccountsPasswordDialog* self)
{
	gboolean result = FALSE;
#line 195 "../src/Authentification/PasswordDialog.vala"
	g_warning ("PasswordDialog.vala:195: forgot password");
#line 196 "../src/Authentification/PasswordDialog.vala"
	((OnlineAccountsDialog*) self)->error_code = ONLINE_ACCOUNTS_SIGNON_UI_ERROR_FORGOT_PASSWORD;
#line 197 "../src/Authentification/PasswordDialog.vala"
	g_signal_emit_by_name ((OnlineAccountsDialog*) self, "finished");
#line 198 "../src/Authentification/PasswordDialog.vala"
	result = FALSE;
#line 198 "../src/Authentification/PasswordDialog.vala"
	return result;
#line 770 "PasswordDialog.c"
}

static gboolean
____lambda34__gtk_link_button_activate_link (GtkLinkButton* _sender,
                                             gpointer self)
{
	gboolean result;
	result = ___lambda34_ ((OnlineAccountsPasswordDialog*) self);
#line 194 "../src/Authentification/PasswordDialog.vala"
	return result;
#line 781 "PasswordDialog.c"
}

static void
___lambda35_ (OnlineAccountsPasswordDialog* self)
{
	GtkEntry* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
#line 221 "../src/Authentification/PasswordDialog.vala"
	_tmp0_ = self->priv->username_entry;
#line 221 "../src/Authentification/PasswordDialog.vala"
	_tmp1_ = gtk_entry_get_text (_tmp0_);
#line 221 "../src/Authentification/PasswordDialog.vala"
	_tmp2_ = _tmp1_;
#line 221 "../src/Authentification/PasswordDialog.vala"
	self->priv->is_username_valid = g_utf8_strlen (_tmp2_, (gssize) -1) > 0;
#line 222 "../src/Authentification/PasswordDialog.vala"
	online_accounts_password_dialog_reset_ok (self);
#line 800 "PasswordDialog.c"
}

static void
____lambda35__gtk_editable_changed (GtkEditable* _sender,
                                    gpointer self)
{
#line 220 "../src/Authentification/PasswordDialog.vala"
	___lambda35_ ((OnlineAccountsPasswordDialog*) self);
#line 809 "PasswordDialog.c"
}

static void
___lambda36_ (OnlineAccountsPasswordDialog* self)
{
	GtkEntry* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	gboolean _tmp3_ = FALSE;
	gboolean _tmp4_ = FALSE;
#line 226 "../src/Authentification/PasswordDialog.vala"
	_tmp0_ = self->priv->password_entry;
#line 226 "../src/Authentification/PasswordDialog.vala"
	_tmp1_ = gtk_entry_get_text (_tmp0_);
#line 226 "../src/Authentification/PasswordDialog.vala"
	_tmp2_ = _tmp1_;
#line 226 "../src/Authentification/PasswordDialog.vala"
	self->priv->is_password_valid = g_utf8_strlen (_tmp2_, (gssize) -1) > 0;
#line 227 "../src/Authentification/PasswordDialog.vala"
	if (self->priv->query_confirm) {
#line 227 "../src/Authentification/PasswordDialog.vala"
		_tmp4_ = self->priv->is_password_valid;
#line 832 "PasswordDialog.c"
	} else {
#line 227 "../src/Authentification/PasswordDialog.vala"
		_tmp4_ = FALSE;
#line 836 "PasswordDialog.c"
	}
#line 227 "../src/Authentification/PasswordDialog.vala"
	if (_tmp4_) {
#line 840 "PasswordDialog.c"
		const gchar* _tmp5_;
#line 227 "../src/Authentification/PasswordDialog.vala"
		_tmp5_ = self->priv->old_password;
#line 227 "../src/Authentification/PasswordDialog.vala"
		_tmp3_ = _tmp5_ != NULL;
#line 846 "PasswordDialog.c"
	} else {
#line 227 "../src/Authentification/PasswordDialog.vala"
		_tmp3_ = FALSE;
#line 850 "PasswordDialog.c"
	}
#line 227 "../src/Authentification/PasswordDialog.vala"
	if (_tmp3_) {
#line 854 "PasswordDialog.c"
		GCompareFunc _tmp6_;
		const gchar* _tmp7_;
		GtkEntry* _tmp8_;
		const gchar* _tmp9_;
		const gchar* _tmp10_;
#line 228 "../src/Authentification/PasswordDialog.vala"
		_tmp6_ = ((GCompareFunc) g_strcmp0);
#line 228 "../src/Authentification/PasswordDialog.vala"
		_tmp7_ = self->priv->old_password;
#line 228 "../src/Authentification/PasswordDialog.vala"
		_tmp8_ = self->priv->password_entry;
#line 228 "../src/Authentification/PasswordDialog.vala"
		_tmp9_ = gtk_entry_get_text (_tmp8_);
#line 228 "../src/Authentification/PasswordDialog.vala"
		_tmp10_ = _tmp9_;
#line 228 "../src/Authentification/PasswordDialog.vala"
		self->priv->is_password_valid = _tmp6_ (_tmp7_, _tmp10_) == 0;
#line 872 "PasswordDialog.c"
	}
#line 230 "../src/Authentification/PasswordDialog.vala"
	online_accounts_password_dialog_reset_ok (self);
#line 876 "PasswordDialog.c"
}

static void
____lambda36__gtk_editable_changed (GtkEditable* _sender,
                                    gpointer self)
{
#line 225 "../src/Authentification/PasswordDialog.vala"
	___lambda36_ ((OnlineAccountsPasswordDialog*) self);
#line 885 "PasswordDialog.c"
}

static void
___lambda37_ (OnlineAccountsPasswordDialog* self)
{
	gchar* new_password = NULL;
	GtkEntry* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* confirm = NULL;
	GtkEntry* _tmp4_;
	const gchar* _tmp5_;
	const gchar* _tmp6_;
	gchar* _tmp7_;
	gboolean _tmp8_ = FALSE;
	gboolean _tmp9_ = FALSE;
	const gchar* _tmp10_;
#line 236 "../src/Authentification/PasswordDialog.vala"
	_tmp0_ = self->priv->new_password_entry;
#line 236 "../src/Authentification/PasswordDialog.vala"
	_tmp1_ = gtk_entry_get_text (_tmp0_);
#line 236 "../src/Authentification/PasswordDialog.vala"
	_tmp2_ = _tmp1_;
#line 236 "../src/Authentification/PasswordDialog.vala"
	_tmp3_ = g_strdup (_tmp2_);
#line 236 "../src/Authentification/PasswordDialog.vala"
	new_password = _tmp3_;
#line 237 "../src/Authentification/PasswordDialog.vala"
	_tmp4_ = self->priv->confirm_password_entry;
#line 237 "../src/Authentification/PasswordDialog.vala"
	_tmp5_ = gtk_entry_get_text (_tmp4_);
#line 237 "../src/Authentification/PasswordDialog.vala"
	_tmp6_ = _tmp5_;
#line 237 "../src/Authentification/PasswordDialog.vala"
	_tmp7_ = g_strdup (_tmp6_);
#line 237 "../src/Authentification/PasswordDialog.vala"
	confirm = _tmp7_;
#line 238 "../src/Authentification/PasswordDialog.vala"
	_tmp10_ = new_password;
#line 238 "../src/Authentification/PasswordDialog.vala"
	if (g_utf8_strlen (_tmp10_, (gssize) -1) > 0) {
#line 928 "PasswordDialog.c"
		const gchar* _tmp11_;
#line 239 "../src/Authentification/PasswordDialog.vala"
		_tmp11_ = confirm;
#line 239 "../src/Authentification/PasswordDialog.vala"
		_tmp9_ = g_utf8_strlen (_tmp11_, (gssize) -1) > 0;
#line 934 "PasswordDialog.c"
	} else {
#line 238 "../src/Authentification/PasswordDialog.vala"
		_tmp9_ = FALSE;
#line 938 "PasswordDialog.c"
	}
#line 238 "../src/Authentification/PasswordDialog.vala"
	if (_tmp9_) {
#line 942 "PasswordDialog.c"
		GCompareFunc _tmp12_;
		const gchar* _tmp13_;
		const gchar* _tmp14_;
#line 240 "../src/Authentification/PasswordDialog.vala"
		_tmp12_ = ((GCompareFunc) g_strcmp0);
#line 240 "../src/Authentification/PasswordDialog.vala"
		_tmp13_ = new_password;
#line 240 "../src/Authentification/PasswordDialog.vala"
		_tmp14_ = confirm;
#line 240 "../src/Authentification/PasswordDialog.vala"
		_tmp8_ = _tmp12_ (_tmp13_, _tmp14_) == 0;
#line 954 "PasswordDialog.c"
	} else {
#line 238 "../src/Authentification/PasswordDialog.vala"
		_tmp8_ = FALSE;
#line 958 "PasswordDialog.c"
	}
#line 238 "../src/Authentification/PasswordDialog.vala"
	self->priv->is_new_password_valid = _tmp8_;
#line 241 "../src/Authentification/PasswordDialog.vala"
	online_accounts_password_dialog_reset_ok (self);
#line 235 "../src/Authentification/PasswordDialog.vala"
	_g_free0 (confirm);
#line 235 "../src/Authentification/PasswordDialog.vala"
	_g_free0 (new_password);
#line 968 "PasswordDialog.c"
}

static void
____lambda37__gtk_editable_changed (GtkEditable* _sender,
                                    gpointer self)
{
#line 235 "../src/Authentification/PasswordDialog.vala"
	___lambda37_ ((OnlineAccountsPasswordDialog*) self);
#line 977 "PasswordDialog.c"
}

static void
___lambda38_ (OnlineAccountsPasswordDialog* self)
{
	gchar* new_password = NULL;
	GtkEntry* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* confirm = NULL;
	GtkEntry* _tmp4_;
	const gchar* _tmp5_;
	const gchar* _tmp6_;
	gchar* _tmp7_;
	gboolean _tmp8_ = FALSE;
	gboolean _tmp9_ = FALSE;
	const gchar* _tmp10_;
#line 245 "../src/Authentification/PasswordDialog.vala"
	_tmp0_ = self->priv->new_password_entry;
#line 245 "../src/Authentification/PasswordDialog.vala"
	_tmp1_ = gtk_entry_get_text (_tmp0_);
#line 245 "../src/Authentification/PasswordDialog.vala"
	_tmp2_ = _tmp1_;
#line 245 "../src/Authentification/PasswordDialog.vala"
	_tmp3_ = g_strdup (_tmp2_);
#line 245 "../src/Authentification/PasswordDialog.vala"
	new_password = _tmp3_;
#line 246 "../src/Authentification/PasswordDialog.vala"
	_tmp4_ = self->priv->confirm_password_entry;
#line 246 "../src/Authentification/PasswordDialog.vala"
	_tmp5_ = gtk_entry_get_text (_tmp4_);
#line 246 "../src/Authentification/PasswordDialog.vala"
	_tmp6_ = _tmp5_;
#line 246 "../src/Authentification/PasswordDialog.vala"
	_tmp7_ = g_strdup (_tmp6_);
#line 246 "../src/Authentification/PasswordDialog.vala"
	confirm = _tmp7_;
#line 247 "../src/Authentification/PasswordDialog.vala"
	_tmp10_ = new_password;
#line 247 "../src/Authentification/PasswordDialog.vala"
	if (g_utf8_strlen (_tmp10_, (gssize) -1) > 0) {
#line 1020 "PasswordDialog.c"
		const gchar* _tmp11_;
#line 248 "../src/Authentification/PasswordDialog.vala"
		_tmp11_ = confirm;
#line 248 "../src/Authentification/PasswordDialog.vala"
		_tmp9_ = g_utf8_strlen (_tmp11_, (gssize) -1) > 0;
#line 1026 "PasswordDialog.c"
	} else {
#line 247 "../src/Authentification/PasswordDialog.vala"
		_tmp9_ = FALSE;
#line 1030 "PasswordDialog.c"
	}
#line 247 "../src/Authentification/PasswordDialog.vala"
	if (_tmp9_) {
#line 1034 "PasswordDialog.c"
		GCompareFunc _tmp12_;
		const gchar* _tmp13_;
		const gchar* _tmp14_;
#line 249 "../src/Authentification/PasswordDialog.vala"
		_tmp12_ = ((GCompareFunc) g_strcmp0);
#line 249 "../src/Authentification/PasswordDialog.vala"
		_tmp13_ = new_password;
#line 249 "../src/Authentification/PasswordDialog.vala"
		_tmp14_ = confirm;
#line 249 "../src/Authentification/PasswordDialog.vala"
		_tmp8_ = _tmp12_ (_tmp13_, _tmp14_) == 0;
#line 1046 "PasswordDialog.c"
	} else {
#line 247 "../src/Authentification/PasswordDialog.vala"
		_tmp8_ = FALSE;
#line 1050 "PasswordDialog.c"
	}
#line 247 "../src/Authentification/PasswordDialog.vala"
	self->priv->is_new_password_valid = _tmp8_;
#line 250 "../src/Authentification/PasswordDialog.vala"
	online_accounts_password_dialog_reset_ok (self);
#line 244 "../src/Authentification/PasswordDialog.vala"
	_g_free0 (confirm);
#line 244 "../src/Authentification/PasswordDialog.vala"
	_g_free0 (new_password);
#line 1060 "PasswordDialog.c"
}

static void
____lambda38__gtk_editable_changed (GtkEditable* _sender,
                                    gpointer self)
{
#line 244 "../src/Authentification/PasswordDialog.vala"
	___lambda38_ ((OnlineAccountsPasswordDialog*) self);
#line 1069 "PasswordDialog.c"
}

static void
___lambda39_ (OnlineAccountsPasswordDialog* self)
{
	GtkEntry* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
#line 256 "../src/Authentification/PasswordDialog.vala"
	_tmp0_ = self->priv->captcha_entry;
#line 256 "../src/Authentification/PasswordDialog.vala"
	_tmp1_ = gtk_entry_get_text (_tmp0_);
#line 256 "../src/Authentification/PasswordDialog.vala"
	_tmp2_ = _tmp1_;
#line 256 "../src/Authentification/PasswordDialog.vala"
	self->priv->is_captcha_valid = g_utf8_strlen (_tmp2_, (gssize) -1) > 0;
#line 257 "../src/Authentification/PasswordDialog.vala"
	online_accounts_password_dialog_reset_ok (self);
#line 1088 "PasswordDialog.c"
}

static void
____lambda39__gtk_editable_changed (GtkEditable* _sender,
                                    gpointer self)
{
#line 255 "../src/Authentification/PasswordDialog.vala"
	___lambda39_ ((OnlineAccountsPasswordDialog*) self);
#line 1097 "PasswordDialog.c"
}

static void
___lambda40_ (OnlineAccountsPasswordDialog* self,
              GtkEntryIconPosition pos,
              GdkEventButton* event)
{
#line 260 "../src/Authentification/PasswordDialog.vala"
	g_return_if_fail (event != NULL);
#line 261 "../src/Authentification/PasswordDialog.vala"
	if (pos == GTK_ENTRY_ICON_SECONDARY) {
#line 262 "../src/Authentification/PasswordDialog.vala"
		g_signal_emit (self, online_accounts_password_dialog_signals[ONLINE_ACCOUNTS_PASSWORD_DIALOG_REFRESH_CAPTCHA_NEEDED_SIGNAL], 0);
#line 1111 "PasswordDialog.c"
	}
}

static void
____lambda40__gtk_entry_icon_release (GtkEntry* _sender,
                                      GtkEntryIconPosition icon_pos,
                                      GdkEventButton* event,
                                      gpointer self)
{
#line 260 "../src/Authentification/PasswordDialog.vala"
	___lambda40_ ((OnlineAccountsPasswordDialog*) self, icon_pos, event);
#line 1123 "PasswordDialog.c"
}

static gboolean
online_accounts_password_dialog_real_set_parameters (OnlineAccountsDialog* base,
                                                     GHashTable* params)
{
	OnlineAccountsPasswordDialog * self;
	gboolean result = FALSE;
	GtkLabel* _tmp0_;
	const gchar* _tmp1_;
	GVariant* temp_string = NULL;
	gconstpointer _tmp2_;
	GtkEntry* _tmp3_;
	GVariant* _tmp4_;
	const gchar* _tmp9_;
	const gchar* _tmp13_;
	gconstpointer _tmp16_;
	GVariant* _tmp17_;
	gconstpointer _tmp23_;
	GVariant* _tmp24_;
#line 176 "../src/Authentification/PasswordDialog.vala"
	self = (OnlineAccountsPasswordDialog*) base;
#line 176 "../src/Authentification/PasswordDialog.vala"
	g_return_val_if_fail (params != NULL, FALSE);
#line 177 "../src/Authentification/PasswordDialog.vala"
	if (ONLINE_ACCOUNTS_DIALOG_CLASS (online_accounts_password_dialog_parent_class)->set_parameters (G_TYPE_CHECK_INSTANCE_CAST (self, ONLINE_ACCOUNTS_TYPE_DIALOG, OnlineAccountsDialog), params) == FALSE) {
#line 178 "../src/Authentification/PasswordDialog.vala"
		result = FALSE;
#line 178 "../src/Authentification/PasswordDialog.vala"
		return result;
#line 1154 "PasswordDialog.c"
	}
#line 181 "../src/Authentification/PasswordDialog.vala"
	if (online_accounts_password_dialog_validate_params (self, params) == FALSE) {
#line 182 "../src/Authentification/PasswordDialog.vala"
		result = FALSE;
#line 182 "../src/Authentification/PasswordDialog.vala"
		return result;
#line 1162 "PasswordDialog.c"
	}
#line 185 "../src/Authentification/PasswordDialog.vala"
	_tmp0_ = self->priv->provider_label;
#line 185 "../src/Authentification/PasswordDialog.vala"
	_tmp1_ = self->priv->display_name;
#line 185 "../src/Authentification/PasswordDialog.vala"
	gtk_label_set_label (_tmp0_, _tmp1_);
#line 187 "../src/Authentification/PasswordDialog.vala"
	_tmp2_ = g_hash_table_lookup (params, ONLINE_ACCOUNTS_KEY_USERNAME);
#line 187 "../src/Authentification/PasswordDialog.vala"
	temp_string = (GVariant*) _tmp2_;
#line 188 "../src/Authentification/PasswordDialog.vala"
	_tmp3_ = self->priv->username_entry;
#line 188 "../src/Authentification/PasswordDialog.vala"
	gtk_widget_set_sensitive ((GtkWidget*) _tmp3_, self->priv->query_username);
#line 189 "../src/Authentification/PasswordDialog.vala"
	_tmp4_ = temp_string;
#line 189 "../src/Authentification/PasswordDialog.vala"
	if (_tmp4_ != NULL) {
#line 1182 "PasswordDialog.c"
		const gchar* _tmp5_ = NULL;
		GVariant* _tmp6_;
		const gchar* _tmp7_;
		GtkEntry* _tmp8_;
#line 190 "../src/Authentification/PasswordDialog.vala"
		_tmp6_ = temp_string;
#line 190 "../src/Authentification/PasswordDialog.vala"
		_tmp7_ = g_variant_get_string (_tmp6_, NULL);
#line 190 "../src/Authentification/PasswordDialog.vala"
		_tmp5_ = _tmp7_;
#line 190 "../src/Authentification/PasswordDialog.vala"
		if (_tmp5_ == NULL) {
#line 190 "../src/Authentification/PasswordDialog.vala"
			_tmp5_ = "";
#line 1197 "PasswordDialog.c"
		}
#line 190 "../src/Authentification/PasswordDialog.vala"
		_tmp8_ = self->priv->username_entry;
#line 190 "../src/Authentification/PasswordDialog.vala"
		gtk_entry_set_text (_tmp8_, _tmp5_);
#line 1203 "PasswordDialog.c"
	}
#line 192 "../src/Authentification/PasswordDialog.vala"
	_tmp9_ = self->priv->forgot_password_url;
#line 192 "../src/Authentification/PasswordDialog.vala"
	if (_tmp9_ != NULL) {
#line 1209 "PasswordDialog.c"
		GtkLinkButton* _tmp10_;
		const gchar* _tmp11_;
		GtkLinkButton* _tmp12_;
#line 193 "../src/Authentification/PasswordDialog.vala"
		_tmp10_ = self->priv->forgot_button;
#line 193 "../src/Authentification/PasswordDialog.vala"
		_tmp11_ = self->priv->forgot_password_url;
#line 193 "../src/Authentification/PasswordDialog.vala"
		gtk_link_button_set_uri (_tmp10_, _tmp11_);
#line 194 "../src/Authentification/PasswordDialog.vala"
		_tmp12_ = self->priv->forgot_button;
#line 194 "../src/Authentification/PasswordDialog.vala"
		g_signal_connect_object (_tmp12_, "activate-link", (GCallback) ____lambda34__gtk_link_button_activate_link, self, 0);
#line 1223 "PasswordDialog.c"
	}
#line 202 "../src/Authentification/PasswordDialog.vala"
	_tmp13_ = self->priv->signup_url;
#line 202 "../src/Authentification/PasswordDialog.vala"
	if (_tmp13_ != NULL) {
#line 1229 "PasswordDialog.c"
		GtkLinkButton* _tmp14_;
		const gchar* _tmp15_;
#line 203 "../src/Authentification/PasswordDialog.vala"
		_tmp14_ = self->priv->signup_button;
#line 203 "../src/Authentification/PasswordDialog.vala"
		_tmp15_ = self->priv->signup_url;
#line 203 "../src/Authentification/PasswordDialog.vala"
		gtk_link_button_set_uri (_tmp14_, _tmp15_);
#line 1238 "PasswordDialog.c"
	}
#line 206 "../src/Authentification/PasswordDialog.vala"
	_tmp16_ = g_hash_table_lookup (params, ONLINE_ACCOUNTS_KEY_MESSAGE);
#line 206 "../src/Authentification/PasswordDialog.vala"
	temp_string = (GVariant*) _tmp16_;
#line 207 "../src/Authentification/PasswordDialog.vala"
	_tmp17_ = temp_string;
#line 207 "../src/Authentification/PasswordDialog.vala"
	if (_tmp17_ != NULL) {
#line 1248 "PasswordDialog.c"
		GtkLabel* _tmp18_;
		GVariant* _tmp19_;
		const gchar* _tmp20_;
		GtkLabel* _tmp21_;
#line 208 "../src/Authentification/PasswordDialog.vala"
		_tmp18_ = self->priv->message_label;
#line 208 "../src/Authentification/PasswordDialog.vala"
		_tmp19_ = temp_string;
#line 208 "../src/Authentification/PasswordDialog.vala"
		_tmp20_ = g_variant_get_string (_tmp19_, NULL);
#line 208 "../src/Authentification/PasswordDialog.vala"
		gtk_label_set_label (_tmp18_, _tmp20_);
#line 209 "../src/Authentification/PasswordDialog.vala"
		_tmp21_ = self->priv->message_label;
#line 209 "../src/Authentification/PasswordDialog.vala"
		gtk_widget_show ((GtkWidget*) _tmp21_);
#line 1265 "PasswordDialog.c"
	} else {
		GtkLabel* _tmp22_;
#line 211 "../src/Authentification/PasswordDialog.vala"
		_tmp22_ = self->priv->message_label;
#line 211 "../src/Authentification/PasswordDialog.vala"
		gtk_widget_hide ((GtkWidget*) _tmp22_);
#line 1272 "PasswordDialog.c"
	}
#line 214 "../src/Authentification/PasswordDialog.vala"
	_tmp23_ = g_hash_table_lookup (params, ONLINE_ACCOUNTS_KEY_CAPTCHA_URL);
#line 214 "../src/Authentification/PasswordDialog.vala"
	temp_string = (GVariant*) _tmp23_;
#line 215 "../src/Authentification/PasswordDialog.vala"
	_tmp24_ = temp_string;
#line 215 "../src/Authentification/PasswordDialog.vala"
	if (_tmp24_ != NULL) {
#line 1282 "PasswordDialog.c"
		GVariant* _tmp25_;
		const gchar* _tmp26_;
#line 216 "../src/Authentification/PasswordDialog.vala"
		_tmp25_ = temp_string;
#line 216 "../src/Authentification/PasswordDialog.vala"
		_tmp26_ = g_variant_get_string (_tmp25_, NULL);
#line 216 "../src/Authentification/PasswordDialog.vala"
		self->priv->query_captcha = online_accounts_dialog_refresh_captcha ((OnlineAccountsDialog*) self, _tmp26_);
#line 1291 "PasswordDialog.c"
	}
#line 219 "../src/Authentification/PasswordDialog.vala"
	if (self->priv->query_username) {
#line 1295 "PasswordDialog.c"
		GtkEntry* _tmp27_;
		GtkEntry* _tmp28_;
#line 220 "../src/Authentification/PasswordDialog.vala"
		_tmp27_ = self->priv->username_entry;
#line 220 "../src/Authentification/PasswordDialog.vala"
		g_signal_connect_object ((GtkEditable*) _tmp27_, "changed", (GCallback) ____lambda35__gtk_editable_changed, self, 0);
#line 225 "../src/Authentification/PasswordDialog.vala"
		_tmp28_ = self->priv->password_entry;
#line 225 "../src/Authentification/PasswordDialog.vala"
		g_signal_connect_object ((GtkEditable*) _tmp28_, "changed", (GCallback) ____lambda36__gtk_editable_changed, self, 0);
#line 1306 "PasswordDialog.c"
	}
#line 234 "../src/Authentification/PasswordDialog.vala"
	if (self->priv->query_confirm) {
#line 1310 "PasswordDialog.c"
		GtkEntry* _tmp29_;
		GtkEntry* _tmp30_;
#line 235 "../src/Authentification/PasswordDialog.vala"
		_tmp29_ = self->priv->new_password_entry;
#line 235 "../src/Authentification/PasswordDialog.vala"
		g_signal_connect_object ((GtkEditable*) _tmp29_, "changed", (GCallback) ____lambda37__gtk_editable_changed, self, 0);
#line 244 "../src/Authentification/PasswordDialog.vala"
		_tmp30_ = self->priv->confirm_password_entry;
#line 244 "../src/Authentification/PasswordDialog.vala"
		g_signal_connect_object ((GtkEditable*) _tmp30_, "changed", (GCallback) ____lambda38__gtk_editable_changed, self, 0);
#line 1321 "PasswordDialog.c"
	}
#line 254 "../src/Authentification/PasswordDialog.vala"
	if (self->priv->query_captcha) {
#line 1325 "PasswordDialog.c"
		GtkEntry* _tmp31_;
		GtkEntry* _tmp32_;
#line 255 "../src/Authentification/PasswordDialog.vala"
		_tmp31_ = self->priv->captcha_entry;
#line 255 "../src/Authentification/PasswordDialog.vala"
		g_signal_connect_object ((GtkEditable*) _tmp31_, "changed", (GCallback) ____lambda39__gtk_editable_changed, self, 0);
#line 260 "../src/Authentification/PasswordDialog.vala"
		_tmp32_ = self->priv->captcha_entry;
#line 260 "../src/Authentification/PasswordDialog.vala"
		g_signal_connect_object (_tmp32_, "icon-release", (GCallback) ____lambda40__gtk_entry_icon_release, self, 0);
#line 1336 "PasswordDialog.c"
	}
#line 266 "../src/Authentification/PasswordDialog.vala"
	online_accounts_password_dialog_reset_ok (self);
#line 268 "../src/Authentification/PasswordDialog.vala"
	result = TRUE;
#line 268 "../src/Authentification/PasswordDialog.vala"
	return result;
#line 1344 "PasswordDialog.c"
}

static void
__lambda33_ (OnlineAccountsPasswordDialog* self,
             const gchar* key)
{
#line 317 "../src/Authentification/PasswordDialog.vala"
	g_return_if_fail (key != NULL);
#line 318 "../src/Authentification/PasswordDialog.vala"
	g_warning ("PasswordDialog.vala:318: %s", key);
#line 1355 "PasswordDialog.c"
}

static void
___lambda33__gfunc (gconstpointer data,
                    gpointer self)
{
#line 317 "../src/Authentification/PasswordDialog.vala"
	__lambda33_ ((OnlineAccountsPasswordDialog*) self, (const gchar*) data);
#line 1364 "PasswordDialog.c"
}

static gboolean
online_accounts_password_dialog_validate_params (OnlineAccountsPasswordDialog* self,
                                                 GHashTable* params)
{
	gboolean result = FALSE;
	gboolean _tmp4_ = FALSE;
	gboolean _tmp5_ = FALSE;
	gboolean _tmp9_ = FALSE;
	GList* _tmp21_;
	GList* _tmp22_;
#line 271 "../src/Authentification/PasswordDialog.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 271 "../src/Authentification/PasswordDialog.vala"
	g_return_val_if_fail (params != NULL, FALSE);
#line 273 "../src/Authentification/PasswordDialog.vala"
	if (g_hash_table_contains (params, ONLINE_ACCOUNTS_KEY_QUERY_USERNAME)) {
#line 1383 "PasswordDialog.c"
		gconstpointer _tmp0_;
#line 274 "../src/Authentification/PasswordDialog.vala"
		_tmp0_ = g_hash_table_lookup (params, ONLINE_ACCOUNTS_KEY_QUERY_USERNAME);
#line 274 "../src/Authentification/PasswordDialog.vala"
		self->priv->query_username = g_variant_get_boolean ((GVariant*) _tmp0_);
#line 1389 "PasswordDialog.c"
	}
#line 277 "../src/Authentification/PasswordDialog.vala"
	if (g_hash_table_contains (params, ONLINE_ACCOUNTS_KEY_QUERY_URL)) {
#line 1393 "PasswordDialog.c"
		gconstpointer _tmp1_;
#line 278 "../src/Authentification/PasswordDialog.vala"
		_tmp1_ = g_hash_table_lookup (params, ONLINE_ACCOUNTS_KEY_QUERY_URL);
#line 278 "../src/Authentification/PasswordDialog.vala"
		self->priv->query_url = g_variant_get_boolean ((GVariant*) _tmp1_);
#line 1399 "PasswordDialog.c"
	}
#line 281 "../src/Authentification/PasswordDialog.vala"
	if (g_hash_table_contains (params, ONLINE_ACCOUNTS_KEY_QUERY_PASSWORD)) {
#line 1403 "PasswordDialog.c"
		gconstpointer _tmp2_;
#line 282 "../src/Authentification/PasswordDialog.vala"
		_tmp2_ = g_hash_table_lookup (params, ONLINE_ACCOUNTS_KEY_QUERY_PASSWORD);
#line 282 "../src/Authentification/PasswordDialog.vala"
		self->priv->query_password = g_variant_get_boolean ((GVariant*) _tmp2_);
#line 1409 "PasswordDialog.c"
	}
#line 285 "../src/Authentification/PasswordDialog.vala"
	if (g_hash_table_contains (params, ONLINE_ACCOUNTS_KEY_CONFIRM)) {
#line 1413 "PasswordDialog.c"
		gconstpointer _tmp3_;
#line 286 "../src/Authentification/PasswordDialog.vala"
		_tmp3_ = g_hash_table_lookup (params, ONLINE_ACCOUNTS_KEY_CONFIRM);
#line 286 "../src/Authentification/PasswordDialog.vala"
		self->priv->query_confirm = g_variant_get_boolean ((GVariant*) _tmp3_);
#line 1419 "PasswordDialog.c"
	}
#line 289 "../src/Authentification/PasswordDialog.vala"
	if (self->priv->query_username == FALSE) {
#line 289 "../src/Authentification/PasswordDialog.vala"
		_tmp5_ = self->priv->query_password == FALSE;
#line 1425 "PasswordDialog.c"
	} else {
#line 289 "../src/Authentification/PasswordDialog.vala"
		_tmp5_ = FALSE;
#line 1429 "PasswordDialog.c"
	}
#line 289 "../src/Authentification/PasswordDialog.vala"
	if (_tmp5_) {
#line 289 "../src/Authentification/PasswordDialog.vala"
		_tmp4_ = self->priv->query_confirm == FALSE;
#line 1435 "PasswordDialog.c"
	} else {
#line 289 "../src/Authentification/PasswordDialog.vala"
		_tmp4_ = FALSE;
#line 1439 "PasswordDialog.c"
	}
#line 289 "../src/Authentification/PasswordDialog.vala"
	if (_tmp4_) {
#line 290 "../src/Authentification/PasswordDialog.vala"
		g_warning ("PasswordDialog.vala:290: No Valid Query found");
#line 291 "../src/Authentification/PasswordDialog.vala"
		result = FALSE;
#line 291 "../src/Authentification/PasswordDialog.vala"
		return result;
#line 1449 "PasswordDialog.c"
	}
#line 294 "../src/Authentification/PasswordDialog.vala"
	if (g_hash_table_contains (params, ONLINE_ACCOUNTS_KEY_PASSWORD)) {
#line 1453 "PasswordDialog.c"
		gconstpointer _tmp6_;
		const gchar* _tmp7_;
		gchar* _tmp8_;
#line 295 "../src/Authentification/PasswordDialog.vala"
		_tmp6_ = g_hash_table_lookup (params, ONLINE_ACCOUNTS_KEY_PASSWORD);
#line 295 "../src/Authentification/PasswordDialog.vala"
		_tmp7_ = g_variant_get_string ((GVariant*) _tmp6_, NULL);
#line 295 "../src/Authentification/PasswordDialog.vala"
		_tmp8_ = g_strdup (_tmp7_);
#line 295 "../src/Authentification/PasswordDialog.vala"
		_g_free0 (self->priv->old_password);
#line 295 "../src/Authentification/PasswordDialog.vala"
		self->priv->old_password = _tmp8_;
#line 1467 "PasswordDialog.c"
	}
#line 298 "../src/Authentification/PasswordDialog.vala"
	if (self->priv->query_confirm) {
#line 1471 "PasswordDialog.c"
		const gchar* _tmp10_;
#line 298 "../src/Authentification/PasswordDialog.vala"
		_tmp10_ = self->priv->old_password;
#line 298 "../src/Authentification/PasswordDialog.vala"
		_tmp9_ = _tmp10_ == NULL;
#line 1477 "PasswordDialog.c"
	} else {
#line 298 "../src/Authentification/PasswordDialog.vala"
		_tmp9_ = FALSE;
#line 1481 "PasswordDialog.c"
	}
#line 298 "../src/Authentification/PasswordDialog.vala"
	if (_tmp9_) {
#line 299 "../src/Authentification/PasswordDialog.vala"
		g_warning ("PasswordDialog.vala:299: Wrong params for confirm query");
#line 300 "../src/Authentification/PasswordDialog.vala"
		result = FALSE;
#line 300 "../src/Authentification/PasswordDialog.vala"
		return result;
#line 1491 "PasswordDialog.c"
	}
#line 303 "../src/Authentification/PasswordDialog.vala"
	if (g_hash_table_contains (params, ONLINE_ACCOUNTS_KEY_DISPLAY_NAME)) {
#line 1495 "PasswordDialog.c"
		gconstpointer _tmp11_;
		const gchar* _tmp12_;
		gchar* _tmp13_;
#line 304 "../src/Authentification/PasswordDialog.vala"
		_tmp11_ = g_hash_table_lookup (params, ONLINE_ACCOUNTS_KEY_DISPLAY_NAME);
#line 304 "../src/Authentification/PasswordDialog.vala"
		_tmp12_ = g_variant_get_string ((GVariant*) _tmp11_, NULL);
#line 304 "../src/Authentification/PasswordDialog.vala"
		_tmp13_ = g_strdup (_tmp12_);
#line 304 "../src/Authentification/PasswordDialog.vala"
		_g_free0 (self->priv->display_name);
#line 304 "../src/Authentification/PasswordDialog.vala"
		self->priv->display_name = _tmp13_;
#line 1509 "PasswordDialog.c"
	} else {
		gchar* _tmp14_;
#line 306 "../src/Authentification/PasswordDialog.vala"
		_tmp14_ = g_strdup (_ ("Other Account"));
#line 306 "../src/Authentification/PasswordDialog.vala"
		_g_free0 (self->priv->display_name);
#line 306 "../src/Authentification/PasswordDialog.vala"
		self->priv->display_name = _tmp14_;
#line 1518 "PasswordDialog.c"
	}
#line 309 "../src/Authentification/PasswordDialog.vala"
	if (g_hash_table_contains (params, ONLINE_ACCOUNTS_KEY_FORGOT_PASSWORD_URL)) {
#line 1522 "PasswordDialog.c"
		gconstpointer _tmp15_;
		const gchar* _tmp16_;
		gchar* _tmp17_;
#line 310 "../src/Authentification/PasswordDialog.vala"
		_tmp15_ = g_hash_table_lookup (params, ONLINE_ACCOUNTS_KEY_FORGOT_PASSWORD_URL);
#line 310 "../src/Authentification/PasswordDialog.vala"
		_tmp16_ = g_variant_get_string ((GVariant*) _tmp15_, NULL);
#line 310 "../src/Authentification/PasswordDialog.vala"
		_tmp17_ = g_strdup (_tmp16_);
#line 310 "../src/Authentification/PasswordDialog.vala"
		_g_free0 (self->priv->forgot_password_url);
#line 310 "../src/Authentification/PasswordDialog.vala"
		self->priv->forgot_password_url = _tmp17_;
#line 1536 "PasswordDialog.c"
	}
#line 313 "../src/Authentification/PasswordDialog.vala"
	if (g_hash_table_contains (params, ONLINE_ACCOUNTS_KEY_SIGNUP_URL)) {
#line 1540 "PasswordDialog.c"
		gconstpointer _tmp18_;
		const gchar* _tmp19_;
		gchar* _tmp20_;
#line 314 "../src/Authentification/PasswordDialog.vala"
		_tmp18_ = g_hash_table_lookup (params, ONLINE_ACCOUNTS_KEY_SIGNUP_URL);
#line 314 "../src/Authentification/PasswordDialog.vala"
		_tmp19_ = g_variant_get_string ((GVariant*) _tmp18_, NULL);
#line 314 "../src/Authentification/PasswordDialog.vala"
		_tmp20_ = g_strdup (_tmp19_);
#line 314 "../src/Authentification/PasswordDialog.vala"
		_g_free0 (self->priv->signup_url);
#line 314 "../src/Authentification/PasswordDialog.vala"
		self->priv->signup_url = _tmp20_;
#line 1554 "PasswordDialog.c"
	}
#line 317 "../src/Authentification/PasswordDialog.vala"
	_tmp21_ = g_hash_table_get_keys (params);
#line 317 "../src/Authentification/PasswordDialog.vala"
	_tmp22_ = _tmp21_;
#line 317 "../src/Authentification/PasswordDialog.vala"
	g_list_foreach (_tmp22_, ___lambda33__gfunc, self);
#line 317 "../src/Authentification/PasswordDialog.vala"
	(_tmp22_ == NULL) ? NULL : (_tmp22_ = (g_list_free (_tmp22_), NULL));
#line 321 "../src/Authentification/PasswordDialog.vala"
	result = TRUE;
#line 321 "../src/Authentification/PasswordDialog.vala"
	return result;
#line 1568 "PasswordDialog.c"
}

static gboolean
online_accounts_password_dialog_real_refresh_captcha (OnlineAccountsDialog* base,
                                                      const gchar* uri)
{
	OnlineAccountsPasswordDialog * self;
	gboolean result = FALSE;
	gchar* filename = NULL;
	const gchar* _tmp6_;
	const gchar* _tmp7_;
	GtkImage* _tmp8_;
	const gchar* _tmp9_;
	gchar* used_filename = NULL;
	GtkImage* _tmp10_;
	gchar* _tmp11_;
	gchar* _tmp12_;
	const gchar* _tmp13_;
	gboolean is_valid = FALSE;
	GCompareFunc _tmp14_;
	const gchar* _tmp15_;
	const gchar* _tmp16_;
	GError* _inner_error0_ = NULL;
#line 324 "../src/Authentification/PasswordDialog.vala"
	self = (OnlineAccountsPasswordDialog*) base;
#line 324 "../src/Authentification/PasswordDialog.vala"
	g_return_val_if_fail (uri != NULL, FALSE);
#line 325 "../src/Authentification/PasswordDialog.vala"
	if (uri == NULL) {
#line 326 "../src/Authentification/PasswordDialog.vala"
		g_warning ("PasswordDialog.vala:326: invalid captcha value : %s", uri);
#line 327 "../src/Authentification/PasswordDialog.vala"
		((OnlineAccountsDialog*) self)->error_code = ONLINE_ACCOUNTS_SIGNON_UI_ERROR_BAD_CAPTCHA_URL;
#line 328 "../src/Authentification/PasswordDialog.vala"
		result = FALSE;
#line 328 "../src/Authentification/PasswordDialog.vala"
		return result;
#line 1606 "PasswordDialog.c"
	}
#line 331 "../src/Authentification/PasswordDialog.vala"
	filename = NULL;
#line 1610 "PasswordDialog.c"
	{
		gchar* _tmp0_ = NULL;
		gchar* _tmp1_;
		gchar* _tmp2_;
#line 333 "../src/Authentification/PasswordDialog.vala"
		_tmp1_ = g_filename_from_uri (uri, NULL, &_inner_error0_);
#line 333 "../src/Authentification/PasswordDialog.vala"
		_tmp0_ = _tmp1_;
#line 333 "../src/Authentification/PasswordDialog.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1621 "PasswordDialog.c"
			goto __catch5_g_error;
		}
#line 333 "../src/Authentification/PasswordDialog.vala"
		_tmp2_ = _tmp0_;
#line 333 "../src/Authentification/PasswordDialog.vala"
		_tmp0_ = NULL;
#line 333 "../src/Authentification/PasswordDialog.vala"
		_g_free0 (filename);
#line 333 "../src/Authentification/PasswordDialog.vala"
		filename = _tmp2_;
#line 332 "../src/Authentification/PasswordDialog.vala"
		_g_free0 (_tmp0_);
#line 1634 "PasswordDialog.c"
	}
	goto __finally5;
	__catch5_g_error:
	{
		GError* e = NULL;
		GError* _tmp3_;
		const gchar* _tmp4_;
#line 332 "../src/Authentification/PasswordDialog.vala"
		e = _inner_error0_;
#line 332 "../src/Authentification/PasswordDialog.vala"
		_inner_error0_ = NULL;
#line 335 "../src/Authentification/PasswordDialog.vala"
		_tmp3_ = e;
#line 335 "../src/Authentification/PasswordDialog.vala"
		_tmp4_ = _tmp3_->message;
#line 335 "../src/Authentification/PasswordDialog.vala"
		g_critical ("PasswordDialog.vala:335: %s", _tmp4_);
#line 332 "../src/Authentification/PasswordDialog.vala"
		_g_error_free0 (e);
#line 1654 "PasswordDialog.c"
	}
	__finally5:
#line 332 "../src/Authentification/PasswordDialog.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1659 "PasswordDialog.c"
		gboolean _tmp5_ = FALSE;
#line 332 "../src/Authentification/PasswordDialog.vala"
		_g_free0 (filename);
#line 332 "../src/Authentification/PasswordDialog.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 332 "../src/Authentification/PasswordDialog.vala"
		g_clear_error (&_inner_error0_);
#line 332 "../src/Authentification/PasswordDialog.vala"
		return _tmp5_;
#line 1669 "PasswordDialog.c"
	}
#line 338 "../src/Authentification/PasswordDialog.vala"
	_tmp6_ = filename;
#line 338 "../src/Authentification/PasswordDialog.vala"
	if (_tmp6_ == NULL) {
#line 339 "../src/Authentification/PasswordDialog.vala"
		g_warning ("PasswordDialog.vala:339: invalid captcha value : %s", uri);
#line 340 "../src/Authentification/PasswordDialog.vala"
		((OnlineAccountsDialog*) self)->error_code = ONLINE_ACCOUNTS_SIGNON_UI_ERROR_BAD_CAPTCHA_URL;
#line 341 "../src/Authentification/PasswordDialog.vala"
		result = FALSE;
#line 341 "../src/Authentification/PasswordDialog.vala"
		_g_free0 (filename);
#line 341 "../src/Authentification/PasswordDialog.vala"
		return result;
#line 1685 "PasswordDialog.c"
	}
#line 344 "../src/Authentification/PasswordDialog.vala"
	_tmp7_ = filename;
#line 344 "../src/Authentification/PasswordDialog.vala"
	g_debug ("PasswordDialog.vala:344: setting captcha : %s", _tmp7_);
#line 345 "../src/Authentification/PasswordDialog.vala"
	_tmp8_ = self->priv->captcha_image;
#line 345 "../src/Authentification/PasswordDialog.vala"
	_tmp9_ = filename;
#line 345 "../src/Authentification/PasswordDialog.vala"
	gtk_image_set_from_file (_tmp8_, _tmp9_);
#line 346 "../src/Authentification/PasswordDialog.vala"
	_tmp10_ = self->priv->captcha_image;
#line 346 "../src/Authentification/PasswordDialog.vala"
	g_object_get (_tmp10_, "file", &_tmp11_, NULL);
#line 346 "../src/Authentification/PasswordDialog.vala"
	_tmp12_ = _tmp11_;
#line 346 "../src/Authentification/PasswordDialog.vala"
	used_filename = _tmp12_;
#line 347 "../src/Authentification/PasswordDialog.vala"
	_tmp13_ = used_filename;
#line 347 "../src/Authentification/PasswordDialog.vala"
	g_debug ("PasswordDialog.vala:347: Used file : %s", _tmp13_);
#line 348 "../src/Authentification/PasswordDialog.vala"
	_tmp14_ = ((GCompareFunc) g_strcmp0);
#line 348 "../src/Authentification/PasswordDialog.vala"
	_tmp15_ = filename;
#line 348 "../src/Authentification/PasswordDialog.vala"
	_tmp16_ = used_filename;
#line 348 "../src/Authentification/PasswordDialog.vala"
	is_valid = _tmp14_ (_tmp15_, _tmp16_) == 0;
#line 349 "../src/Authentification/PasswordDialog.vala"
	if (is_valid == FALSE) {
#line 350 "../src/Authentification/PasswordDialog.vala"
		((OnlineAccountsDialog*) self)->error_code = ONLINE_ACCOUNTS_SIGNON_UI_ERROR_BAD_CAPTCHA;
#line 351 "../src/Authentification/PasswordDialog.vala"
		result = FALSE;
#line 351 "../src/Authentification/PasswordDialog.vala"
		_g_free0 (used_filename);
#line 351 "../src/Authentification/PasswordDialog.vala"
		_g_free0 (filename);
#line 351 "../src/Authentification/PasswordDialog.vala"
		return result;
#line 1729 "PasswordDialog.c"
	}
#line 354 "../src/Authentification/PasswordDialog.vala"
	self->priv->query_captcha = TRUE;
#line 355 "../src/Authentification/PasswordDialog.vala"
	result = TRUE;
#line 355 "../src/Authentification/PasswordDialog.vala"
	_g_free0 (used_filename);
#line 355 "../src/Authentification/PasswordDialog.vala"
	_g_free0 (filename);
#line 355 "../src/Authentification/PasswordDialog.vala"
	return result;
#line 1741 "PasswordDialog.c"
}

static GHashTable*
online_accounts_password_dialog_real_get_reply (OnlineAccountsDialog* base)
{
	OnlineAccountsPasswordDialog * self;
	GHashTable* result = NULL;
	GHashTable* table = NULL;
	GHashTable* _tmp0_;
	gchar* _tmp1_;
	GtkEntry* _tmp2_;
	const gchar* _tmp3_;
	const gchar* _tmp4_;
	GVariant* _tmp5_;
	gchar* _tmp6_;
	GtkEntry* _tmp7_;
	const gchar* _tmp8_;
	const gchar* _tmp9_;
	GVariant* _tmp10_;
#line 358 "../src/Authentification/PasswordDialog.vala"
	self = (OnlineAccountsPasswordDialog*) base;
#line 359 "../src/Authentification/PasswordDialog.vala"
	_tmp0_ = ONLINE_ACCOUNTS_DIALOG_CLASS (online_accounts_password_dialog_parent_class)->get_reply (G_TYPE_CHECK_INSTANCE_CAST (self, ONLINE_ACCOUNTS_TYPE_DIALOG, OnlineAccountsDialog));
#line 359 "../src/Authentification/PasswordDialog.vala"
	table = _tmp0_;
#line 360 "../src/Authentification/PasswordDialog.vala"
	_tmp1_ = g_strdup (ONLINE_ACCOUNTS_KEY_USERNAME);
#line 360 "../src/Authentification/PasswordDialog.vala"
	_tmp2_ = self->priv->username_entry;
#line 360 "../src/Authentification/PasswordDialog.vala"
	_tmp3_ = gtk_entry_get_text (_tmp2_);
#line 360 "../src/Authentification/PasswordDialog.vala"
	_tmp4_ = _tmp3_;
#line 360 "../src/Authentification/PasswordDialog.vala"
	_tmp5_ = g_variant_new_string (_tmp4_);
#line 360 "../src/Authentification/PasswordDialog.vala"
	g_variant_ref_sink (_tmp5_);
#line 360 "../src/Authentification/PasswordDialog.vala"
	g_hash_table_insert (table, _tmp1_, _tmp5_);
#line 361 "../src/Authentification/PasswordDialog.vala"
	_tmp6_ = g_strdup (ONLINE_ACCOUNTS_KEY_PASSWORD);
#line 361 "../src/Authentification/PasswordDialog.vala"
	_tmp7_ = self->priv->password_entry;
#line 361 "../src/Authentification/PasswordDialog.vala"
	_tmp8_ = gtk_entry_get_text (_tmp7_);
#line 361 "../src/Authentification/PasswordDialog.vala"
	_tmp9_ = _tmp8_;
#line 361 "../src/Authentification/PasswordDialog.vala"
	_tmp10_ = g_variant_new_string (_tmp9_);
#line 361 "../src/Authentification/PasswordDialog.vala"
	g_variant_ref_sink (_tmp10_);
#line 361 "../src/Authentification/PasswordDialog.vala"
	g_hash_table_insert (table, _tmp6_, _tmp10_);
#line 362 "../src/Authentification/PasswordDialog.vala"
	result = table;
#line 362 "../src/Authentification/PasswordDialog.vala"
	return result;
#line 1799 "PasswordDialog.c"
}

static void
online_accounts_password_dialog_reset_ok (OnlineAccountsPasswordDialog* self)
{
	gboolean state = FALSE;
	GtkButton* _tmp3_;
	gboolean _tmp4_;
	gboolean _tmp5_;
#line 365 "../src/Authentification/PasswordDialog.vala"
	g_return_if_fail (self != NULL);
#line 366 "../src/Authentification/PasswordDialog.vala"
	state = FALSE;
#line 368 "../src/Authentification/PasswordDialog.vala"
	if (self->priv->query_username) {
#line 1815 "PasswordDialog.c"
		gboolean _tmp0_ = FALSE;
#line 369 "../src/Authentification/PasswordDialog.vala"
		if (self->priv->is_username_valid) {
#line 369 "../src/Authentification/PasswordDialog.vala"
			_tmp0_ = self->priv->is_password_valid;
#line 1821 "PasswordDialog.c"
		} else {
#line 369 "../src/Authentification/PasswordDialog.vala"
			_tmp0_ = FALSE;
#line 1825 "PasswordDialog.c"
		}
#line 369 "../src/Authentification/PasswordDialog.vala"
		state = _tmp0_;
#line 1829 "PasswordDialog.c"
	} else {
#line 370 "../src/Authentification/PasswordDialog.vala"
		if (self->priv->query_password) {
#line 371 "../src/Authentification/PasswordDialog.vala"
			state = self->priv->is_password_valid;
#line 1835 "PasswordDialog.c"
		} else {
#line 372 "../src/Authentification/PasswordDialog.vala"
			if (self->priv->query_confirm) {
#line 1839 "PasswordDialog.c"
				gboolean _tmp1_ = FALSE;
#line 373 "../src/Authentification/PasswordDialog.vala"
				if (self->priv->is_password_valid) {
#line 373 "../src/Authentification/PasswordDialog.vala"
					_tmp1_ = self->priv->is_new_password_valid;
#line 1845 "PasswordDialog.c"
				} else {
#line 373 "../src/Authentification/PasswordDialog.vala"
					_tmp1_ = FALSE;
#line 1849 "PasswordDialog.c"
				}
#line 373 "../src/Authentification/PasswordDialog.vala"
				state = _tmp1_;
#line 1853 "PasswordDialog.c"
			}
		}
	}
#line 375 "../src/Authentification/PasswordDialog.vala"
	if (self->priv->query_captcha) {
#line 1859 "PasswordDialog.c"
		gboolean _tmp2_ = FALSE;
#line 376 "../src/Authentification/PasswordDialog.vala"
		if (state) {
#line 376 "../src/Authentification/PasswordDialog.vala"
			_tmp2_ = self->priv->is_captcha_valid;
#line 1865 "PasswordDialog.c"
		} else {
#line 376 "../src/Authentification/PasswordDialog.vala"
			_tmp2_ = FALSE;
#line 1869 "PasswordDialog.c"
		}
#line 376 "../src/Authentification/PasswordDialog.vala"
		state = _tmp2_;
#line 1873 "PasswordDialog.c"
	}
#line 378 "../src/Authentification/PasswordDialog.vala"
	_tmp3_ = self->priv->save_button;
#line 378 "../src/Authentification/PasswordDialog.vala"
	_tmp4_ = gtk_widget_get_sensitive ((GtkWidget*) _tmp3_);
#line 378 "../src/Authentification/PasswordDialog.vala"
	_tmp5_ = _tmp4_;
#line 378 "../src/Authentification/PasswordDialog.vala"
	if (_tmp5_ != state) {
#line 1883 "PasswordDialog.c"
		GtkButton* _tmp6_;
#line 379 "../src/Authentification/PasswordDialog.vala"
		_tmp6_ = self->priv->save_button;
#line 379 "../src/Authentification/PasswordDialog.vala"
		gtk_widget_set_sensitive ((GtkWidget*) _tmp6_, state);
#line 1889 "PasswordDialog.c"
	}
}

static void
online_accounts_password_dialog_class_init (OnlineAccountsPasswordDialogClass * klass,
                                            gpointer klass_data)
{
#line 23 "../src/Authentification/PasswordDialog.vala"
	online_accounts_password_dialog_parent_class = g_type_class_peek_parent (klass);
#line 23 "../src/Authentification/PasswordDialog.vala"
	g_type_class_adjust_private_offset (klass, &OnlineAccountsPasswordDialog_private_offset);
#line 23 "../src/Authentification/PasswordDialog.vala"
	((OnlineAccountsDialogClass *) klass)->set_parameters = (gboolean (*) (OnlineAccountsDialog*, GHashTable*)) online_accounts_password_dialog_real_set_parameters;
#line 23 "../src/Authentification/PasswordDialog.vala"
	((OnlineAccountsDialogClass *) klass)->refresh_captcha = (gboolean (*) (OnlineAccountsDialog*, const gchar*)) online_accounts_password_dialog_real_refresh_captcha;
#line 23 "../src/Authentification/PasswordDialog.vala"
	((OnlineAccountsDialogClass *) klass)->get_reply = (GHashTable* (*) (OnlineAccountsDialog*)) online_accounts_password_dialog_real_get_reply;
#line 23 "../src/Authentification/PasswordDialog.vala"
	G_OBJECT_CLASS (klass)->finalize = online_accounts_password_dialog_finalize;
#line 23 "../src/Authentification/PasswordDialog.vala"
	online_accounts_password_dialog_signals[ONLINE_ACCOUNTS_PASSWORD_DIALOG_REFRESH_CAPTCHA_NEEDED_SIGNAL] = g_signal_new ("refresh-captcha-needed", ONLINE_ACCOUNTS_TYPE_PASSWORD_DIALOG, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 1911 "PasswordDialog.c"
}

static void
online_accounts_password_dialog_instance_init (OnlineAccountsPasswordDialog * self,
                                               gpointer klass)
{
#line 23 "../src/Authentification/PasswordDialog.vala"
	self->priv = online_accounts_password_dialog_get_instance_private (self);
#line 39 "../src/Authentification/PasswordDialog.vala"
	self->priv->query_url = FALSE;
#line 40 "../src/Authentification/PasswordDialog.vala"
	self->priv->query_username = FALSE;
#line 41 "../src/Authentification/PasswordDialog.vala"
	self->priv->query_password = FALSE;
#line 42 "../src/Authentification/PasswordDialog.vala"
	self->priv->query_confirm = FALSE;
#line 43 "../src/Authentification/PasswordDialog.vala"
	self->priv->query_captcha = FALSE;
#line 45 "../src/Authentification/PasswordDialog.vala"
	self->priv->is_username_valid = FALSE;
#line 46 "../src/Authentification/PasswordDialog.vala"
	self->priv->is_password_valid = FALSE;
#line 47 "../src/Authentification/PasswordDialog.vala"
	self->priv->is_new_password_valid = FALSE;
#line 48 "../src/Authentification/PasswordDialog.vala"
	self->priv->is_captcha_valid = FALSE;
#line 1938 "PasswordDialog.c"
}

static void
online_accounts_password_dialog_finalize (GObject * obj)
{
	OnlineAccountsPasswordDialog * self;
#line 23 "../src/Authentification/PasswordDialog.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, ONLINE_ACCOUNTS_TYPE_PASSWORD_DIALOG, OnlineAccountsPasswordDialog);
#line 25 "../src/Authentification/PasswordDialog.vala"
	_g_object_unref0 (self->priv->url_entry);
#line 26 "../src/Authentification/PasswordDialog.vala"
	_g_object_unref0 (self->priv->username_entry);
#line 27 "../src/Authentification/PasswordDialog.vala"
	_g_object_unref0 (self->priv->password_entry);
#line 28 "../src/Authentification/PasswordDialog.vala"
	_g_object_unref0 (self->priv->new_password_entry);
#line 29 "../src/Authentification/PasswordDialog.vala"
	_g_object_unref0 (self->priv->confirm_password_entry);
#line 30 "../src/Authentification/PasswordDialog.vala"
	_g_object_unref0 (self->priv->captcha_entry);
#line 31 "../src/Authentification/PasswordDialog.vala"
	_g_object_unref0 (self->priv->cancel_button);
#line 32 "../src/Authentification/PasswordDialog.vala"
	_g_object_unref0 (self->priv->save_button);
#line 33 "../src/Authentification/PasswordDialog.vala"
	_g_object_unref0 (self->priv->forgot_button);
#line 34 "../src/Authentification/PasswordDialog.vala"
	_g_object_unref0 (self->priv->signup_button);
#line 35 "../src/Authentification/PasswordDialog.vala"
	_g_object_unref0 (self->priv->captcha_image);
#line 36 "../src/Authentification/PasswordDialog.vala"
	_g_object_unref0 (self->priv->message_label);
#line 37 "../src/Authentification/PasswordDialog.vala"
	_g_object_unref0 (self->priv->provider_label);
#line 50 "../src/Authentification/PasswordDialog.vala"
	_g_free0 (self->priv->display_name);
#line 51 "../src/Authentification/PasswordDialog.vala"
	_g_free0 (self->priv->old_password);
#line 52 "../src/Authentification/PasswordDialog.vala"
	_g_free0 (self->priv->forgot_password_url);
#line 53 "../src/Authentification/PasswordDialog.vala"
	_g_free0 (self->priv->signup_url);
#line 23 "../src/Authentification/PasswordDialog.vala"
	G_OBJECT_CLASS (online_accounts_password_dialog_parent_class)->finalize (obj);
#line 1983 "PasswordDialog.c"
}

GType
online_accounts_password_dialog_get_type (void)
{
	static volatile gsize online_accounts_password_dialog_type_id__volatile = 0;
	if (g_once_init_enter (&online_accounts_password_dialog_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (OnlineAccountsPasswordDialogClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) online_accounts_password_dialog_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (OnlineAccountsPasswordDialog), 0, (GInstanceInitFunc) online_accounts_password_dialog_instance_init, NULL };
		GType online_accounts_password_dialog_type_id;
		online_accounts_password_dialog_type_id = g_type_register_static (ONLINE_ACCOUNTS_TYPE_DIALOG, "OnlineAccountsPasswordDialog", &g_define_type_info, 0);
		OnlineAccountsPasswordDialog_private_offset = g_type_add_instance_private (online_accounts_password_dialog_type_id, sizeof (OnlineAccountsPasswordDialogPrivate));
		g_once_init_leave (&online_accounts_password_dialog_type_id__volatile, online_accounts_password_dialog_type_id);
	}
	return online_accounts_password_dialog_type_id__volatile;
}

