/* AppRow.c generated by valac 0.45.3, the Vala compiler
 * generated from AppRow.vala, do not modify */

/*
* Copyright (c) 2013-2018 elementary, Inc. (https://elementary.io)
*
* This library is free software; you can redistribute it and/or
* modify it under the terms of the GNU Library General Public
* License as published by the Free Software Foundation; either
* version 2 of the License, or (at your option) any later version.
*
* This library is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* Library General Public License for more details.
*
* You should have received a copy of the GNU Library General Public
* License along with this library; if not, write to the
* Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
* Boston, MA 02110-1301 USA.
*
* Authored by: Corentin Noël <corentin@elementary.io>
*/

#include <gtk/gtk.h>
#include <glib-object.h>
#include <libaccounts-glib/accounts-glib.h>
#include <libsignon-glib/signon-glib.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <gio/gdesktopappinfo.h>
#include <gio/gio.h>

#define TYPE_APP_ROW (app_row_get_type ())
#define APP_ROW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_APP_ROW, AppRow))
#define APP_ROW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_APP_ROW, AppRowClass))
#define IS_APP_ROW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_APP_ROW))
#define IS_APP_ROW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_APP_ROW))
#define APP_ROW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_APP_ROW, AppRowClass))

typedef struct _AppRow AppRow;
typedef struct _AppRowClass AppRowClass;
typedef struct _AppRowPrivate AppRowPrivate;
enum  {
	APP_ROW_0_PROPERTY,
	APP_ROW_ACCOUNT_PROPERTY,
	APP_ROW_APP_PROPERTY,
	APP_ROW_SERVICE_PROPERTY,
	APP_ROW_IDENTITY_PROPERTY,
	APP_ROW_NUM_PROPERTIES
};
static GParamSpec* app_row_properties[APP_ROW_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define __vala_AgApplication_free0(var) ((var == NULL) ? NULL : (var = (_vala_AgApplication_free (var), NULL)))
#define __vala_AgService_free0(var) ((var == NULL) ? NULL : (var = (_vala_AgService_free (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define __vala_SignonIdentityInfo_free0(var) ((var == NULL) ? NULL : (var = (_vala_SignonIdentityInfo_free (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
typedef struct _AppRowAllowAppData AppRowAllowAppData;
typedef struct _Block8Data Block8Data;
typedef struct _AppRowDenyAppData AppRowDenyAppData;

struct _AppRow {
	GtkListBoxRow parent_instance;
	AppRowPrivate * priv;
};

struct _AppRowClass {
	GtkListBoxRowClass parent_class;
};

struct _AppRowPrivate {
	AgAccount* _account;
	AgApplication* _app;
	AgService* _service;
	SignonIdentity* _identity;
	GtkCheckButton* app_switch;
};

struct _AppRowAllowAppData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	AppRow* self;
	AgAccount* _tmp0_;
	AgService* _tmp1_;
	SignonIdentityInfo* info;
	SignonIdentity* _tmp2_;
	SignonIdentityInfo* _tmp3_;
	SignonIdentityInfo* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	SignonIdentity* _tmp7_;
	SignonIdentityInfo* _tmp8_;
	GtkCheckButton* _tmp9_;
	AgAccount* _tmp10_;
	AgAccount* _tmp11_;
	GError* e;
	GError* _tmp12_;
	const gchar* _tmp13_;
	AgAccount* _tmp14_;
	GError* _inner_error0_;
};

struct _Block8Data {
	int _ref_count_;
	AppRow* self;
	GList* list;
	gchar* path;
};

struct _AppRowDenyAppData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	AppRow* self;
	Block8Data* _data8_;
	AgAccount* _tmp0_;
	AgService* _tmp1_;
	SignonIdentityInfo* info;
	SignonIdentity* _tmp2_;
	SignonIdentityInfo* _tmp3_;
	SignonIdentityInfo* _tmp4_;
	GList* _tmp5_;
	gchar* _tmp6_;
	GList* _tmp7_;
	SignonIdentityInfo* _tmp8_;
	GList* _tmp9_;
	SignonIdentity* _tmp10_;
	SignonIdentityInfo* _tmp11_;
	GtkCheckButton* _tmp12_;
	AgAccount* _tmp13_;
	AgAccount* _tmp14_;
	GError* e;
	GError* _tmp15_;
	const gchar* _tmp16_;
	AgAccount* _tmp17_;
	GError* _inner_error0_;
};

static gint AppRow_private_offset;
static gpointer app_row_parent_class = NULL;

GType app_row_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (AppRow, g_object_unref)
static void _vala_AgApplication_free (AgApplication* self);
static void _vala_AgService_free (AgService* self);
AppRow* app_row_new (AgAccount* account,
                     AgApplication* app,
                     AgService* service,
                     SignonIdentity* identity);
AppRow* app_row_construct (GType object_type,
                           AgAccount* account,
                           AgApplication* app,
                           AgService* service,
                           SignonIdentity* identity);
static gchar* app_row_get_app_path (AppRow* self);
AgApplication* app_row_get_app (AppRow* self);
void app_row_check_acl (AppRow* self,
                        GList* acl);
static void app_row_allow_app_data_free (gpointer _data);
void app_row_allow_app (AppRow* self,
                        GAsyncReadyCallback _callback_,
                        gpointer _user_data_);
void app_row_allow_app_finish (AppRow* self,
                               GAsyncResult* _res_);
static gboolean app_row_allow_app_co (AppRowAllowAppData* _data_);
AgAccount* app_row_get_account (AppRow* self);
AgService* app_row_get_service (AppRow* self);
SignonIdentity* app_row_get_identity (AppRow* self);
static void app_row_allow_app_ready (GObject* source_object,
                              GAsyncResult* _res_,
                              gpointer _user_data_);
static void _vala_SignonIdentityInfo_free (SignonIdentityInfo* self);
static void app_row_deny_app_data_free (gpointer _data);
void app_row_deny_app (AppRow* self,
                       GAsyncReadyCallback _callback_,
                       gpointer _user_data_);
void app_row_deny_app_finish (AppRow* self,
                              GAsyncResult* _res_);
static gboolean app_row_deny_app_co (AppRowDenyAppData* _data_);
static Block8Data* block8_data_ref (Block8Data* _data8_);
static void _vala_SignonSecurityContext_free (SignonSecurityContext* self);
static void __vala_SignonSecurityContext_free0_ (gpointer var);
static inline void _g_list_free___vala_SignonSecurityContext_free0_ (GList* self);
static void block8_data_unref (void * _userdata_);
static void app_row_deny_app_ready (GObject* source_object,
                             GAsyncResult* _res_,
                             gpointer _user_data_);
static void ___lambda6_ (Block8Data* _data8_,
                  SignonSecurityContext* nth);
static void ____lambda6__gfunc (gconstpointer data,
                         gpointer self);
static void app_row_set_account (AppRow* self,
                          AgAccount* value);
static void app_row_set_app (AppRow* self,
                      AgApplication* value);
static AgApplication* _vala_AgApplication_copy (AgApplication* self);
static void app_row_set_service (AppRow* self,
                          AgService* value);
static AgService* _vala_AgService_copy (AgService* self);
static void app_row_set_identity (AppRow* self,
                           SignonIdentity* value);
static GObject * app_row_constructor (GType type,
                               guint n_construct_properties,
                               GObjectConstructParam * construct_properties);
static void _app_row___lambda7_ (AppRow* self);
static void __app_row___lambda7__gtk_button_activate (GtkButton* _sender,
                                               gpointer self);
static void app_row_finalize (GObject * obj);
static void _vala_app_row_get_property (GObject * object,
                                 guint property_id,
                                 GValue * value,
                                 GParamSpec * pspec);
static void _vala_app_row_set_property (GObject * object,
                                 guint property_id,
                                 const GValue * value,
                                 GParamSpec * pspec);

static inline gpointer
app_row_get_instance_private (AppRow* self)
{
	return G_STRUCT_MEMBER_P (self, AppRow_private_offset);
}

static void
_vala_AgApplication_free (AgApplication* self)
{
#line 24 "../src/Widgets/AppRow.vala"
	g_boxed_free (ag_application_get_type (), self);
#line 235 "AppRow.c"
}

static void
_vala_AgService_free (AgService* self)
{
#line 25 "../src/Widgets/AppRow.vala"
	g_boxed_free (ag_service_get_type (), self);
#line 243 "AppRow.c"
}

AppRow*
app_row_construct (GType object_type,
                   AgAccount* account,
                   AgApplication* app,
                   AgService* service,
                   SignonIdentity* identity)
{
	AppRow * self = NULL;
#line 30 "../src/Widgets/AppRow.vala"
	g_return_val_if_fail (account != NULL, NULL);
#line 30 "../src/Widgets/AppRow.vala"
	g_return_val_if_fail (app != NULL, NULL);
#line 30 "../src/Widgets/AppRow.vala"
	g_return_val_if_fail (service != NULL, NULL);
#line 30 "../src/Widgets/AppRow.vala"
	g_return_val_if_fail (identity != NULL, NULL);
#line 31 "../src/Widgets/AppRow.vala"
	self = (AppRow*) g_object_new (object_type, "account", account, "app", app, "identity", identity, "service", service, NULL);
#line 30 "../src/Widgets/AppRow.vala"
	return self;
#line 266 "AppRow.c"
}

AppRow*
app_row_new (AgAccount* account,
             AgApplication* app,
             AgService* service,
             SignonIdentity* identity)
{
#line 30 "../src/Widgets/AppRow.vala"
	return app_row_construct (TYPE_APP_ROW, account, app, service, identity);
#line 277 "AppRow.c"
}

static gboolean
string_contains (const gchar* self,
                 const gchar* needle)
{
	gboolean result = FALSE;
	gchar* _tmp0_;
#line 1476 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1476 "glib-2.0.vapi"
	g_return_val_if_fail (needle != NULL, FALSE);
#line 1477 "glib-2.0.vapi"
	_tmp0_ = strstr ((gchar*) self, (gchar*) needle);
#line 1477 "glib-2.0.vapi"
	result = _tmp0_ != NULL;
#line 1477 "glib-2.0.vapi"
	return result;
#line 296 "AppRow.c"
}

static gchar*
app_row_get_app_path (AppRow* self)
{
	gchar* result = NULL;
	GDesktopAppInfo* app_info = NULL;
	AgApplication* _tmp0_;
	GDesktopAppInfo* _tmp1_;
	const gchar* exec = NULL;
	GDesktopAppInfo* _tmp2_;
	const gchar* _tmp3_;
	const gchar* _tmp4_;
	const gchar* _tmp7_;
	gchar* _tmp8_;
#line 70 "../src/Widgets/AppRow.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 71 "../src/Widgets/AppRow.vala"
	_tmp0_ = self->priv->_app;
#line 71 "../src/Widgets/AppRow.vala"
	_tmp1_ = ag_application_get_desktop_app_info (_tmp0_);
#line 71 "../src/Widgets/AppRow.vala"
	app_info = _tmp1_;
#line 72 "../src/Widgets/AppRow.vala"
	_tmp2_ = app_info;
#line 72 "../src/Widgets/AppRow.vala"
	_tmp3_ = g_app_info_get_executable ((GAppInfo*) _tmp2_);
#line 72 "../src/Widgets/AppRow.vala"
	exec = _tmp3_;
#line 73 "../src/Widgets/AppRow.vala"
	_tmp4_ = exec;
#line 73 "../src/Widgets/AppRow.vala"
	if (string_contains (_tmp4_, "/") == FALSE) {
#line 330 "AppRow.c"
		const gchar* _tmp5_;
		gchar* _tmp6_;
#line 74 "../src/Widgets/AppRow.vala"
		_tmp5_ = exec;
#line 74 "../src/Widgets/AppRow.vala"
		_tmp6_ = g_find_program_in_path (_tmp5_);
#line 74 "../src/Widgets/AppRow.vala"
		result = _tmp6_;
#line 74 "../src/Widgets/AppRow.vala"
		_g_object_unref0 (app_info);
#line 74 "../src/Widgets/AppRow.vala"
		return result;
#line 343 "AppRow.c"
	}
#line 77 "../src/Widgets/AppRow.vala"
	_tmp7_ = exec;
#line 77 "../src/Widgets/AppRow.vala"
	_tmp8_ = g_strdup (_tmp7_);
#line 77 "../src/Widgets/AppRow.vala"
	result = _tmp8_;
#line 77 "../src/Widgets/AppRow.vala"
	_g_object_unref0 (app_info);
#line 77 "../src/Widgets/AppRow.vala"
	return result;
#line 355 "AppRow.c"
}

void
app_row_check_acl (AppRow* self,
                   GList* acl)
{
	gchar* path = NULL;
	gchar* _tmp0_;
	GtkCheckButton* _tmp11_;
#line 80 "../src/Widgets/AppRow.vala"
	g_return_if_fail (self != NULL);
#line 81 "../src/Widgets/AppRow.vala"
	_tmp0_ = app_row_get_app_path (self);
#line 81 "../src/Widgets/AppRow.vala"
	path = _tmp0_;
#line 371 "AppRow.c"
	{
		GList* nth = NULL;
		GList* _tmp1_;
#line 82 "../src/Widgets/AppRow.vala"
		_tmp1_ = g_list_first (acl);
#line 82 "../src/Widgets/AppRow.vala"
		nth = _tmp1_;
#line 379 "AppRow.c"
		{
			gboolean _tmp2_ = FALSE;
#line 82 "../src/Widgets/AppRow.vala"
			_tmp2_ = TRUE;
#line 82 "../src/Widgets/AppRow.vala"
			while (TRUE) {
#line 386 "AppRow.c"
				GList* _tmp5_;
				GList* _tmp6_;
				gconstpointer _tmp7_;
				const gchar* _tmp8_;
				const gchar* _tmp9_;
#line 82 "../src/Widgets/AppRow.vala"
				if (!_tmp2_) {
#line 394 "AppRow.c"
					GList* _tmp3_;
					GList* _tmp4_;
#line 82 "../src/Widgets/AppRow.vala"
					_tmp3_ = nth;
#line 82 "../src/Widgets/AppRow.vala"
					_tmp4_ = _tmp3_->next;
#line 82 "../src/Widgets/AppRow.vala"
					nth = _tmp4_;
#line 403 "AppRow.c"
				}
#line 82 "../src/Widgets/AppRow.vala"
				_tmp2_ = FALSE;
#line 82 "../src/Widgets/AppRow.vala"
				_tmp5_ = nth;
#line 82 "../src/Widgets/AppRow.vala"
				if (!(_tmp5_ != NULL)) {
#line 82 "../src/Widgets/AppRow.vala"
					break;
#line 413 "AppRow.c"
				}
#line 83 "../src/Widgets/AppRow.vala"
				_tmp6_ = nth;
#line 83 "../src/Widgets/AppRow.vala"
				_tmp7_ = _tmp6_->data;
#line 83 "../src/Widgets/AppRow.vala"
				_tmp8_ = signon_security_context_get_system_context ((SignonSecurityContext*) _tmp7_);
#line 83 "../src/Widgets/AppRow.vala"
				_tmp9_ = path;
#line 83 "../src/Widgets/AppRow.vala"
				if (g_strcmp0 (_tmp8_, _tmp9_) == 0) {
#line 425 "AppRow.c"
					GtkCheckButton* _tmp10_;
#line 84 "../src/Widgets/AppRow.vala"
					_tmp10_ = self->priv->app_switch;
#line 84 "../src/Widgets/AppRow.vala"
					gtk_toggle_button_set_active ((GtkToggleButton*) _tmp10_, TRUE);
#line 85 "../src/Widgets/AppRow.vala"
					_g_free0 (path);
#line 85 "../src/Widgets/AppRow.vala"
					return;
#line 435 "AppRow.c"
				}
			}
		}
	}
#line 89 "../src/Widgets/AppRow.vala"
	_tmp11_ = self->priv->app_switch;
#line 89 "../src/Widgets/AppRow.vala"
	gtk_toggle_button_set_active ((GtkToggleButton*) _tmp11_, FALSE);
#line 80 "../src/Widgets/AppRow.vala"
	_g_free0 (path);
#line 446 "AppRow.c"
}

static void
app_row_allow_app_data_free (gpointer _data)
{
	AppRowAllowAppData* _data_;
	_data_ = _data;
#line 22 "../src/Widgets/AppRow.vala"
	_g_object_unref0 (_data_->self);
#line 22 "../src/Widgets/AppRow.vala"
	g_slice_free (AppRowAllowAppData, _data_);
#line 458 "AppRow.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 22 "../src/Widgets/AppRow.vala"
	return self ? g_object_ref (self) : NULL;
#line 466 "AppRow.c"
}

void
app_row_allow_app (AppRow* self,
                   GAsyncReadyCallback _callback_,
                   gpointer _user_data_)
{
	AppRowAllowAppData* _data_;
	AppRow* _tmp0_;
#line 22 "../src/Widgets/AppRow.vala"
	_data_ = g_slice_new0 (AppRowAllowAppData);
#line 22 "../src/Widgets/AppRow.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 22 "../src/Widgets/AppRow.vala"
	g_task_set_task_data (_data_->_async_result, _data_, app_row_allow_app_data_free);
#line 22 "../src/Widgets/AppRow.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 22 "../src/Widgets/AppRow.vala"
	_data_->self = _tmp0_;
#line 22 "../src/Widgets/AppRow.vala"
	app_row_allow_app_co (_data_);
#line 488 "AppRow.c"
}

void
app_row_allow_app_finish (AppRow* self,
                          GAsyncResult* _res_)
{
	AppRowAllowAppData* _data_;
#line 22 "../src/Widgets/AppRow.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
#line 498 "AppRow.c"
}

static void
app_row_allow_app_ready (GObject* source_object,
                         GAsyncResult* _res_,
                         gpointer _user_data_)
{
	AppRowAllowAppData* _data_;
#line 95 "../src/Widgets/AppRow.vala"
	_data_ = _user_data_;
#line 95 "../src/Widgets/AppRow.vala"
	_data_->_source_object_ = source_object;
#line 95 "../src/Widgets/AppRow.vala"
	_data_->_res_ = _res_;
#line 95 "../src/Widgets/AppRow.vala"
	app_row_allow_app_co (_data_);
#line 515 "AppRow.c"
}

static void
_vala_SignonIdentityInfo_free (SignonIdentityInfo* self)
{
#line 97 "../src/Widgets/AppRow.vala"
	g_boxed_free (signon_identity_info_get_type (), self);
#line 523 "AppRow.c"
}

static gboolean
app_row_allow_app_co (AppRowAllowAppData* _data_)
{
#line 92 "../src/Widgets/AppRow.vala"
	switch (_data_->_state_) {
#line 92 "../src/Widgets/AppRow.vala"
		case 0:
#line 533 "AppRow.c"
		goto _state_0;
#line 92 "../src/Widgets/AppRow.vala"
		case 1:
#line 537 "AppRow.c"
		goto _state_1;
#line 92 "../src/Widgets/AppRow.vala"
		case 2:
#line 541 "AppRow.c"
		goto _state_2;
#line 92 "../src/Widgets/AppRow.vala"
		case 3:
#line 545 "AppRow.c"
		goto _state_3;
		default:
#line 92 "../src/Widgets/AppRow.vala"
		g_assert_not_reached ();
#line 550 "AppRow.c"
	}
	_state_0:
	{
#line 94 "../src/Widgets/AppRow.vala"
		_data_->_tmp0_ = _data_->self->priv->_account;
#line 94 "../src/Widgets/AppRow.vala"
		_data_->_tmp1_ = _data_->self->priv->_service;
#line 94 "../src/Widgets/AppRow.vala"
		ag_account_select_service (_data_->_tmp0_, _data_->_tmp1_);
#line 95 "../src/Widgets/AppRow.vala"
		_data_->_tmp2_ = _data_->self->priv->_identity;
#line 95 "../src/Widgets/AppRow.vala"
		_data_->_state_ = 1;
#line 95 "../src/Widgets/AppRow.vala"
		signon_identity_query_info (_data_->_tmp2_, NULL, app_row_allow_app_ready, _data_);
#line 95 "../src/Widgets/AppRow.vala"
		return FALSE;
#line 568 "AppRow.c"
		_state_1:
#line 95 "../src/Widgets/AppRow.vala"
		_data_->_tmp3_ = signon_identity_query_info_finish (_data_->_tmp2_, _data_->_res_, &_data_->_inner_error0_);
#line 95 "../src/Widgets/AppRow.vala"
		_data_->info = _data_->_tmp3_;
#line 95 "../src/Widgets/AppRow.vala"
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 576 "AppRow.c"
			goto __catch10_g_error;
		}
#line 96 "../src/Widgets/AppRow.vala"
		_data_->_tmp4_ = _data_->info;
#line 96 "../src/Widgets/AppRow.vala"
		_data_->_tmp5_ = app_row_get_app_path (_data_->self);
#line 96 "../src/Widgets/AppRow.vala"
		_data_->_tmp6_ = _data_->_tmp5_;
#line 96 "../src/Widgets/AppRow.vala"
		signon_identity_info_add_access_control (_data_->_tmp4_, _data_->_tmp6_, "*");
#line 96 "../src/Widgets/AppRow.vala"
		_g_free0 (_data_->_tmp6_);
#line 97 "../src/Widgets/AppRow.vala"
		_data_->_tmp7_ = _data_->self->priv->_identity;
#line 97 "../src/Widgets/AppRow.vala"
		_data_->_tmp8_ = _data_->info;
#line 97 "../src/Widgets/AppRow.vala"
		_data_->_state_ = 2;
#line 97 "../src/Widgets/AppRow.vala"
		signon_identity_store_info (_data_->_tmp7_, _data_->_tmp8_, NULL, app_row_allow_app_ready, _data_);
#line 97 "../src/Widgets/AppRow.vala"
		return FALSE;
#line 599 "AppRow.c"
		_state_2:
#line 97 "../src/Widgets/AppRow.vala"
		signon_identity_store_info_finish (_data_->_tmp7_, _data_->_res_, &_data_->_inner_error0_);
#line 97 "../src/Widgets/AppRow.vala"
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 97 "../src/Widgets/AppRow.vala"
			__vala_SignonIdentityInfo_free0 (_data_->info);
#line 607 "AppRow.c"
			goto __catch10_g_error;
		}
#line 98 "../src/Widgets/AppRow.vala"
		_data_->_tmp9_ = _data_->self->priv->app_switch;
#line 98 "../src/Widgets/AppRow.vala"
		gtk_toggle_button_set_active ((GtkToggleButton*) _data_->_tmp9_, TRUE);
#line 99 "../src/Widgets/AppRow.vala"
		_data_->_tmp10_ = _data_->self->priv->_account;
#line 99 "../src/Widgets/AppRow.vala"
		ag_account_select_service (_data_->_tmp10_, NULL);
#line 100 "../src/Widgets/AppRow.vala"
		_data_->_tmp11_ = _data_->self->priv->_account;
#line 100 "../src/Widgets/AppRow.vala"
		_data_->_state_ = 3;
#line 100 "../src/Widgets/AppRow.vala"
		ag_account_store_async (_data_->_tmp11_, NULL, app_row_allow_app_ready, _data_);
#line 100 "../src/Widgets/AppRow.vala"
		return FALSE;
#line 626 "AppRow.c"
		_state_3:
#line 100 "../src/Widgets/AppRow.vala"
		ag_account_store_finish (_data_->_tmp11_, _data_->_res_, &_data_->_inner_error0_);
#line 100 "../src/Widgets/AppRow.vala"
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 100 "../src/Widgets/AppRow.vala"
			__vala_SignonIdentityInfo_free0 (_data_->info);
#line 634 "AppRow.c"
			goto __catch10_g_error;
		}
#line 93 "../src/Widgets/AppRow.vala"
		__vala_SignonIdentityInfo_free0 (_data_->info);
#line 639 "AppRow.c"
	}
	goto __finally10;
	__catch10_g_error:
	{
#line 93 "../src/Widgets/AppRow.vala"
		_data_->e = _data_->_inner_error0_;
#line 93 "../src/Widgets/AppRow.vala"
		_data_->_inner_error0_ = NULL;
#line 102 "../src/Widgets/AppRow.vala"
		_data_->_tmp12_ = _data_->e;
#line 102 "../src/Widgets/AppRow.vala"
		_data_->_tmp13_ = _data_->_tmp12_->message;
#line 102 "../src/Widgets/AppRow.vala"
		g_critical ("AppRow.vala:102: %s", _data_->_tmp13_);
#line 103 "../src/Widgets/AppRow.vala"
		_data_->_tmp14_ = _data_->self->priv->_account;
#line 103 "../src/Widgets/AppRow.vala"
		ag_account_select_service (_data_->_tmp14_, NULL);
#line 93 "../src/Widgets/AppRow.vala"
		_g_error_free0 (_data_->e);
#line 660 "AppRow.c"
	}
	__finally10:
#line 93 "../src/Widgets/AppRow.vala"
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 93 "../src/Widgets/AppRow.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
#line 93 "../src/Widgets/AppRow.vala"
		g_clear_error (&_data_->_inner_error0_);
#line 93 "../src/Widgets/AppRow.vala"
		g_object_unref (_data_->_async_result);
#line 93 "../src/Widgets/AppRow.vala"
		return FALSE;
#line 673 "AppRow.c"
	}
#line 92 "../src/Widgets/AppRow.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 92 "../src/Widgets/AppRow.vala"
	if (_data_->_state_ != 0) {
#line 92 "../src/Widgets/AppRow.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 92 "../src/Widgets/AppRow.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 683 "AppRow.c"
		}
	}
#line 92 "../src/Widgets/AppRow.vala"
	g_object_unref (_data_->_async_result);
#line 92 "../src/Widgets/AppRow.vala"
	return FALSE;
#line 690 "AppRow.c"
}

static void
app_row_deny_app_data_free (gpointer _data)
{
	AppRowDenyAppData* _data_;
	_data_ = _data;
#line 22 "../src/Widgets/AppRow.vala"
	_g_object_unref0 (_data_->self);
#line 22 "../src/Widgets/AppRow.vala"
	g_slice_free (AppRowDenyAppData, _data_);
#line 702 "AppRow.c"
}

void
app_row_deny_app (AppRow* self,
                  GAsyncReadyCallback _callback_,
                  gpointer _user_data_)
{
	AppRowDenyAppData* _data_;
	AppRow* _tmp0_;
#line 22 "../src/Widgets/AppRow.vala"
	_data_ = g_slice_new0 (AppRowDenyAppData);
#line 22 "../src/Widgets/AppRow.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 22 "../src/Widgets/AppRow.vala"
	g_task_set_task_data (_data_->_async_result, _data_, app_row_deny_app_data_free);
#line 22 "../src/Widgets/AppRow.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 22 "../src/Widgets/AppRow.vala"
	_data_->self = _tmp0_;
#line 22 "../src/Widgets/AppRow.vala"
	app_row_deny_app_co (_data_);
#line 724 "AppRow.c"
}

void
app_row_deny_app_finish (AppRow* self,
                         GAsyncResult* _res_)
{
	AppRowDenyAppData* _data_;
#line 22 "../src/Widgets/AppRow.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
#line 734 "AppRow.c"
}

static Block8Data*
block8_data_ref (Block8Data* _data8_)
{
#line 108 "../src/Widgets/AppRow.vala"
	g_atomic_int_inc (&_data8_->_ref_count_);
#line 108 "../src/Widgets/AppRow.vala"
	return _data8_;
#line 744 "AppRow.c"
}

static void
_vala_SignonSecurityContext_free (SignonSecurityContext* self)
{
#line 108 "../src/Widgets/AppRow.vala"
	g_boxed_free (signon_security_context_get_type (), self);
#line 752 "AppRow.c"
}

static void
__vala_SignonSecurityContext_free0_ (gpointer var)
{
#line 108 "../src/Widgets/AppRow.vala"
	(var == NULL) ? NULL : (var = (_vala_SignonSecurityContext_free (var), NULL));
#line 760 "AppRow.c"
}

static inline void
_g_list_free___vala_SignonSecurityContext_free0_ (GList* self)
{
#line 108 "../src/Widgets/AppRow.vala"
	g_list_free_full (self, (GDestroyNotify) __vala_SignonSecurityContext_free0_);
#line 768 "AppRow.c"
}

static void
block8_data_unref (void * _userdata_)
{
	Block8Data* _data8_;
	_data8_ = (Block8Data*) _userdata_;
#line 108 "../src/Widgets/AppRow.vala"
	if (g_atomic_int_dec_and_test (&_data8_->_ref_count_)) {
#line 778 "AppRow.c"
		AppRow* self;
#line 108 "../src/Widgets/AppRow.vala"
		self = _data8_->self;
#line 108 "../src/Widgets/AppRow.vala"
		_g_free0 (_data8_->path);
#line 108 "../src/Widgets/AppRow.vala"
		(_data8_->list == NULL) ? NULL : (_data8_->list = (_g_list_free___vala_SignonSecurityContext_free0_ (_data8_->list), NULL));
#line 108 "../src/Widgets/AppRow.vala"
		_g_object_unref0 (self);
#line 108 "../src/Widgets/AppRow.vala"
		g_slice_free (Block8Data, _data8_);
#line 790 "AppRow.c"
	}
}

static void
app_row_deny_app_ready (GObject* source_object,
                        GAsyncResult* _res_,
                        gpointer _user_data_)
{
	AppRowDenyAppData* _data_;
#line 110 "../src/Widgets/AppRow.vala"
	_data_ = _user_data_;
#line 110 "../src/Widgets/AppRow.vala"
	_data_->_source_object_ = source_object;
#line 110 "../src/Widgets/AppRow.vala"
	_data_->_res_ = _res_;
#line 110 "../src/Widgets/AppRow.vala"
	app_row_deny_app_co (_data_);
#line 808 "AppRow.c"
}

static void
___lambda6_ (Block8Data* _data8_,
             SignonSecurityContext* nth)
{
	AppRow* self;
	const gchar* _tmp0_;
	const gchar* _tmp1_;
#line 113 "../src/Widgets/AppRow.vala"
	self = _data8_->self;
#line 113 "../src/Widgets/AppRow.vala"
	g_return_if_fail (nth != NULL);
#line 114 "../src/Widgets/AppRow.vala"
	_tmp0_ = signon_security_context_get_system_context (nth);
#line 114 "../src/Widgets/AppRow.vala"
	_tmp1_ = _data8_->path;
#line 114 "../src/Widgets/AppRow.vala"
	if (g_strcmp0 (_tmp0_, _tmp1_) == 0) {
#line 115 "../src/Widgets/AppRow.vala"
		_data8_->list = g_list_remove (_data8_->list, nth);
#line 830 "AppRow.c"
	}
}

static void
____lambda6__gfunc (gconstpointer data,
                    gpointer self)
{
#line 113 "../src/Widgets/AppRow.vala"
	___lambda6_ (self, (SignonSecurityContext*) data);
#line 840 "AppRow.c"
}

static gboolean
app_row_deny_app_co (AppRowDenyAppData* _data_)
{
#line 107 "../src/Widgets/AppRow.vala"
	switch (_data_->_state_) {
#line 107 "../src/Widgets/AppRow.vala"
		case 0:
#line 850 "AppRow.c"
		goto _state_0;
#line 107 "../src/Widgets/AppRow.vala"
		case 1:
#line 854 "AppRow.c"
		goto _state_1;
#line 107 "../src/Widgets/AppRow.vala"
		case 2:
#line 858 "AppRow.c"
		goto _state_2;
#line 107 "../src/Widgets/AppRow.vala"
		case 3:
#line 862 "AppRow.c"
		goto _state_3;
		default:
#line 107 "../src/Widgets/AppRow.vala"
		g_assert_not_reached ();
#line 867 "AppRow.c"
	}
	_state_0:
	{
#line 108 "../src/Widgets/AppRow.vala"
		_data_->_data8_ = g_slice_new0 (Block8Data);
#line 108 "../src/Widgets/AppRow.vala"
		_data_->_data8_->_ref_count_ = 1;
#line 108 "../src/Widgets/AppRow.vala"
		_data_->_data8_->self = g_object_ref (_data_->self);
#line 109 "../src/Widgets/AppRow.vala"
		_data_->_tmp0_ = _data_->self->priv->_account;
#line 109 "../src/Widgets/AppRow.vala"
		_data_->_tmp1_ = _data_->self->priv->_service;
#line 109 "../src/Widgets/AppRow.vala"
		ag_account_select_service (_data_->_tmp0_, _data_->_tmp1_);
#line 110 "../src/Widgets/AppRow.vala"
		_data_->_tmp2_ = _data_->self->priv->_identity;
#line 110 "../src/Widgets/AppRow.vala"
		_data_->_state_ = 1;
#line 110 "../src/Widgets/AppRow.vala"
		signon_identity_query_info (_data_->_tmp2_, NULL, app_row_deny_app_ready, _data_);
#line 110 "../src/Widgets/AppRow.vala"
		return FALSE;
#line 891 "AppRow.c"
		_state_1:
#line 110 "../src/Widgets/AppRow.vala"
		_data_->_tmp3_ = signon_identity_query_info_finish (_data_->_tmp2_, _data_->_res_, &_data_->_inner_error0_);
#line 110 "../src/Widgets/AppRow.vala"
		_data_->info = _data_->_tmp3_;
#line 110 "../src/Widgets/AppRow.vala"
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 110 "../src/Widgets/AppRow.vala"
			block8_data_unref (_data_->_data8_);
#line 110 "../src/Widgets/AppRow.vala"
			_data_->_data8_ = NULL;
#line 903 "AppRow.c"
			goto __catch11_g_error;
		}
#line 111 "../src/Widgets/AppRow.vala"
		_data_->_tmp4_ = _data_->info;
#line 111 "../src/Widgets/AppRow.vala"
		_data_->_tmp5_ = signon_identity_info_get_access_control_list (_data_->_tmp4_);
#line 111 "../src/Widgets/AppRow.vala"
		_data_->_data8_->list = _data_->_tmp5_;
#line 112 "../src/Widgets/AppRow.vala"
		_data_->_tmp6_ = app_row_get_app_path (_data_->self);
#line 112 "../src/Widgets/AppRow.vala"
		_data_->_data8_->path = _data_->_tmp6_;
#line 113 "../src/Widgets/AppRow.vala"
		_data_->_tmp7_ = _data_->_data8_->list;
#line 113 "../src/Widgets/AppRow.vala"
		g_list_foreach (_data_->_tmp7_, ____lambda6__gfunc, _data_->_data8_);
#line 119 "../src/Widgets/AppRow.vala"
		_data_->_tmp8_ = _data_->info;
#line 119 "../src/Widgets/AppRow.vala"
		_data_->_tmp9_ = _data_->_data8_->list;
#line 119 "../src/Widgets/AppRow.vala"
		signon_identity_info_set_access_control_list (_data_->_tmp8_, _data_->_tmp9_);
#line 120 "../src/Widgets/AppRow.vala"
		_data_->_tmp10_ = _data_->self->priv->_identity;
#line 120 "../src/Widgets/AppRow.vala"
		_data_->_tmp11_ = _data_->info;
#line 120 "../src/Widgets/AppRow.vala"
		_data_->_state_ = 2;
#line 120 "../src/Widgets/AppRow.vala"
		signon_identity_store_info (_data_->_tmp10_, _data_->_tmp11_, NULL, app_row_deny_app_ready, _data_);
#line 120 "../src/Widgets/AppRow.vala"
		return FALSE;
#line 936 "AppRow.c"
		_state_2:
#line 120 "../src/Widgets/AppRow.vala"
		signon_identity_store_info_finish (_data_->_tmp10_, _data_->_res_, &_data_->_inner_error0_);
#line 120 "../src/Widgets/AppRow.vala"
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 120 "../src/Widgets/AppRow.vala"
			__vala_SignonIdentityInfo_free0 (_data_->info);
#line 120 "../src/Widgets/AppRow.vala"
			block8_data_unref (_data_->_data8_);
#line 120 "../src/Widgets/AppRow.vala"
			_data_->_data8_ = NULL;
#line 948 "AppRow.c"
			goto __catch11_g_error;
		}
#line 121 "../src/Widgets/AppRow.vala"
		_data_->_tmp12_ = _data_->self->priv->app_switch;
#line 121 "../src/Widgets/AppRow.vala"
		gtk_toggle_button_set_active ((GtkToggleButton*) _data_->_tmp12_, FALSE);
#line 122 "../src/Widgets/AppRow.vala"
		_data_->_tmp13_ = _data_->self->priv->_account;
#line 122 "../src/Widgets/AppRow.vala"
		ag_account_select_service (_data_->_tmp13_, NULL);
#line 123 "../src/Widgets/AppRow.vala"
		_data_->_tmp14_ = _data_->self->priv->_account;
#line 123 "../src/Widgets/AppRow.vala"
		_data_->_state_ = 3;
#line 123 "../src/Widgets/AppRow.vala"
		ag_account_store_async (_data_->_tmp14_, NULL, app_row_deny_app_ready, _data_);
#line 123 "../src/Widgets/AppRow.vala"
		return FALSE;
#line 967 "AppRow.c"
		_state_3:
#line 123 "../src/Widgets/AppRow.vala"
		ag_account_store_finish (_data_->_tmp14_, _data_->_res_, &_data_->_inner_error0_);
#line 123 "../src/Widgets/AppRow.vala"
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 123 "../src/Widgets/AppRow.vala"
			__vala_SignonIdentityInfo_free0 (_data_->info);
#line 123 "../src/Widgets/AppRow.vala"
			block8_data_unref (_data_->_data8_);
#line 123 "../src/Widgets/AppRow.vala"
			_data_->_data8_ = NULL;
#line 979 "AppRow.c"
			goto __catch11_g_error;
		}
#line 108 "../src/Widgets/AppRow.vala"
		__vala_SignonIdentityInfo_free0 (_data_->info);
#line 108 "../src/Widgets/AppRow.vala"
		block8_data_unref (_data_->_data8_);
#line 108 "../src/Widgets/AppRow.vala"
		_data_->_data8_ = NULL;
#line 988 "AppRow.c"
	}
	goto __finally11;
	__catch11_g_error:
	{
#line 108 "../src/Widgets/AppRow.vala"
		_data_->e = _data_->_inner_error0_;
#line 108 "../src/Widgets/AppRow.vala"
		_data_->_inner_error0_ = NULL;
#line 125 "../src/Widgets/AppRow.vala"
		_data_->_tmp15_ = _data_->e;
#line 125 "../src/Widgets/AppRow.vala"
		_data_->_tmp16_ = _data_->_tmp15_->message;
#line 125 "../src/Widgets/AppRow.vala"
		g_critical ("AppRow.vala:125: %s", _data_->_tmp16_);
#line 126 "../src/Widgets/AppRow.vala"
		_data_->_tmp17_ = _data_->self->priv->_account;
#line 126 "../src/Widgets/AppRow.vala"
		ag_account_select_service (_data_->_tmp17_, NULL);
#line 108 "../src/Widgets/AppRow.vala"
		_g_error_free0 (_data_->e);
#line 1009 "AppRow.c"
	}
	__finally11:
#line 108 "../src/Widgets/AppRow.vala"
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 108 "../src/Widgets/AppRow.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
#line 108 "../src/Widgets/AppRow.vala"
		g_clear_error (&_data_->_inner_error0_);
#line 108 "../src/Widgets/AppRow.vala"
		g_object_unref (_data_->_async_result);
#line 108 "../src/Widgets/AppRow.vala"
		return FALSE;
#line 1022 "AppRow.c"
	}
#line 107 "../src/Widgets/AppRow.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 107 "../src/Widgets/AppRow.vala"
	if (_data_->_state_ != 0) {
#line 107 "../src/Widgets/AppRow.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 107 "../src/Widgets/AppRow.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 1032 "AppRow.c"
		}
	}
#line 107 "../src/Widgets/AppRow.vala"
	g_object_unref (_data_->_async_result);
#line 107 "../src/Widgets/AppRow.vala"
	return FALSE;
#line 1039 "AppRow.c"
}

AgAccount*
app_row_get_account (AppRow* self)
{
	AgAccount* result;
	AgAccount* _tmp0_;
#line 23 "../src/Widgets/AppRow.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 23 "../src/Widgets/AppRow.vala"
	_tmp0_ = self->priv->_account;
#line 23 "../src/Widgets/AppRow.vala"
	result = _tmp0_;
#line 23 "../src/Widgets/AppRow.vala"
	return result;
#line 1055 "AppRow.c"
}

static void
app_row_set_account (AppRow* self,
                     AgAccount* value)
{
#line 23 "../src/Widgets/AppRow.vala"
	g_return_if_fail (self != NULL);
#line 23 "../src/Widgets/AppRow.vala"
	if (app_row_get_account (self) != value) {
#line 1066 "AppRow.c"
		AgAccount* _tmp0_;
#line 23 "../src/Widgets/AppRow.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 23 "../src/Widgets/AppRow.vala"
		_g_object_unref0 (self->priv->_account);
#line 23 "../src/Widgets/AppRow.vala"
		self->priv->_account = _tmp0_;
#line 23 "../src/Widgets/AppRow.vala"
		g_object_notify_by_pspec ((GObject *) self, app_row_properties[APP_ROW_ACCOUNT_PROPERTY]);
#line 1076 "AppRow.c"
	}
}

AgApplication*
app_row_get_app (AppRow* self)
{
	AgApplication* result;
	AgApplication* _tmp0_;
#line 24 "../src/Widgets/AppRow.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 24 "../src/Widgets/AppRow.vala"
	_tmp0_ = self->priv->_app;
#line 24 "../src/Widgets/AppRow.vala"
	result = _tmp0_;
#line 24 "../src/Widgets/AppRow.vala"
	return result;
#line 1093 "AppRow.c"
}

static AgApplication*
_vala_AgApplication_copy (AgApplication* self)
{
#line 24 "../src/Widgets/AppRow.vala"
	return g_boxed_copy (ag_application_get_type (), self);
#line 1101 "AppRow.c"
}

static gpointer
__vala_AgApplication_copy0 (gpointer self)
{
#line 24 "../src/Widgets/AppRow.vala"
	return self ? _vala_AgApplication_copy (self) : NULL;
#line 1109 "AppRow.c"
}

static void
app_row_set_app (AppRow* self,
                 AgApplication* value)
{
#line 24 "../src/Widgets/AppRow.vala"
	g_return_if_fail (self != NULL);
#line 24 "../src/Widgets/AppRow.vala"
	if (app_row_get_app (self) != value) {
#line 1120 "AppRow.c"
		AgApplication* _tmp0_;
#line 24 "../src/Widgets/AppRow.vala"
		_tmp0_ = __vala_AgApplication_copy0 (value);
#line 24 "../src/Widgets/AppRow.vala"
		__vala_AgApplication_free0 (self->priv->_app);
#line 24 "../src/Widgets/AppRow.vala"
		self->priv->_app = _tmp0_;
#line 24 "../src/Widgets/AppRow.vala"
		g_object_notify_by_pspec ((GObject *) self, app_row_properties[APP_ROW_APP_PROPERTY]);
#line 1130 "AppRow.c"
	}
}

AgService*
app_row_get_service (AppRow* self)
{
	AgService* result;
	AgService* _tmp0_;
#line 25 "../src/Widgets/AppRow.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 25 "../src/Widgets/AppRow.vala"
	_tmp0_ = self->priv->_service;
#line 25 "../src/Widgets/AppRow.vala"
	result = _tmp0_;
#line 25 "../src/Widgets/AppRow.vala"
	return result;
#line 1147 "AppRow.c"
}

static AgService*
_vala_AgService_copy (AgService* self)
{
#line 25 "../src/Widgets/AppRow.vala"
	return g_boxed_copy (ag_service_get_type (), self);
#line 1155 "AppRow.c"
}

static gpointer
__vala_AgService_copy0 (gpointer self)
{
#line 25 "../src/Widgets/AppRow.vala"
	return self ? _vala_AgService_copy (self) : NULL;
#line 1163 "AppRow.c"
}

static void
app_row_set_service (AppRow* self,
                     AgService* value)
{
#line 25 "../src/Widgets/AppRow.vala"
	g_return_if_fail (self != NULL);
#line 25 "../src/Widgets/AppRow.vala"
	if (app_row_get_service (self) != value) {
#line 1174 "AppRow.c"
		AgService* _tmp0_;
#line 25 "../src/Widgets/AppRow.vala"
		_tmp0_ = __vala_AgService_copy0 (value);
#line 25 "../src/Widgets/AppRow.vala"
		__vala_AgService_free0 (self->priv->_service);
#line 25 "../src/Widgets/AppRow.vala"
		self->priv->_service = _tmp0_;
#line 25 "../src/Widgets/AppRow.vala"
		g_object_notify_by_pspec ((GObject *) self, app_row_properties[APP_ROW_SERVICE_PROPERTY]);
#line 1184 "AppRow.c"
	}
}

SignonIdentity*
app_row_get_identity (AppRow* self)
{
	SignonIdentity* result;
	SignonIdentity* _tmp0_;
#line 26 "../src/Widgets/AppRow.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 26 "../src/Widgets/AppRow.vala"
	_tmp0_ = self->priv->_identity;
#line 26 "../src/Widgets/AppRow.vala"
	result = _tmp0_;
#line 26 "../src/Widgets/AppRow.vala"
	return result;
#line 1201 "AppRow.c"
}

static void
app_row_set_identity (AppRow* self,
                      SignonIdentity* value)
{
#line 26 "../src/Widgets/AppRow.vala"
	g_return_if_fail (self != NULL);
#line 26 "../src/Widgets/AppRow.vala"
	if (app_row_get_identity (self) != value) {
#line 1212 "AppRow.c"
		SignonIdentity* _tmp0_;
#line 26 "../src/Widgets/AppRow.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 26 "../src/Widgets/AppRow.vala"
		_g_object_unref0 (self->priv->_identity);
#line 26 "../src/Widgets/AppRow.vala"
		self->priv->_identity = _tmp0_;
#line 26 "../src/Widgets/AppRow.vala"
		g_object_notify_by_pspec ((GObject *) self, app_row_properties[APP_ROW_IDENTITY_PROPERTY]);
#line 1222 "AppRow.c"
	}
}

static void
_app_row___lambda7_ (AppRow* self)
{
	GtkCheckButton* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
#line 62 "../src/Widgets/AppRow.vala"
	_tmp0_ = self->priv->app_switch;
#line 62 "../src/Widgets/AppRow.vala"
	_tmp1_ = gtk_toggle_button_get_active ((GtkToggleButton*) _tmp0_);
#line 62 "../src/Widgets/AppRow.vala"
	_tmp2_ = _tmp1_;
#line 62 "../src/Widgets/AppRow.vala"
	if (_tmp2_) {
#line 63 "../src/Widgets/AppRow.vala"
		app_row_allow_app (self, NULL, NULL);
#line 1242 "AppRow.c"
	} else {
#line 65 "../src/Widgets/AppRow.vala"
		app_row_deny_app (self, NULL, NULL);
#line 1246 "AppRow.c"
	}
}

static void
__app_row___lambda7__gtk_button_activate (GtkButton* _sender,
                                          gpointer self)
{
#line 61 "../src/Widgets/AppRow.vala"
	_app_row___lambda7_ ((AppRow*) self);
#line 1256 "AppRow.c"
}

static GObject *
app_row_constructor (GType type,
                     guint n_construct_properties,
                     GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	AppRow * self;
	GDesktopAppInfo* app_info = NULL;
	AgApplication* _tmp0_;
	GDesktopAppInfo* _tmp1_;
	GtkImage* app_image = NULL;
	GtkImage* _tmp2_;
	GtkImage* _tmp3_;
	GtkImage* _tmp4_;
	GDesktopAppInfo* _tmp5_;
	GIcon* _tmp6_;
	GtkLabel* app_name = NULL;
	GDesktopAppInfo* _tmp7_;
	const gchar* _tmp8_;
	GtkLabel* _tmp9_;
	GtkCheckButton* _tmp10_;
	GtkGrid* grid = NULL;
	GtkGrid* _tmp11_;
	GtkGrid* _tmp12_;
	GtkGrid* _tmp13_;
	GtkCheckButton* _tmp14_;
	GtkGrid* _tmp15_;
	GtkImage* _tmp16_;
	GtkGrid* _tmp17_;
	GtkLabel* _tmp18_;
	GtkGrid* _tmp19_;
	GtkCheckButton* _tmp20_;
#line 39 "../src/Widgets/AppRow.vala"
	parent_class = G_OBJECT_CLASS (app_row_parent_class);
#line 39 "../src/Widgets/AppRow.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 39 "../src/Widgets/AppRow.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_APP_ROW, AppRow);
#line 40 "../src/Widgets/AppRow.vala"
	_tmp0_ = self->priv->_app;
#line 40 "../src/Widgets/AppRow.vala"
	_tmp1_ = ag_application_get_desktop_app_info (_tmp0_);
#line 40 "../src/Widgets/AppRow.vala"
	app_info = _tmp1_;
#line 42 "../src/Widgets/AppRow.vala"
	_tmp2_ = (GtkImage*) gtk_image_new ();
#line 42 "../src/Widgets/AppRow.vala"
	g_object_ref_sink (_tmp2_);
#line 42 "../src/Widgets/AppRow.vala"
	app_image = _tmp2_;
#line 43 "../src/Widgets/AppRow.vala"
	_tmp3_ = app_image;
#line 43 "../src/Widgets/AppRow.vala"
	g_object_set (_tmp3_, "icon-size", (gint) GTK_ICON_SIZE_DND, NULL);
#line 44 "../src/Widgets/AppRow.vala"
	_tmp4_ = app_image;
#line 44 "../src/Widgets/AppRow.vala"
	_tmp5_ = app_info;
#line 44 "../src/Widgets/AppRow.vala"
	_tmp6_ = g_app_info_get_icon ((GAppInfo*) _tmp5_);
#line 44 "../src/Widgets/AppRow.vala"
	g_object_set (_tmp4_, "gicon", _tmp6_, NULL);
#line 46 "../src/Widgets/AppRow.vala"
	_tmp7_ = app_info;
#line 46 "../src/Widgets/AppRow.vala"
	_tmp8_ = g_app_info_get_display_name ((GAppInfo*) _tmp7_);
#line 46 "../src/Widgets/AppRow.vala"
	_tmp9_ = (GtkLabel*) gtk_label_new (_tmp8_);
#line 46 "../src/Widgets/AppRow.vala"
	g_object_ref_sink (_tmp9_);
#line 46 "../src/Widgets/AppRow.vala"
	app_name = _tmp9_;
#line 48 "../src/Widgets/AppRow.vala"
	_tmp10_ = (GtkCheckButton*) gtk_check_button_new ();
#line 48 "../src/Widgets/AppRow.vala"
	g_object_ref_sink (_tmp10_);
#line 48 "../src/Widgets/AppRow.vala"
	_g_object_unref0 (self->priv->app_switch);
#line 48 "../src/Widgets/AppRow.vala"
	self->priv->app_switch = _tmp10_;
#line 50 "../src/Widgets/AppRow.vala"
	_tmp11_ = (GtkGrid*) gtk_grid_new ();
#line 50 "../src/Widgets/AppRow.vala"
	g_object_ref_sink (_tmp11_);
#line 50 "../src/Widgets/AppRow.vala"
	grid = _tmp11_;
#line 51 "../src/Widgets/AppRow.vala"
	_tmp12_ = grid;
#line 51 "../src/Widgets/AppRow.vala"
	gtk_grid_set_column_spacing (_tmp12_, 6);
#line 52 "../src/Widgets/AppRow.vala"
	_tmp13_ = grid;
#line 52 "../src/Widgets/AppRow.vala"
	_tmp14_ = self->priv->app_switch;
#line 52 "../src/Widgets/AppRow.vala"
	gtk_container_add ((GtkContainer*) _tmp13_, (GtkWidget*) _tmp14_);
#line 53 "../src/Widgets/AppRow.vala"
	_tmp15_ = grid;
#line 53 "../src/Widgets/AppRow.vala"
	_tmp16_ = app_image;
#line 53 "../src/Widgets/AppRow.vala"
	gtk_container_add ((GtkContainer*) _tmp15_, (GtkWidget*) _tmp16_);
#line 54 "../src/Widgets/AppRow.vala"
	_tmp17_ = grid;
#line 54 "../src/Widgets/AppRow.vala"
	_tmp18_ = app_name;
#line 54 "../src/Widgets/AppRow.vala"
	gtk_container_add ((GtkContainer*) _tmp17_, (GtkWidget*) _tmp18_);
#line 56 "../src/Widgets/AppRow.vala"
	gtk_list_box_row_set_activatable ((GtkListBoxRow*) self, FALSE);
#line 57 "../src/Widgets/AppRow.vala"
	gtk_list_box_row_set_selectable ((GtkListBoxRow*) self, FALSE);
#line 58 "../src/Widgets/AppRow.vala"
	g_object_set ((GtkWidget*) self, "margin", 6, NULL);
#line 59 "../src/Widgets/AppRow.vala"
	_tmp19_ = grid;
#line 59 "../src/Widgets/AppRow.vala"
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) _tmp19_);
#line 61 "../src/Widgets/AppRow.vala"
	_tmp20_ = self->priv->app_switch;
#line 61 "../src/Widgets/AppRow.vala"
	g_signal_connect_object ((GtkButton*) _tmp20_, "activate", (GCallback) __app_row___lambda7__gtk_button_activate, self, 0);
#line 39 "../src/Widgets/AppRow.vala"
	_g_object_unref0 (grid);
#line 39 "../src/Widgets/AppRow.vala"
	_g_object_unref0 (app_name);
#line 39 "../src/Widgets/AppRow.vala"
	_g_object_unref0 (app_image);
#line 39 "../src/Widgets/AppRow.vala"
	_g_object_unref0 (app_info);
#line 39 "../src/Widgets/AppRow.vala"
	return obj;
#line 1392 "AppRow.c"
}

static void
app_row_class_init (AppRowClass * klass,
                    gpointer klass_data)
{
#line 22 "../src/Widgets/AppRow.vala"
	app_row_parent_class = g_type_class_peek_parent (klass);
#line 22 "../src/Widgets/AppRow.vala"
	g_type_class_adjust_private_offset (klass, &AppRow_private_offset);
#line 22 "../src/Widgets/AppRow.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_app_row_get_property;
#line 22 "../src/Widgets/AppRow.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_app_row_set_property;
#line 22 "../src/Widgets/AppRow.vala"
	G_OBJECT_CLASS (klass)->constructor = app_row_constructor;
#line 22 "../src/Widgets/AppRow.vala"
	G_OBJECT_CLASS (klass)->finalize = app_row_finalize;
#line 22 "../src/Widgets/AppRow.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), APP_ROW_ACCOUNT_PROPERTY, app_row_properties[APP_ROW_ACCOUNT_PROPERTY] = g_param_spec_object ("account", "account", "account", ag_account_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 22 "../src/Widgets/AppRow.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), APP_ROW_APP_PROPERTY, app_row_properties[APP_ROW_APP_PROPERTY] = g_param_spec_boxed ("app", "app", "app", ag_application_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 22 "../src/Widgets/AppRow.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), APP_ROW_SERVICE_PROPERTY, app_row_properties[APP_ROW_SERVICE_PROPERTY] = g_param_spec_boxed ("service", "service", "service", ag_service_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 22 "../src/Widgets/AppRow.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), APP_ROW_IDENTITY_PROPERTY, app_row_properties[APP_ROW_IDENTITY_PROPERTY] = g_param_spec_object ("identity", "identity", "identity", signon_identity_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 1419 "AppRow.c"
}

static void
app_row_instance_init (AppRow * self,
                       gpointer klass)
{
#line 22 "../src/Widgets/AppRow.vala"
	self->priv = app_row_get_instance_private (self);
#line 1428 "AppRow.c"
}

static void
app_row_finalize (GObject * obj)
{
	AppRow * self;
#line 22 "../src/Widgets/AppRow.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_APP_ROW, AppRow);
#line 23 "../src/Widgets/AppRow.vala"
	_g_object_unref0 (self->priv->_account);
#line 24 "../src/Widgets/AppRow.vala"
	__vala_AgApplication_free0 (self->priv->_app);
#line 25 "../src/Widgets/AppRow.vala"
	__vala_AgService_free0 (self->priv->_service);
#line 26 "../src/Widgets/AppRow.vala"
	_g_object_unref0 (self->priv->_identity);
#line 28 "../src/Widgets/AppRow.vala"
	_g_object_unref0 (self->priv->app_switch);
#line 22 "../src/Widgets/AppRow.vala"
	G_OBJECT_CLASS (app_row_parent_class)->finalize (obj);
#line 1449 "AppRow.c"
}

GType
app_row_get_type (void)
{
	static volatile gsize app_row_type_id__volatile = 0;
	if (g_once_init_enter (&app_row_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (AppRowClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) app_row_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (AppRow), 0, (GInstanceInitFunc) app_row_instance_init, NULL };
		GType app_row_type_id;
		app_row_type_id = g_type_register_static (gtk_list_box_row_get_type (), "AppRow", &g_define_type_info, 0);
		AppRow_private_offset = g_type_add_instance_private (app_row_type_id, sizeof (AppRowPrivate));
		g_once_init_leave (&app_row_type_id__volatile, app_row_type_id);
	}
	return app_row_type_id__volatile;
}

static void
_vala_app_row_get_property (GObject * object,
                            guint property_id,
                            GValue * value,
                            GParamSpec * pspec)
{
	AppRow * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_APP_ROW, AppRow);
#line 22 "../src/Widgets/AppRow.vala"
	switch (property_id) {
#line 22 "../src/Widgets/AppRow.vala"
		case APP_ROW_ACCOUNT_PROPERTY:
#line 22 "../src/Widgets/AppRow.vala"
		g_value_set_object (value, app_row_get_account (self));
#line 22 "../src/Widgets/AppRow.vala"
		break;
#line 22 "../src/Widgets/AppRow.vala"
		case APP_ROW_APP_PROPERTY:
#line 22 "../src/Widgets/AppRow.vala"
		g_value_set_boxed (value, app_row_get_app (self));
#line 22 "../src/Widgets/AppRow.vala"
		break;
#line 22 "../src/Widgets/AppRow.vala"
		case APP_ROW_SERVICE_PROPERTY:
#line 22 "../src/Widgets/AppRow.vala"
		g_value_set_boxed (value, app_row_get_service (self));
#line 22 "../src/Widgets/AppRow.vala"
		break;
#line 22 "../src/Widgets/AppRow.vala"
		case APP_ROW_IDENTITY_PROPERTY:
#line 22 "../src/Widgets/AppRow.vala"
		g_value_set_object (value, app_row_get_identity (self));
#line 22 "../src/Widgets/AppRow.vala"
		break;
#line 1500 "AppRow.c"
		default:
#line 22 "../src/Widgets/AppRow.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 22 "../src/Widgets/AppRow.vala"
		break;
#line 1506 "AppRow.c"
	}
}

static void
_vala_app_row_set_property (GObject * object,
                            guint property_id,
                            const GValue * value,
                            GParamSpec * pspec)
{
	AppRow * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_APP_ROW, AppRow);
#line 22 "../src/Widgets/AppRow.vala"
	switch (property_id) {
#line 22 "../src/Widgets/AppRow.vala"
		case APP_ROW_ACCOUNT_PROPERTY:
#line 22 "../src/Widgets/AppRow.vala"
		app_row_set_account (self, g_value_get_object (value));
#line 22 "../src/Widgets/AppRow.vala"
		break;
#line 22 "../src/Widgets/AppRow.vala"
		case APP_ROW_APP_PROPERTY:
#line 22 "../src/Widgets/AppRow.vala"
		app_row_set_app (self, g_value_get_boxed (value));
#line 22 "../src/Widgets/AppRow.vala"
		break;
#line 22 "../src/Widgets/AppRow.vala"
		case APP_ROW_SERVICE_PROPERTY:
#line 22 "../src/Widgets/AppRow.vala"
		app_row_set_service (self, g_value_get_boxed (value));
#line 22 "../src/Widgets/AppRow.vala"
		break;
#line 22 "../src/Widgets/AppRow.vala"
		case APP_ROW_IDENTITY_PROPERTY:
#line 22 "../src/Widgets/AppRow.vala"
		app_row_set_identity (self, g_value_get_object (value));
#line 22 "../src/Widgets/AppRow.vala"
		break;
#line 1544 "AppRow.c"
		default:
#line 22 "../src/Widgets/AppRow.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 22 "../src/Widgets/AppRow.vala"
		break;
#line 1550 "AppRow.c"
	}
}

